/**
 *
 */
package nc.impl.fip.operatinglog;

import java.io.Serializable;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Properties;
import java.util.Set;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.FutureTask;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;

import nc.bs.businessevent.BusinessEvent;
import nc.bs.businessevent.EventDispatcher;
import nc.bs.businessevent.IEventType;
import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.fip.tools.FipBaseDao;
import nc.bs.framework.common.IAttributeManager;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.framework.component.RemoteProcessComponetFactory;
import nc.bs.framework.distribute.environment.DistEnvFactory;
import nc.bs.framework.distribute.environment.IDistributedEnv;
import nc.bs.framework.distribute.environment.IpAndPort;
import nc.bs.framework.distribute.environment.IpAndPortUtils;
import nc.bs.framework.distribute.environment.SystemInfo;
import nc.bs.framework.execute.Executor;
import nc.bs.framework.server.LiveServerAgent;
import nc.bs.framework.server.ServerConfiguration;
import nc.bs.framework.server.ServerInstance;
import nc.bs.logging.Logger;
import nc.bs.uap.lock.PKLock;
import nc.impl.fip.generate.FipGenerateProxy;
import nc.impl.fip.messagelogs.FipMessageLogsProxy;
import nc.impl.fip.pub.tools.TempTableTool;
import nc.impl.fip.relation.FipRelationBO;
import nc.impl.fip.service.pub.FipMessageBO;
import nc.impl.fip.sumrelation.FipSumRelationBO;
import nc.impl.fip.sumrelation.FipSumRelationProxy;
import nc.itf.fip.FipRedisKeyConst;
import nc.itf.fip.ITXMessageDataService;
import nc.itf.fip.TXMsgDataUtil;
import nc.itf.fip.cache.memcache.FipConfigCache;
import nc.itf.fip.opreatinglog.IOperatingLog;
import nc.itf.fip.pub.FipInterfaceCenter;
import nc.itf.fip.sumrelation.IFipSumRelation;
import nc.itf.fip.trans.BOTranslateCenter;
import nc.itf.gl.voucher.IVoucher;
import nc.jdbc.framework.DataSourceCenter;
import nc.jdbc.framework.JdbcSession;
import nc.jdbc.framework.PersistenceManager;
import nc.jdbc.framework.SQLParameter;
import nc.jdbc.framework.crossdb.CrossDBConnection;
import nc.jdbc.framework.exception.DbException;
import nc.jdbc.framework.processor.ResultSetProcessor;
import nc.pub.fip.cache.FipBillRegisterCache;
import nc.pub.fip.pubtools.FipBSCacheCleaner;
import nc.pub.fip.pubtools.FipSceneUtil;
import nc.pub.fip.pubtools.SagasUtil;
import nc.pubitf.fip.external.IBillDrawService;
import nc.pubitf.fip.external.IBillReflectorExService;
import nc.pubitf.fip.external.IBillReflectorService;
import nc.pubitf.fip.external.IBillSumService;
import nc.pubitf.fip.external.IDesBillService;
import nc.pubitf.fip.external.IDesBillSumService;
import nc.pubitf.fip.service.IFipInterfaceCenterService;
import nc.pubitf.fip.service.IFipMsgCallbackProcessService;
import nc.pubitf.fip.service.IFipQueryService;
import nc.pubitf.fip.task.ServerDistributeCenter;
import nc.pubitf.ra.respvoucher.IFipDeleteCheck;
import nc.vo.bd.meta.BatchOperateVO;
import nc.vo.fip.billregister.BillRegisterVO;
import nc.vo.fip.config.ConfigVO;
import nc.vo.fip.external.FipBillSumRSVO;
import nc.vo.fip.external.FipExtendAggVO;
import nc.vo.fip.external.FipSaveResultVO;
import nc.vo.fip.messagelogs.MessageLogVO;
import nc.vo.fip.messagelogs.MessageTool;
import nc.vo.fip.operatinglogs.GenerateDestSceneEnum;
import nc.vo.fip.operatinglogs.OperatingFlagEmu;
import nc.vo.fip.operatinglogs.OperatingLogVO;
import nc.vo.fip.operatinglogs.OperatinglogSceneEnum;
import nc.vo.fip.pub.DestWFWParamsVO;
import nc.vo.fip.pub.FipBaseDataProxy;
import nc.vo.fip.pub.FipBillState;
import nc.vo.fip.pub.SqlTools;
import nc.vo.fip.relation.FipRelationVO;
import nc.vo.fip.service.FipBaseMessageVO;
import nc.vo.fip.service.FipBasicRelationVO;
import nc.vo.fip.service.FipExtRelationVO;
import nc.vo.fip.service.FipMessageVO;
import nc.vo.fip.service.FipRelationInfoVO;
import nc.vo.fip.sumrelation.SumRelationVO;
import nc.vo.fip.trans.FipTransVO;
import nc.vo.fip.trans.FipTranslateResultVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.billtype.BilltypeVO;
import nc.vo.pub.lang.UFBoolean;

import org.apache.commons.lang3.StringUtils;

import com.yonyou.cloud.common.IConfigKey;
import com.yonyou.cloud.middleware.MiddlewareRuntimeEnvironment;
import com.yonyou.cloud.ncc.NCCEnv;
import com.yonyou.cloud.ncc.NCCSagas;

/**
 * <p>
 * TODO ӿ/๦˵ʹ˵ӿǷΪʹߣǷ̰߳ȫȣ
 * </p>
 * 
 * ޸ļ¼<br>
 * <li>޸ˣ޸ڣ޸ݣ</li> <br>
 * <br>
 * 
 * @see
 * @author gbh
 * @version V6.0
 * @since V6.0 ʱ䣺2010-8-5 10:54:25
 */
public class FipOperatingLogBO {
	public static final int DrawGroupingNum = 30000;
	
	//ԭ㳡
	private Integer batchSize = 0;

	abstract class RecomputeCallable<T> implements Callable<T> {
		private ArrayList<String> pklist = null;

		/**
		 * @return the pklist
		 */
		public ArrayList<String> getPklist() {
			return pklist;
		}

		/**
		 * @param pklist
		 *            the pklist to set
		 */
		public void setPklist(ArrayList<String> pklist) {
			this.pklist = pklist;
		}

		protected void preProcess() {
			try {
				RemoteProcessComponetFactory factory = getRemoteProcessComponetFactory();
				if (factory != null) {
					factory.preProcess();
				}
			} catch (Throwable thr) {
				Logger.error("Background preProcess error", thr);
			}
		}

		protected void postErrorProcess(Throwable e) {
			try {
				RemoteProcessComponetFactory factory = getRemoteProcessComponetFactory();
				if (factory != null) {
					factory.postErrorProcess(e);
				}
			} catch (Throwable thr) {
				Logger.error("Background postErrorProcess error", thr);
			}
		}

		protected void postProcess() {
			try {
				RemoteProcessComponetFactory factory = getRemoteProcessComponetFactory();
				if (factory != null) {
					factory.postProcess();
				}
			} catch (Throwable thr) {
				Logger.error("Background postProcess error", thr);
			}
		}

		protected void clearProcess() {
			try {
				RemoteProcessComponetFactory factory = getRemoteProcessComponetFactory();
				if (factory != null) {
					factory.clearThreadScopePostProcess();
				}
			} catch (Throwable thr) {
				Logger.error("Background clearProcess error", thr);
			}
		}

		protected RemoteProcessComponetFactory getRemoteProcessComponetFactory() {
			RemoteProcessComponetFactory factory = null;
			try {
				factory = (RemoteProcessComponetFactory) NCLocator.getInstance().lookup("RemoteProcessComponetFactory");
			} catch (Throwable thr) {
				Logger.error("Maybe the BizServer has not been started", thr);
			}
			return factory;
		}
	}

	// private static final String MDId = "53eae12c-6455-4a3c-a484-5069e4a21860";
	//
	// /**
	// * 췽һFipOperatingLogBOʵ
	// *
	// * @param MDId
	// * @param bizInfoUtil
	// */
	// public FipOperatingLogBO() {
	// super(MDId);
	// }

	/*
	 * deleteFipOperatingLogProxyеʵ
	 * 
	 * @see nc.itf.fip.opreatinglog.IOperatingLog#delete(nc.vo.fip.operatinglogs.OperatingLogVO[])
	 */
	public void deleteVOArray(OperatingLogVO[] vos) throws BusinessException {
		//УǷ΢,岿߼ֿ
		boolean isMerged = NCCEnv.isMerged();
		boolean isuser = false;
		// ¼־
		if (vos != null) {
			Exception e = new BusinessException();
			StackTraceElement[] stackTrace = e.getStackTrace();
			for (StackTraceElement stackTraceElement : stackTrace) {
				if (stackTraceElement.toString().indexOf("batchSave") >= 0) {
					isuser = true;
					break;
				}
			}
			if (isMerged) {
				loggerMessage(vos, "del oplog" + (isuser ? " by user" : " by system"));
				// ɾ״̬¼
				if (vos != null && vos.length > 0) {
					int deletecount = new FipBaseDao().deleteVOArray(vos);
					if (deletecount != vos.length) {
						throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0033")/* @res "Ϣ״̬󣬲ϢѾʽݻѾɾ" */);
					}
				}
			}
		}
		// ɾ״̬¼ͬʱҪɾѾɵʱĿ굥
		HashMap<String, List<FipRelationInfoVO>> dellistmap = new HashMap<String, List<FipRelationInfoVO>>();
		//Ŀ굥Ͷʱƾ֤з
		HashMap<String, List<OperatingLogVO>> opermap = new HashMap<String, List<OperatingLogVO>>();
		OperatingLogVO[] oplogs = vos;
		//΢񳡾,¼ûĿ굥ݵϢ
		List<OperatingLogVO> noRelationVOs = new ArrayList<OperatingLogVO>();
		//΢񳡾,¼ûĿ굥ݵϢԴ(ɾʹ)
		List<String> noRelationsPks = new ArrayList<String>();
		//¼ҪɾʱϢ,ɾʧܵʱĲ쳣Ϣʱʹ
		List<String> pkList = new ArrayList<String>();
		String pk_group = null;
		//ȫκ,ǰ˽ʹ
		String global_batchno = null;
		//¼κ,ɾĵϢʱʹ
		Set<String> batchnos = new HashSet<String>();
		if (oplogs != null) {
			// Ŀ굥ͷĿ굥ݣɾӦĿ굥
			for (int i = 0; i < oplogs.length; i++) {
				//΢񳡾
				if (!isMerged) {
					//ƽ̨ɾʱƾ֤,ȫκŷڵһԪ,Ҫȡ,Ȼbatchnoԭ
					if (isuser) {
						if (i == 0) {
							global_batchno = oplogs[i].getBatchno();
						}
					} else {//ҵ񵥾ݷȡ,Ϣ,Ҫɾ
						if (oplogs[i] != null && oplogs[i].getBatchno() != null && !"".equals(oplogs[i].getBatchno())) {
							batchnos.add(oplogs[i].getBatchno());
						}
						
					}
					
				}
				OperatingLogVO operatingLogVO = oplogs[i];
				pkList.add(operatingLogVO.getPk_operatinglog());
				// ûĿ굥ݵȻҪɾ
				if (operatingLogVO.getDes_relationid() == null || operatingLogVO.getDes_relationid().trim().equals("")) {
					noRelationVOs.add(operatingLogVO);
					noRelationsPks.add(operatingLogVO.getSrc_relationid());
					continue;
				}
				if (pk_group == null)
					pk_group = operatingLogVO.getDes_group();
				List<FipRelationInfoVO> list = dellistmap.get(operatingLogVO.getDes_billtype());
				if (list == null) {
					list = new ArrayList<FipRelationInfoVO>();
					dellistmap.put(operatingLogVO.getDes_billtype(), list);
				}
				List<OperatingLogVO> operList = opermap.get(operatingLogVO.getDes_billtype());
				if (operList == null) {
					operList = new ArrayList<OperatingLogVO>();
					opermap.put(operatingLogVO.getDes_billtype(), operList);
				}
				list.add(FipBasicRelationVO.convertFromOperatingVO(operatingLogVO).getDesRelation());
				operList.add(operatingLogVO);
			}
			//ɾϢ
			if (batchnos.size() > 0) {
				SagasUtil.deleteErrMsg(batchnos.toArray(new String[0]));
			}
		}
		//΢񳡾ǰѾɾûĿ굥ݵϢ,ֻҪ΢񳡾ɾûĿ굥ݵϢ
		if (!isMerged) {
			if(noRelationVOs.size() > 0) {
				//ɾƽ̨Ϣ
				new FipBaseDao().deleteVOArray(noRelationVOs.toArray(new OperatingLogVO[0]));
				//ɾϢ
				SumRelationVO[] sumvos = null;
				SumRelationVO[] sumvos1 = null;
				//ɾ
				if (noRelationsPks.size() > 0) {
					//ȸsrc_relationidѯ,ٸgroupidѯ
					String sqlWhere = SqlTools.getInStr(SumRelationVO.SRC_RELATIONID, noRelationsPks, true);
					String sqlWhere1 = SqlTools.getInStr(SumRelationVO.GROUPID, noRelationsPks, true);
					sumvos = NCLocator.getInstance().lookup(IFipSumRelation.class).queryByWhere(sqlWhere);
					sumvos1 = NCLocator.getInstance().lookup(IFipSumRelation.class).queryByWhere(sqlWhere1);
					if (sumvos != null) {
						new BaseDAO().deleteVOArray(sumvos);
					}
					if (sumvos1 != null) {
						new BaseDAO().deleteVOArray(sumvos1);
					}
				}
			}
		}
		// Ŀ굥ɾӦĿ굥
		Set<Entry<String, List<FipRelationInfoVO>>> entrySet = dellistmap.entrySet();
		if (!entrySet.isEmpty()) {
			for (Entry<String, List<FipRelationInfoVO>> entry : entrySet) {
				String billtype = entry.getKey();
				if (!isMerged) {
					IFipInterfaceCenterService destService = SagasUtil.getFipInterfaceCenterService(billtype);
					Map<String,Serializable> params = new HashMap<String,Serializable>();
					params.put("pk_group", pk_group);
					params.put("billtype", billtype);
					List<OperatingLogVO> logvos = opermap.get(billtype);
					if (logvos != null && logvos.size() > 0) {
						params.put("data", logvos.toArray(new OperatingLogVO[0]));
					}
					params.put("pks", pkList.toArray(new String[0]));
					params.put("billState", FipBillState.State_TempDes);
					params.put("isuser", isuser);
					//ƽ̨ɾ,Ҫκźͳ,ǰ˽ʹ
					if (isuser) {
						//κ
						params.put("batchno", global_batchno);
						//
						params.put("size", dellistmap.size());
						//
						params.put("scene", OperatinglogSceneEnum.DELETETEMP);
					} else {
						//ҵ񵥾ݷȡ
						params.put("scene", OperatinglogSceneEnum.DELETEBYSRC);
					}
					destService.deleteBill(params, entry.getValue());
				} else {
					IDesBillService itf = FipInterfaceCenter.getDesBillService(pk_group, billtype);
					if (itf == null)
						throw new BusinessException(FipInterfaceCenter.getNoInterfaceFoundMessage(billtype, "IDesBillService"));
					List<FipRelationInfoVO> value = entry.getValue();
					itf.deleteBill(value);
				}
				
			}
		}
	}
	
	public void deleteOplogVOArray(OperatingLogVO[] vos) throws BusinessException {
		// ¼־
		if (vos != null) {
			Exception e = new BusinessException();
			StackTraceElement[] stackTrace = e.getStackTrace();
			boolean isuser = false;
			for (StackTraceElement stackTraceElement : stackTrace) {
				if (stackTraceElement.toString().indexOf("batchSave") >= 0 || stackTraceElement.toString().indexOf("OperatingLogDeleteAction") >= 0) {
					isuser = true;
					break;
				}
			}
			loggerMessage(vos, "del oplog" + (isuser ? " by user" : " by system"));
		}
		// ɾ״̬¼
		if (vos != null && vos.length > 0) {
			//΢񳡾,ļ¼ݶӦĴϢ,Ҫɾ
			if (!NCCEnv.isMerged()) {
				//¼κ,ɾĵϢʱʹ
				Set<String> batchnos = new HashSet<String>();
				for (OperatingLogVO logvo : vos) {
					if (logvo != null && logvo.getBatchno() != null && !"".equals(logvo.getBatchno())) {
						batchnos.add(logvo.getBatchno());
					}
				}
				if (batchnos.size() > 0) {
					//ɾϢ
					SagasUtil.deleteErrMsg(batchnos.toArray(new String[0]));
				}
			}
			new FipBaseDao().deleteVOArray(vos);
		}
	}
	
	public void deleteInitOplogVOArray(OperatingLogVO[] vos) throws BusinessException {
		// ɾ״̬¼
		if (vos != null && vos.length > 0) {
			new FipBaseDao().deleteVOArray(vos);
		}
	}

	public static void loggerMessage(OperatingLogVO[] vos, String msg) throws BusinessException {
		if (vos == null || vos.length == 0)
			return;
		List<MessageLogVO> logvoList = new ArrayList<MessageLogVO>();
		for (int i = 0; i < vos.length; i++) {
			OperatingLogVO vo = vos[i];
			int opflag = vo.getOperateflag();
			if(opflag == OperatingFlagEmu.FLAG_init || opflag == OperatingFlagEmu.FLAG_init_running || opflag == OperatingFlagEmu.FLAG_init_error){
				continue;
			}
			MessageLogVO messageLogVO = MessageTool.createMessageVO(FipBasicRelationVO.convertFromOperatingVO(vo).getSrcRelation());
			messageLogVO.setMessagetype(1);
			messageLogVO.setPk_operator(InvocationInfoProxy.getInstance().getUserId());
			messageLogVO.setFreedef5(msg);
			messageLogVO.setFreedef4(vo.getDes_billtype() + ":" + vo.getDes_relationid() + "@" + vo.getDes_org() + ":" + vo.getDes_freedef1());
			logvoList.add(messageLogVO);
		}
		new FipMessageLogsProxy().insert(logvoList.toArray(new MessageLogVO[0]));
	}

	public void deleteVOList(List<OperatingLogVO> volist) throws BusinessException {
		deleteVOArray(volist.toArray(new OperatingLogVO[0]));
	}

	public void deleteByPKs(String[] pks) throws BusinessException {
		if (pks == null || pks.length == 0)
			return;
		new BaseDAO().deleteByPKs(OperatingLogVO.class, pks);
	}

	/*
	 * insertFipOperatingLogProxyеʵ
	 * 
	 * @see nc.itf.fip.opreatinglog.IOperatingLog#insert(nc.vo.fip.operatinglogs.OperatingLogVO[])
	 */
	public OperatingLogVO[] insert(OperatingLogVO[] vos) throws BusinessException {
		if (vos != null) {
			String[] pks = new BaseDAO().insertVOArray(vos);
			for (int i = 0; i < vos.length; i++) {
				vos[i].setPk_operatinglog(pks[i]);
			}
		}
		return vos;
	}

	/*
	 * insertFipOperatingLogProxyеʵ
	 * 
	 * @see nc.itf.fip.opreatinglog.IOperatingLog#insert(nc.vo.fip.operatinglogs.OperatingLogVO[])
	 */
	public List<OperatingLogVO> insert(List<OperatingLogVO> vos) throws BusinessException {
		if (vos != null) {
			//΢񳡾,¼Ϣ
			if (!NCCEnv.isMerged()) {
				//sagasκ,쳣ͬʱ¼ƾ֤Ϣsagas_business_log
				String sagas_business_batch_no = SagasUtil.generateUID();
				for(OperatingLogVO logvo : vos){
					if(logvo != null){
						logvo.setBatchno(sagas_business_batch_no);
					}
				}
				String[] pks = new BaseDAO().insertVOList(vos);
				List<String> pkList = new ArrayList<String>();
				for (int i = 0; i < vos.size(); i++) {
					vos.get(i).setPk_operatinglog(pks[i]);
					pkList.add(pks[i]);
				}
				boolean isDraw = false;
				Exception e = new BusinessException();
				StackTraceElement[] stackTrace = e.getStackTrace();
				for (StackTraceElement stackTraceElement : stackTrace) {
					if (stackTraceElement.toString().indexOf("drawSrcBill") >= 0) {
						isDraw = true;
						break;
					}
				}
				Map<String, Object> errMap = new HashMap<String, Object>();
				errMap.put("pks", pkList);
				if (isDraw) {
					errMap.put("scene", OperatinglogSceneEnum.GENERATE_DRAW);
				} else {
					errMap.put("scene", OperatinglogSceneEnum.GENERATE_REBUILD);
				}
				errMap.put("errMsg", nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10170410", "1101704100034"));
				errMap.put("sagas_business_batch_no", sagas_business_batch_no);
				//ϢĲwebsocketϢ
				SagasUtil.saveAndPushErrorMsg(errMap);
			} else {
				String[] pks = new BaseDAO().insertVOList(vos);
				for (int i = 0; i < vos.size(); i++) {
					vos.get(i).setPk_operatinglog(pks[i]);
				}
			}
		}
		return vos;
	}

	/*
	 * queryByWhereFipOperatingLogProxyеʵ
	 * 
	 * @see nc.itf.fip.opreatinglog.IOperatingLog#queryByWhere(java.lang.String)
	 */
	@SuppressWarnings({ "unchecked", "rawtypes" })
	public OperatingLogVO[] queryByWhere(String wherepart) throws BusinessException {
		if (wherepart == null)
			return null;
		OperatingLogVO[] rs = null;
		BaseDAO baseDAO = new BaseDAO();
		Collection c = baseDAO.retrieveByClause(OperatingLogVO.class, wherepart, "" + OperatingLogVO.SRC_ORG + "," + OperatingLogVO.SRC_BILLTYPE + "," + OperatingLogVO.SRC_BUSIDATE);
		if (c != null && c.size() > 0) {
			rs = new OperatingLogVO[c.size()];
			c.toArray(rs);
		}
		return rs;
	}
	
	/*
	 * ݴԴidȡĿ굥Ϣ
	 */
	public Map<String,List<String>> queryDesBillBySumRelationSrcIds(ArrayList<String> src_relationids) throws BusinessException{
		//Դidȡ
		String wherepart = " " + SqlTools.getInStr(OperatingLogVO.SRC_RELATIONID, src_relationids, false);
		IFipSumRelation ipx = NCLocator.getInstance().lookup(IFipSumRelation.class);
		SumRelationVO[] sumvos = ipx.queryByWhere(wherepart);
		//ܷ
		List<String> groupidList = new ArrayList<String>();
		for(SumRelationVO sumRelation : sumvos){
			groupidList.add(sumRelation.getGroupid());
		}
		IOperatingLog opLogQry = NCLocator.getInstance().lookup(IOperatingLog.class);
		String wherepart_oplog = " " + SqlTools.getInStr(OperatingLogVO.SRC_RELATIONID, groupidList, false);
		OperatingLogVO[] oplogs = opLogQry.queryByWhere(wherepart_oplog);
		List<String> pk_operatinglogs = new ArrayList<String>();//ɾϢ
		List<String> des_relationids = new ArrayList<String>(); //ɾʱƾ֤
		for(OperatingLogVO oplog : oplogs){
			if(oplog.getPk_operatinglog() != null){
				pk_operatinglogs.add(oplog.getPk_operatinglog());
			}
			if(oplog.getDes_relationid() != null){
				des_relationids.add(oplog.getDes_relationid());
			}
		}
		Map<String,List<String>> desBillMap = new HashMap<String,List<String>>();
		desBillMap.put("pk_operatinglogs", pk_operatinglogs.size() > 0 ? pk_operatinglogs : null);
		desBillMap.put("des_relationids", des_relationids.size() > 0 ? des_relationids : null);
		return desBillMap;
	}

	/*
	 * queryByWhereFipOperatingLogProxyеʵ
	 * 
	 * @see nc.itf.fip.opreatinglog.IOperatingLog#queryByWhere(java.lang.String)
	 */
	@SuppressWarnings("unchecked")
	public List<String> queryPKListByWhere(String wherepart) throws BusinessException {
		if (wherepart == null)
			return null;
		List<String> c = (List<String>) new BaseDAO().retrieveByClause(OperatingLogVO.class, wherepart);
		return c;
	}

	/*
	 * updateFipOperatingLogProxyеʵ
	 * 
	 * @see nc.itf.fip.opreatinglog.IOperatingLog#update(nc.vo.fip.operatinglogs.OperatingLogVO[])
	 */
	public OperatingLogVO[] update(OperatingLogVO[] vos) throws BusinessException {
		if (vos != null) {
			new BaseDAO().updateVOArray(vos);
		}
		return vos;
	}

	/*
	 * updateFipOperatingLogProxyеʵ
	 * 
	 * @see nc.itf.fip.opreatinglog.IOperatingLog#update(nc.vo.fip.operatinglogs.OperatingLogVO[])
	 */
	public List<OperatingLogVO> update(List<OperatingLogVO> vos) throws BusinessException {
		if (vos != null) {
			//΢񳡾,¼Ϣ
			if (!NCCEnv.isMerged()) {
				boolean isRecompute = false;
				Exception e = new BusinessException();
				StackTraceElement[] stackTrace = e.getStackTrace();
				for (StackTraceElement stackTraceElement : stackTrace) {
					if (stackTraceElement.toString().indexOf("disposeResult") >= 0) {
						isRecompute = true;
						break;
					}
				}
				boolean isDraw = false;
				if (isRecompute) {
					for (StackTraceElement stackTraceElement : stackTrace) {
						if (stackTraceElement.toString().indexOf("drawSrcBill") >= 0) {
							isDraw = true;
							break;
						}
					}
					
				}
				//,ƽ̨־,ʽȡ,ʱɳ,Ϣ͵ǰ
				if (isRecompute) {
					//sagasκ,쳣ͬʱ¼ƾ֤Ϣsagas_business_log
					String sagas_business_batch_no = SagasUtil.generateUID();
					List<String> pkList = new ArrayList<String>();
					for(OperatingLogVO logvo : vos){
						if(logvo != null){
							logvo.setBatchno(sagas_business_batch_no);
							pkList.add(logvo.getPk_operatinglog());
						}
					}
					new BaseDAO().updateVOList(vos);
					Map<String, Object> errMap = new HashMap<String, Object>();
					errMap.put("pks", pkList);
					if (isDraw) {
						errMap.put("scene", OperatinglogSceneEnum.GENERATE_DRAW);
					} else {
						errMap.put("scene", OperatinglogSceneEnum.GENERATE_REBUILD);
					}
					errMap.put("errMsg", nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10170410", "1101704100034"));
					errMap.put("sagas_business_batch_no", sagas_business_batch_no);
					//ϢĲwebsocketϢ
					SagasUtil.saveAndPushErrorMsg(errMap);
				} else {
					new BaseDAO().updateVOList(vos);
				}
			} else {
				new BaseDAO().updateVOList(vos);
			}
			new BaseDAO().updateVOList(vos);
		}
		return vos;
	}

	/*
	 * queryByPKIOperatingLogеʵ
	 * 
	 * @see nc.itf.fip.opreatinglog.IOperatingLog#queryByPK(java.lang.String)
	 */
	public OperatingLogVO queryByPK(String pk) throws BusinessException {
		OperatingLogVO rsvo = (OperatingLogVO) new BaseDAO().retrieveByPK(OperatingLogVO.class, pk);
		return rsvo;
	}

	/*
	 * queryByPKIOperatingLogеʵ
	 * 
	 * @see nc.itf.fip.opreatinglog.IOperatingLog#queryByPK(java.lang.String)
	 */
	@SuppressWarnings("unchecked")
	public OperatingLogVO[] queryByPKs(String[] pks) throws BusinessException {
		OperatingLogVO[] rsvo = null;
		if (pks != null) {
			String wherepart = SqlTools.getInStr("pk_operatinglog", pks, true);
			Collection<OperatingLogVO> c = new BaseDAO().retrieveByClause(OperatingLogVO.class, wherepart);
			if (c != null && !c.isEmpty()) {
				rsvo = new OperatingLogVO[c.size()];
				c.toArray(rsvo);
			}
		}
		return rsvo;
	}

	/*
	 * batchSaveFipOperatingLogProxyеʵ
	 * 
	 * @see nc.itf.fip.opreatinglog.IOperatingLog#batchSave(nc.vo.bd.meta.BatchOperateVO)
	 */
	public BatchOperateVO batchSave(BatchOperateVO batchVO) throws BusinessException {
		//saga
		NCCSagas.startNewSaga();
		List<String> lockList = new ArrayList<String>();
		//ȫκ,ǰһκ̨ɲݶκ
		String global_batchno = null;
		if (batchVO == null)
			return null;
		if (batchVO.getAddObjs() != null) {

		}
		if (batchVO.getUpdObjs() != null) {

		}
		//¼κ,ɾĵϢʱʹ
		Set<String> batchnos = new HashSet<String>();
		Object[] objs = batchVO.getDelObjs();
		if (objs != null) {
			if (!NCCEnv.isMerged()) {
				String batchno = ((OperatingLogVO)objs[0]).getBatchno();
				if (StringUtils.isNotBlank(batchno)) {
					String[] noArr = batchno.split("-");
					if (noArr.length > 1) {
						global_batchno = noArr[0];
						((OperatingLogVO)objs[0]).setBatchno(noArr[1]);
					} else {
						global_batchno = noArr[0];
						((OperatingLogVO)objs[0]).setBatchno(null);
					}
				}
			}
			List<String> relationList = new ArrayList<String>();
			List<OperatingLogVO> volist = new ArrayList<OperatingLogVO>();
			List<String> pklist = new ArrayList<String>();
			//ɾʱƾ֤
			List<String> pklogs = new ArrayList<String>();
			for (Object vo : objs) {
				if (vo != null) {
					OperatingLogVO opvo = (OperatingLogVO) vo;
					if (StringUtils.isNotBlank(opvo.getBatchno())) {
						batchnos.add(opvo.getBatchno());
					}
					opvo.setOperateflag(OperatingFlagEmu.FLAG_delete_running);
					volist.add(opvo);
					relationList.add(opvo.getSrc_relationid());
					lockList.add(OperatingLogVO.getDefaultTableName() + opvo.getPk_operatinglog());
					pklist.add(opvo.getDes_relationid());
					pklogs.add(opvo.getPk_operatinglog());
				}
			}
			boolean locked = false;
			String[] array = lockList.toArray(new String[0]);
			try{
				//УǷ΢,岿߼ֿ
				boolean isMerged = NCCEnv.isMerged();
				if(!isMerged){
					//Ҫɾݼ
					SagasUtil.addDynamicLock(volist.toArray(new OperatingLogVO[0]));
					//Уts
					SagasUtil.checkBillsTs(volist.toArray(new OperatingLogVO[0]));
					//ɾϢ
					SagasUtil.deleteErrMsg(batchnos.toArray(new String[0]));
					//Уǰ
					String billtype = ((OperatingLogVO)objs[0]).getDes_billtype();
					if("C0".equalsIgnoreCase(billtype)){
						NCLocator.getInstance().lookup(IVoucher.class).checkDeleteVouchersSagasCheck(pklist.toArray(new String[0]));
					} else if ("RA00".equalsIgnoreCase(billtype)){
						NCLocator.getInstance().lookup(IFipDeleteCheck.class).beforeDeleteCheck(pklist.toArray(new String[0]));
					}
					//Ϣ״̬Ϊɾ
					if (volist != null && volist.size() > 0) {
						update(volist);
					}
				}else{
					locked = PKLock.getInstance().acquireBatchLock(array, null, null);
					if (!locked) {
						throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-2-0003")/* ,ûڲͬһ */);
					}
				}
				//ȫκż´
				if (!NCCEnv.isMerged()) {
					if (volist != null && volist.size() > 0) {
						volist.get(0).setBatchno(global_batchno);
					}
//					//ʼredisеļΪ0,ɾ,ÿִһ,redisһ,Ҳ1,ȵͷ,Ϊǰ
//					SagasUtil.processInitCount(global_batchno, FipRedisKeyConst.DELBILL_KEY2);
				}
				//ɾĿ굥
				deleteVOList(volist);
			} catch (Exception e) {
				Logger.error(e.getMessage(), e);
//				if (!NCCEnv.isMerged()) {
//					//ɾredisеcount
//					SagasUtil.removeRedisData(global_batchno, FipRedisKeyConst.DELBILL_KEY2);
//				}
				throw e;
			} finally{
				if (locked){
					PKLock.getInstance().releaseBatchLock(array, null, null);
				}
			}
			
			//ɾӿڵ
			if(!relationList.isEmpty())
				NCLocator.getInstance().lookup(ITXMessageDataService.class).deleteByRelationIDs(relationList.toArray(new String[0]));
		}
		return batchVO;
	}

	/**
	 * 
	 * 
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param pklist
	 * @throws BusinessException
	 * @see
	 * @since V6.0
	 */
	public void recomputeByPKs_RequiresNew(List<String> pklist, Map<String,Object> recomputeMap) throws BusinessException {
		//serverʱͨmaptabid
		if(recomputeMap != null && recomputeMap.get("tabid") != null){
			String env = "nc.bs.framework.core.service.RequestAttributeManager";
			IAttributeManager manager = (IAttributeManager) NCLocator.getInstance().lookup(env);
			Object tabid = manager.getAttribute("tabid");
			if(tabid == null){
				manager.setAttribute("tabid", recomputeMap.get("tabid"));
			}
		}
		long start = System.currentTimeMillis();
		if (pklist == null || pklist.isEmpty())
			return;
		int threadcount = 3;
		int runthreadlimit = 100;// ̫Сʱ򣬶̲߳û̫Եƣӷѹ
		int listsize = pklist.size();
		if (listsize > runthreadlimit) {
			String serviceName = MiddlewareRuntimeEnvironment.get(IConfigKey.Keys.APP_CODE);//ȡ
			// жǷԭ
		    if (serviceName != null) {
				final IOperatingLog ip = NCLocator.getInstance().lookup(IOperatingLog.class);
				final String datasource = InvocationInfoProxy.getInstance().getUserDataSource();
				final String langcode = InvocationInfoProxy.getInstance().getLangCode();
				final String userid = InvocationInfoProxy.getInstance().getUserId();
				final String loglevel = InvocationInfoProxy.getInstance().getLogLevel();
				final String groupid = InvocationInfoProxy.getInstance().getGroupId();
				final String callid = InvocationInfoProxy.getInstance().getCallId();
				final Map<String,Object> map = recomputeMap;
				String env = "nc.bs.framework.core.service.RequestAttributeManager";
				IAttributeManager manager = (IAttributeManager) NCLocator.getInstance().lookup(env);
				Object tabid = manager.getAttribute("tabid");
				final Object tab_id = tabid;
				int groupcount = (listsize / threadcount) + 1;
				ArrayList<FutureTask<Object>> futurelist = new ArrayList<FutureTask<Object>>();
				for (int i = 0; i < threadcount; i++) {
					List<String> sublist;
					if (i == threadcount - 1) {
						sublist = pklist.subList(groupcount * i, listsize);
					} else {
						sublist = pklist.subList(groupcount * i, groupcount * i + groupcount);
					}
					RecomputeCallable<Object> c = new RecomputeCallable<Object>() {
						@Override
						public Object call() throws Exception {
							InvocationInfoProxy.getInstance().setUserDataSource(datasource);
							InvocationInfoProxy.getInstance().setLangCode(langcode);
							InvocationInfoProxy.getInstance().setUserId(userid);
							InvocationInfoProxy.getInstance().setLogLevel(loglevel);
							InvocationInfoProxy.getInstance().setGroupId(groupid);
							InvocationInfoProxy.getInstance().setCallId(callid);
							String env = "nc.bs.framework.core.service.RequestAttributeManager";
							IAttributeManager manager = (IAttributeManager) NCLocator.getInstance().lookup(env);
							manager.setAttribute("tabid", tab_id);
							preProcess();
							try {
								long start1 = System.currentTimeMillis();
								ip.recomputeAtomic_RequiresNew(getPklist(), false, map);
								long end1 = System.currentTimeMillis();
								Logger.error("[FIP Distribute] currentTread:[" + Thread.currentThread().getName() + "] cost ms " + (end1 - start1));
								postProcess();
								return Boolean.TRUE;
							} catch (Exception e) {
								postErrorProcess(e);
								throw e;
							} finally {
								clearProcess();
							}
						}
					};
					ArrayList<String> tmplist = new ArrayList<String>();
					tmplist.addAll(sublist);
					c.setPklist(tmplist);
					FutureTask<Object> f = new FutureTask<Object>(c);
					futurelist.add(f);
					Executor e = new Executor(f, "RecomputeCallableThread" + i);
					e.start();
				}
				for (FutureTask<Object> futureTask : futurelist) {
					try {
						futureTask.get(groupcount * 2000, TimeUnit.MILLISECONDS);
					} catch (InterruptedException e) {
						Logger.error("", e);
					} catch (ExecutionException e) {
						Logger.error("", e);
						// ִִ̳
						if (e.getCause() instanceof BusinessException)
							throw (BusinessException) e.getCause();
					} catch (TimeoutException e) {
						// ʱ󣬿ܽ
						if (!futureTask.isDone() && !futureTask.isCancelled())
							futureTask.cancel(true);
						// ִִ̳
					}
				}
		    } else {
		    	// ķisMaster()᷵trueisSingle()жϣ  Ĺϵ
				boolean single = ServerConfiguration.getServerConfiguration().isSingle();
				boolean canRunThread = single || !ServerConfiguration.getServerConfiguration().isMaster();
				if (canRunThread) {
					Properties prop = new Properties();
					prop.setProperty(NCLocator.SERVICEDISPATCH_URL, ServerConfiguration.getServerConfiguration().getServerEndpointURL(ServerConfiguration.getServerConfiguration().getServerName()));
					// prop.setProperty(NCLocator.LOCATOR_PROVIDER_PROPERTY, ModuleNCLocator.class.getName());
					prop.setProperty(NCLocator.TARGET_MODULE, "fip");
					final IOperatingLog ip = (single ? NCLocator.getInstance().lookup(IOperatingLog.class) : NCLocator.getInstance(prop).lookup(IOperatingLog.class));
					final String datasource = InvocationInfoProxy.getInstance().getUserDataSource();
					final String langcode = InvocationInfoProxy.getInstance().getLangCode();
					final String userid = InvocationInfoProxy.getInstance().getUserId();
					final String loglevel = InvocationInfoProxy.getInstance().getLogLevel();
					final String groupid = InvocationInfoProxy.getInstance().getGroupId();
					int groupcount = (listsize / threadcount) + 1;
					ArrayList<FutureTask<Object>> futurelist = new ArrayList<FutureTask<Object>>();
					for (int i = 0; i < threadcount; i++) {
						List<String> sublist;
						if (i == threadcount - 1) {
							sublist = pklist.subList(groupcount * i, listsize);
						} else {
							sublist = pklist.subList(groupcount * i, groupcount * i + groupcount);
						}
						RecomputeCallable<Object> c = new RecomputeCallable<Object>() {
							@Override
							public Object call() throws Exception {
								InvocationInfoProxy.getInstance().setUserDataSource(datasource);
								InvocationInfoProxy.getInstance().setLangCode(langcode);
								InvocationInfoProxy.getInstance().setUserId(userid);
								InvocationInfoProxy.getInstance().setLogLevel(loglevel);
								InvocationInfoProxy.getInstance().setGroupId(groupid);
								preProcess();
								try {
									ip.recomputeAtomic_RequiresNew(getPklist(), false, null);
									postProcess();
									return Boolean.TRUE;
								} catch (Exception e) {
									postErrorProcess(e);
									throw e;
								} finally {
									clearProcess();
								}
							}
						};
						ArrayList<String> tmplist = new ArrayList<String>();
						tmplist.addAll(sublist);
						c.setPklist(tmplist);
						FutureTask<Object> f = new FutureTask<Object>(c);
						futurelist.add(f);
						Executor e = new Executor(f, "RecomputeCallableThread" + i);
						e.start();
					}
					for (FutureTask<Object> futureTask : futurelist) {
						try {
							futureTask.get(groupcount * 2000, TimeUnit.MILLISECONDS);
						} catch (InterruptedException e) {
							Logger.error("", e);
						} catch (ExecutionException e) {
							Logger.error("", e);
							// ִִ̳
							if (e.getCause() instanceof BusinessException)
								throw (BusinessException) e.getCause();
						} catch (TimeoutException e) {
							// ʱ󣬿ܽ
							if (!futureTask.isDone() && !futureTask.isCancelled())
								futureTask.cancel(true);
							// ִִ̳
						}
					}
				} else {
					recomputeByPKs_atomic(pklist, false, null);
				}
		    }
		} else {
			recomputeByPKs_atomic(pklist, false, recomputeMap);
		}
		long end = System.currentTimeMillis();
	    Logger.error("[FIP Distribute] currentServer:[" + getUrl(getLocalIpPortCloud()) + "] cost ms " + (end - start));
	}

	/**
	 * 
	 * ˵
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param pklist
	 *            ¼
	 * @param rebuildRelation
	 *            Ƿ
	 * @throws BusinessException
	 * @see
	 * @since V6.0
	 */
	@SuppressWarnings("unchecked")
	public void recomputeByPKs_atomic(List<String> pklist, boolean rebuildRelation, Map<String,Object> recomputeMap) throws BusinessException {
		FipBSCacheCleaner.clearAllCache();
		String wherepart = SqlTools.getInStr("pk_operatinglog", pklist, true);
		BaseDAO dao = new BaseDAO();
		Collection<OperatingLogVO> opvolist = dao.retrieveByClause(OperatingLogVO.class, wherepart);
		if (opvolist == null || opvolist.isEmpty()){
			return;
		}
		ArrayList<String> locklist = new ArrayList<String>();
		try {
			//УǷ΢,岿߼ֿ
			boolean isMerged = NCCEnv.isMerged();
			if(!isMerged){
				//ƽ̨־ɳ(ʱɻҲߵóӦ˵)
				if(!FipSceneUtil.isGenerateSoonOrTime()){
					//֮ǰûnewsagaaddsagaԿһµ
					NCCSagas.startAddSaga();
					//״̬ΪУɾе
					SagasUtil.handleDataInProcess(opvolist.toArray(new OperatingLogVO[0]),UFBoolean.TRUE);
				}
			}
			ArrayList<FipBasicRelationVO> volist = new ArrayList<FipBasicRelationVO>();
			ArrayList<FipBasicRelationVO> sumvolist = new ArrayList<FipBasicRelationVO>();
			// ȫκ
			String batchno = (recomputeMap == null || recomputeMap.get("global_batchno") == null) ? null : (String)recomputeMap.get("global_batchno");
			HashMap<String, String> billtypeMap_all = new HashMap<String, String>();
			HashMap<String, String> billtypeMap_new = new HashMap<String, String>();
			boolean recomputeWithUnSum = false;//ݰǻ
			boolean recomputeWithSum = false;  //ݰ
			for (OperatingLogVO operatingLogVO : opvolist) {
				if(!isMerged){
					//ȡܳݵĵ
					if (operatingLogVO.getSumflag() != null && operatingLogVO.getSumflag().booleanValue()) {
						recomputeWithSum = true;
						String key = operatingLogVO.getSrc_billtype();
						String value = billtypeMap_all.get(key);
						if (value == null) {
							billtypeMap_all.put(key, key);
						}
					} else {
						recomputeWithUnSum = true;
					}
					boolean locked = SagasUtil.addSingleDynamicLock(operatingLogVO);
					if (!locked)
						continue;
					//ȡܳݵĵ
					if (operatingLogVO.getSumflag() != null && operatingLogVO.getSumflag().booleanValue()) {
						String key = operatingLogVO.getSrc_billtype();
						String value = billtypeMap_new.get(key);
						if (value == null) {
							billtypeMap_new.put(key, key);
						}
					}
				}else{
					// ֹͬʱͬһ
					String pkOperatinglog = operatingLogVO.getPk_operatinglog();
					String lockable = OperatingLogVO.getDefaultTableName() + pkOperatinglog;
					boolean locked = PKLock.getInstance().acquireLock(lockable, null, null);
					if (!locked)
						continue;
					locklist.add(lockable);
				}
				if (operatingLogVO.getSumflag() != null && operatingLogVO.getSumflag().booleanValue()) {
					// ɵļ¼
					sumvolist.add(FipBasicRelationVO.convertFromOperatingVO(operatingLogVO));
				} else {
					// ǻɵļ¼
					volist.add(FipBasicRelationVO.convertFromOperatingVO(operatingLogVO));
				}
			}
			if(!isMerged){
				//
				int batchSize = recomputeMap == null ? 0 : Integer.parseInt(String.valueOf(recomputeMap.get("batchSize")));
				opvolist = null;
				if (!volist.isEmpty()){
					recomputeUnSum(volist, recomputeMap);
				} else {
					if(recomputeMap != null && recomputeWithUnSum){
						SagasUtil.processMsgsResult(batchno, 1*2, batchSize, FipRedisKeyConst.REBUILD_KEY1, FipRedisKeyConst.REBUILD_KEY2);
					}
				}
				if (!sumvolist.isEmpty()){
					if(recomputeMap != null){
						if(billtypeMap_all.size() > billtypeMap_new.size()){
							SagasUtil.processMsgsResult(batchno, (billtypeMap_all.size() - billtypeMap_new.size())*2, batchSize, FipRedisKeyConst.REBUILD_KEY1, FipRedisKeyConst.REBUILD_KEY2);
						}
					}
					recomputeSum(sumvolist, recomputeMap);
				} else {
					if(recomputeMap != null && recomputeWithSum){
						SagasUtil.processMsgsResult(batchno, billtypeMap_all.keySet().size()*2, batchSize, FipRedisKeyConst.REBUILD_KEY1, FipRedisKeyConst.REBUILD_KEY2);
					}
				}
			} else {
				if (!volist.isEmpty())
					recomputeUnSum(volist, null);
				
				if (!sumvolist.isEmpty())
					recomputeSum(sumvolist, null);
			}
		} finally {
			if (!locklist.isEmpty()) {
				PKLock.getInstance().releaseBatchLock(locklist.toArray(new String[0]), null, null);
			}
		}

	}

	/**
	 * ɵļ¼ã
	 * 
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param sumvolist
	 * @throws BusinessException
	 * @see
	 * @since V6.0
	 */
	private void recomputeSum(ArrayList<FipBasicRelationVO> sumvolist, Map<String, Object> map) throws BusinessException {
		if (sumvolist == null || sumvolist.isEmpty())
			return;
		String des_group = null;
		String des_billtype = null;
		ArrayList<FipRelationInfoVO> deldeslist = new ArrayList<FipRelationInfoVO>();
		ArrayList<String> oppklist = new ArrayList<String>();
		for (FipBasicRelationVO operatingLogVO : sumvolist) {
			// ݵĺϷ
			if (des_group == null)
				des_group = operatingLogVO.getDesRelation().getPk_group();
			else {
				if (!des_group.equals(operatingLogVO.getDesRelation().getPk_group()))
					throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0023")/* @res "ݷΧһֻͬŵͬĿ굥ͽС" */);
			}
			if (des_billtype == null) {
				des_billtype = operatingLogVO.getDesRelation().getPk_billtype();
			}
			// ¼ҪɾĿ굥
			deldeslist.add((FipRelationInfoVO) operatingLogVO.getDesRelation().clone());
			oppklist.add(operatingLogVO.getPk_relation());
		}
		//УǷ΢,岿߼ֿ
		boolean isMerged = NCCEnv.isMerged();
		if(isMerged){
			// ɾƽ̨Ϣ
			deleteByPKs(oppklist.toArray(new String[0]));
			IDesBillService itf = FipInterfaceCenter.getDesBillService(des_group, des_billtype);
			// ɾĿ굥
			// ޳ظݣrelationIDΪ׼Ϊƽ̨relationIDΨһʶĵ
			ArrayList<FipRelationInfoVO> realdellist = new ArrayList<FipRelationInfoVO>();
			HashMap<String, String> samemap = new HashMap<String, String>();
			for (FipRelationInfoVO fipRelationInfoVO : deldeslist) {
				if (fipRelationInfoVO.getRelationID() == null)
					continue;
				if (samemap.get(fipRelationInfoVO.getRelationID()) == null) {
					samemap.put(fipRelationInfoVO.getRelationID(), "");
					realdellist.add(fipRelationInfoVO);
				}
			}
			if (realdellist != null && !realdellist.isEmpty())
				if (itf == null)
					throw new BusinessException(FipInterfaceCenter.getNoInterfaceFoundMessage(des_billtype, "IDesBillService"));
			itf.deleteBill(realdellist);
		}
		
		{
			// 
			ArrayList<String> grouplist = new ArrayList<String>();
			HashMap<String, FipBasicRelationVO> groupmap = new HashMap<String, FipBasicRelationVO>();
			for (FipBasicRelationVO vo : sumvolist) {
				grouplist.add(vo.getSrcRelation().getRelationID());
				groupmap.put(vo.getSrcRelation().getRelationID(), vo);
			}
			// ѯܵԴϢ
			SumRelationVO[] sumvos = new FipSumRelationProxy().queryByWhere(SqlTools.getInStr("groupid", grouplist, true));
			if (sumvos == null)
				return;
			// Դͺͷŷ
			HashMap<String, HashMap<String, Collection<FipRelationInfoVO>>> groupbill = new HashMap<String, HashMap<String, Collection<FipRelationInfoVO>>>();
			for (int i = 0; i < sumvos.length; i++) {
				SumRelationVO vo = sumvos[i];
				if (vo == null)
					continue;
				HashMap<String, Collection<FipRelationInfoVO>> billtypemap = groupbill.get(vo.getSrc_billtype());
				if (billtypemap == null) {
					billtypemap = new HashMap<String, Collection<FipRelationInfoVO>>();
					groupbill.put(vo.getSrc_billtype(), billtypemap);
				}
				Collection<FipRelationInfoVO> volist = billtypemap.get(vo.getGroupid());
				if (volist == null) {
					volist = new ArrayList<FipRelationInfoVO>();
					billtypemap.put(vo.getGroupid(), volist);
				}
				volist.add(FipBasicRelationVO.convertFromSumRelationVO(vo).getSrcRelation());
			}
			sumvos = null;
			IBillSumService ip = null;
			IFipQueryService iqp = NCLocator.getInstance().lookup(IFipQueryService.class);
			Set<Entry<String, HashMap<String, Collection<FipRelationInfoVO>>>> entrySet = groupbill.entrySet();
			for (Entry<String, HashMap<String, Collection<FipRelationInfoVO>>> entry : entrySet) {
				Collection<FipBillSumRSVO> sumBills = null;
				// Դͷֱ
				String key = entry.getKey();
				HashMap<String, Collection<FipRelationInfoVO>> value = entry.getValue();
				if (value == null || value.isEmpty())
					continue;
				// ͬһ͵ģŷݷ
				Set<Entry<String, Collection<FipRelationInfoVO>>> entrySet2 = value.entrySet();
				ArrayList<Collection<FipRelationInfoVO>> billlist = new ArrayList<Collection<FipRelationInfoVO>>();
				String[] usingFields = null;
				FipRelationInfoVO desinfo = null;
				for (Entry<String, Collection<FipRelationInfoVO>> entry2 : entrySet2) {
					String groupid = entry2.getKey();
					FipBasicRelationVO fipBasicRelationVO = groupmap.get(groupid);
					if (usingFields == null) {
						usingFields = iqp.getUsingFields(fipBasicRelationVO.getSrcRelation().getPk_billtype(), fipBasicRelationVO.getDesRelation().getPk_billtype(), fipBasicRelationVO.getSrcRelation().getPk_group(), fipBasicRelationVO.getDesRelation().getPk_org());
					}
					if (desinfo == null) {
						desinfo = fipBasicRelationVO.getDesRelation();
					}
					Collection<FipRelationInfoVO> value2 = entry2.getValue();
					if (value2 != null)
						billlist.add(value2);
				}
				if(!isMerged){
					//ȡηӿڣñķϵĽӿڣ
					IFipInterfaceCenterService srcService = SagasUtil.getFipInterfaceCenterService(key);
					Map<String,Serializable> params_src = new HashMap<String,Serializable>();
					params_src.put("pk_group", des_group);
					params_src.put("billtype", key);
					// Դ
					try{
						sumBills = srcService.querySumBill(params_src, billlist, usingFields, UFBoolean.TRUE);
					} catch (BusinessException ex){
						throw ex;
					} catch (Exception ex1){//ʱֳܻʱ
						throw new BusinessException(ex1);
					}
				}else{
					ip = FipInterfaceCenter.getBillSumService(des_group, key);
					if (ip == null)
						throw new BusinessException(FipInterfaceCenter.getNoInterfaceFoundMessage(key, "IBillSumService"));
					// Դ
					sumBills = ip.querySumBill(billlist, usingFields, UFBoolean.TRUE);
				}
				List<FipBillSumRSVO> sumBillsList = new ArrayList<FipBillSumRSVO>();
				if (sumBills != null && !sumBills.isEmpty()) {
					ArrayList<String> groupidlist = new ArrayList<String>();
					List<FipTranslateResultVO> fipmessagelist = new ArrayList<FipTranslateResultVO>();
					Map<String,Object> params = null;
					for (FipBillSumRSVO fipBillSumRSVO : sumBills) {
						FipExtRelationVO fipRelationVO = new FipExtRelationVO();
						FipMessageVO fipmessagevo = new FipMessageVO();
						fipRelationVO.setSrcRelation(fipBillSumRSVO.getMessageinfo());
						fipRelationVO.setDesRelation((FipRelationInfoVO) desinfo.clone());
						fipRelationVO.setIssum(UFBoolean.FALSE);
						fipmessagevo.setMessageinfo(fipBillSumRSVO.getMessageinfo());
						fipmessagevo.setBillVO(fipBillSumRSVO.getBillVO());
						fipmessagevo.setMessagetype(FipMessageVO.MESSAGETYPE_ADD);
						FipTransVO transvo = new FipTransVO();
						transvo.setDatavo(fipmessagevo.getBillVO());
						transvo.setMessagevo(fipRelationVO);
						transvo.setIsImmediatelyRun(UFBoolean.TRUE);
						List<FipTransVO> tvolist = new ArrayList<FipTransVO>();
						tvolist.add(transvo);
						List<FipTranslateResultVO> list = constructDesBillWithData(tvolist);
						if(!isMerged){
							fipmessagelist.addAll(list);
							FipBillSumRSVO sumvo = new FipBillSumRSVO();
							sumvo.setBillVO(null);
							sumvo.setMessageinfo(fipBillSumRSVO.getMessageinfo());
							sumvo.setRelationvos(fipBillSumRSVO.getRelationvos());
							sumBillsList.add(sumvo);
						}else{
							disposeResult(list,params);
							// ·
							FipRelationInfoVO[] relationvos = fipBillSumRSVO.getRelationvos();
							if (relationvos != null) {
								String relationID = fipBillSumRSVO.getMessageinfo().getRelationID();
								groupidlist.add(relationID);
								updateSumRelation(relationID, relationvos, desinfo);
							}
						}
					}
					//΢񳡾Ҫݸη
					if(!isMerged){
						params = new HashMap<String,Object>();
						params.put("sumvos", sumBillsList.size() > 0 ? sumBillsList : null);//
						params.put("desinfo", desinfo);//ĿϢ
						if(map != null){
							//ȡȫκ
							params.put("global_batchno", map.get("global_batchno"));
							//ȡκ
							params.put("batchSize", map.get("batchSize"));
						}
						if (oppklist != null && oppklist.size() > 0) {
							params.put("pkList", oppklist);
						}
						disposeResult(fipmessagelist,params);
					}
				}
			}
		}
	}

	private void updateSumRelation(String relationID, FipRelationInfoVO[] relationvos, FipRelationInfoVO desinfo) throws BusinessException {
		BaseDAO baseDAO = new BaseDAO();
		ArrayList<String> pklist = new ArrayList<String>();
		for (int i = 0; i < relationvos.length; i++) {
			FipRelationInfoVO fipRelationInfoVO = relationvos[i];
			if (fipRelationInfoVO == null || pklist.contains(fipRelationInfoVO.getRelationID()))
				continue;
			pklist.add(fipRelationInfoVO.getRelationID());
		}
		String wherepart = SqlTools.getInStr(SumRelationVO.SRC_RELATIONID, pklist, true) + " and " + SumRelationVO.DES_BILLTYPE + "='" + desinfo.getPk_billtype() + "' and " + SumRelationVO.DES_ORG + "='" + desinfo.getPk_org() + "' ";
		String sql = "update " + SumRelationVO.getDefaultTableName() + " set " + SumRelationVO.GROUPID + " ='" + relationID + "' where " + wherepart;
		int upcount = baseDAO.executeUpdate(sql);
		if (upcount != pklist.size())
			throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0047")/* @res "Ѿ˸£ˢݡ" */);
		sql = "update " + OperatingLogVO.getDefaultTableName() + " set " + OperatingLogVO.SUMFLAG + " ='Y' where " + OperatingLogVO.SRC_RELATIONID + "='" + relationID + "' and " + OperatingLogVO.DES_BILLTYPE + "='" + desinfo.getPk_billtype() + "' and " + OperatingLogVO.DES_ORG + "='" + desinfo.getPk_org() + "' ";
		baseDAO.executeUpdate(sql);
		sql = "update " + FipRelationVO.getDefaultTableName() + " set " + FipRelationVO.SUMFLAG + " ='Y' where " + FipRelationVO.SRC_RELATIONID + "='" + relationID + "' and " + FipRelationVO.DES_BILLTYPE + "='" + desinfo.getPk_billtype() + "' and " + FipRelationVO.DES_ORG + "='" + desinfo.getPk_org() + "' ";
		baseDAO.executeUpdate(sql);
	}

	/**
	 * ǻɵļ¼ã
	 * 
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param volist
	 * @throws BusinessException
	 * @see
	 * @since V6.0
	 */
	private void recomputeUnSum(ArrayList<FipBasicRelationVO> volist, Map<String, Object> map) throws BusinessException {
		ArrayList<FipRelationInfoVO> deldeslist = new ArrayList<FipRelationInfoVO>();
		String des_group = null;
		String des_billtype = null;
		HashMap<String, List<FipBasicRelationVO>> billtypemap = new HashMap<String, List<FipBasicRelationVO>>();
		//Ϣ,ǰ˽ʹ
		List<String> pkList = new ArrayList<String>();
		for (FipBasicRelationVO operatingLogVO : volist) {
			// ݵĺϷ
			if (des_group == null)
				des_group = operatingLogVO.getDesRelation().getPk_group();
			else {
				if (!des_group.equals(operatingLogVO.getDesRelation().getPk_group()))
					throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0023")/* @res "ݷΧһֻͬŵͬĿ굥ͽС" */);
			}
			if (des_billtype == null)
				des_billtype = operatingLogVO.getDesRelation().getPk_billtype();
			else {
				if (!des_billtype.equals(operatingLogVO.getDesRelation().getPk_billtype()))
					throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0023")/* @res "ݷΧһֻͬŵͬĿ굥ͽС" */);
			}
			// ¼ҪɾĿ굥
			deldeslist.add((FipRelationInfoVO) operatingLogVO.getDesRelation().clone());
			// Դͷ
			List<FipBasicRelationVO> list = billtypemap.get(operatingLogVO.getSrcRelation().getPk_billtype());
			if (list == null) {
				list = new ArrayList<FipBasicRelationVO>();
				billtypemap.put(operatingLogVO.getSrcRelation().getPk_billtype(), list);
			}
			list.add(operatingLogVO);
			if (StringUtils.isNotBlank(operatingLogVO.getPk_relation())) {
				pkList.add(operatingLogVO.getPk_relation());
			}
		}
		if(des_group != null){
			InvocationInfoProxy.getInstance().setGroupId(des_group);
		}
		Set<String> keyset = billtypemap.keySet();
		ArrayList<FipTranslateResultVO> rslist = new ArrayList<FipTranslateResultVO>();
		for (String billtype : keyset) {
			List<FipBasicRelationVO> list = billtypemap.get(billtype);
			List<FipTranslateResultVO> translist = constructDesBillWithoutData(list);
			if (translist == null || translist.isEmpty())
				continue;
			rslist.addAll(translist);
		}
		Map<String,Object> params = null;
		//УǷ΢,岿߼ֿ
		boolean isMerged = NCCEnv.isMerged();
		if(!isMerged){
			// ɾĿ굥
			// ޳ظݣrelationIDΪ׼Ϊƽ̨relationIDΨһʶĵ
			ArrayList<FipRelationInfoVO> realdellist = new ArrayList<FipRelationInfoVO>();
			HashMap<String, String> samemap = new HashMap<String, String>();
			for (FipRelationInfoVO fipRelationInfoVO : deldeslist) {
				if (fipRelationInfoVO.getRelationID() == null)
					continue;
				if (samemap.get(fipRelationInfoVO.getRelationID()) == null) {
					samemap.put(fipRelationInfoVO.getRelationID(), "");
					realdellist.add(fipRelationInfoVO);
				}
			}
			if (realdellist != null && !realdellist.isEmpty()){
				if(params == null) {
					params = new HashMap<String,Object>();
				}
				//ʱɾʷƾ֤
				params.put("realdellist", realdellist);
			} 
			if(map != null){
				if(params == null) {
					params = new HashMap<String,Object>();
				}
				//ȡȫκ
				params.put("global_batchno", map.get("global_batchno"));
				//ȡκ
				params.put("batchSize", map.get("batchSize"));
			}
			if (pkList != null && pkList.size() > 0) {
				if(params == null) {
					params = new HashMap<String,Object>();
				}
				params.put("pkList", pkList);
			}
			//Ľ
			disposeResult(rslist,params);
		}else{
			//Ľ
			disposeResult(rslist,params);
			IDesBillService itf = FipInterfaceCenter.getDesBillService(des_group, des_billtype);
			// ɾĿ굥
			// ޳ظݣrelationIDΪ׼Ϊƽ̨relationIDΨһʶĵ
			ArrayList<FipRelationInfoVO> realdellist = new ArrayList<FipRelationInfoVO>();
			HashMap<String, String> samemap = new HashMap<String, String>();
			for (FipRelationInfoVO fipRelationInfoVO : deldeslist) {
				if (fipRelationInfoVO.getRelationID() == null)
					continue;
				if (samemap.get(fipRelationInfoVO.getRelationID()) == null) {
					samemap.put(fipRelationInfoVO.getRelationID(), "");
					realdellist.add(fipRelationInfoVO);
				}
			}
			//ʱɾʷƾ֤
			if (realdellist != null && !realdellist.isEmpty())
				if (itf == null)
					throw new BusinessException(FipInterfaceCenter.getNoInterfaceFoundMessage(des_billtype, "IDesBillService"));
			itf.deleteBill(realdellist);
		}
	}

	/*
	 * recomputeByPKsIFipRelationеʵ
	 * 
	 * @see nc.itf.fip.relation.IFipRelation#recomputeByPKs(java.lang.String[])
	 */
	public void recomputeByPKList(Map<String, Object> paramMap) throws BusinessException {
		FipBSCacheCleaner.clearAllCache();
		if (paramMap == null || paramMap.isEmpty())
			return;
		@SuppressWarnings("unchecked")
		List<String> pklist = (List<String>)paramMap.get("pklist");
		if (pklist == null || pklist.isEmpty()) {
			return;
		}
		//ʼredisеļΪ0,̨ɷ,ÿִһ,redisһ,Ҳ1,ȵͷ,Ϊǰ
		//ʾʼredisͻʹüʱĬϸֵΪ0˴ݲʾʼĳûɾredis
		//SagasUtil.processInitCount(global_batchno, FipRedisKeyConst.REBUILD_KEY2);
		//ȫκ
		String global_batchno = (String)paramMap.get("global_batchno");
		//Ƿ
		boolean isUseOrgRule = (boolean)paramMap.get("isUseOrgRule");
		if (isUseOrgRule) {
			//УǷ΢,岿߼ֿ
			boolean isMerged = NCCEnv.isMerged();
			if (!isMerged) {
				//״̬ΪУɾе
				SagasUtil.handleDataInProcess(queryByPKs(pklist.toArray(new String[0])),null);
			}
			NCCSagas.startNewSaga();
			// ϷԣʱΪԴݿɲͬϵͳ֯ĵݣҪĿϵͳ֯ﶼûʽݲſ
			String wherepart = " " + FipRelationVO.SRC_RELATIONID + " in (select " + OperatingLogVO.SRC_RELATIONID + " from " + OperatingLogVO.getDefaultTableName() + " where " + SqlTools.getInStr(OperatingLogVO.PK_OPERATINGLOG, pklist, true) + ")";
			FipRelationVO[] vos = new FipRelationBO().queryByWhere(wherepart);
			if (vos != null && vos.length > 0) {
				throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0024")/* @res "ѡΧвԴѾʽĿ굥ݣ޷ʹõѡѡ㷶Χ㷽ʽ" */);
			}
			BaseDAO dao = new BaseDAO();
			String upsql1 = "update " + OperatingLogVO.getDefaultTableName() + " set " + OperatingLogVO.OPERATEFLAG + "=99 where " + wherepart;
			dao.executeUpdate(upsql1);
			String delsql1 = "delete from " + OperatingLogVO.getDefaultTableName() + " where " + OperatingLogVO.PK_OPERATINGLOG + ">(select min(" + OperatingLogVO.PK_OPERATINGLOG + ") from " + OperatingLogVO.getDefaultTableName() + " a where a." + OperatingLogVO.SRC_ORG + "=" + OperatingLogVO.getDefaultTableName() + "." + OperatingLogVO.SRC_ORG + " and a." + OperatingLogVO.SRC_BILLTYPE + "="
					+ OperatingLogVO.getDefaultTableName() + "." + OperatingLogVO.SRC_BILLTYPE + " and a." + OperatingLogVO.SRC_RELATIONID + "=" + OperatingLogVO.getDefaultTableName() + "." + OperatingLogVO.SRC_RELATIONID + " and a." + OperatingLogVO.OPERATEFLAG + "=" + OperatingLogVO.getDefaultTableName() + "." + OperatingLogVO.OPERATEFLAG + ") and " + OperatingLogVO.OPERATEFLAG + "=99";
			dao.executeUpdate(delsql1);
			OperatingLogVO[] tmpvos = queryByWhere(" " + OperatingLogVO.OPERATEFLAG + "=99 ");
			String delsql2 = "delete from " + OperatingLogVO.getDefaultTableName() + " where " + OperatingLogVO.OPERATEFLAG + "=99";
			dao.executeUpdate(delsql2);
			if (tmpvos != null && tmpvos.length > 0) {
				HashMap<String, List<OperatingLogVO>> billmap = new HashMap<String, List<OperatingLogVO>>();
				for (OperatingLogVO operatingLogVO : tmpvos) {
					String src_billtype = operatingLogVO.getSrc_billtype();
					List<OperatingLogVO> list = billmap.get(src_billtype);
					if (list == null) {
						list = new ArrayList<OperatingLogVO>();
						billmap.put(src_billtype, list);
					}
					list.add(operatingLogVO);
				}
				if (!billmap.isEmpty()) {
					Set<Entry<String, List<OperatingLogVO>>> entrySet = billmap.entrySet();
					for (Entry<String, List<OperatingLogVO>> entry : entrySet) {
						List<OperatingLogVO> volist = entry.getValue();
						String src_billtype = entry.getKey();
						List<FipRelationInfoVO> srcinfo = new ArrayList<FipRelationInfoVO>();
						Collection<FipExtendAggVO> billlist = null;
						for (OperatingLogVO operatingLogVO : volist) {
							srcinfo.add(FipBasicRelationVO.convertFromOperatingVO(operatingLogVO).getSrcRelation());
						}
						
						if (volist != null && !volist.isEmpty()) {
							String src_group = volist.get(0).getSrc_group();
							//УǷΪϵͳ
							TXMsgDataUtil.checkTXMsgDataType(src_group, src_billtype);
							if(!isMerged){
								//ȡηӿ
								IFipInterfaceCenterService destService = SagasUtil.getFipInterfaceCenterService(src_billtype);
								Map<String,Serializable> params = new HashMap<String,Serializable>();
								params.put("pk_group", src_group);
								params.put("billtype", src_billtype);
								billlist = destService.queryBillByRelations(params, srcinfo);
							}else{
								IBillReflectorService ib = FipInterfaceCenter.getBillReflectorService(src_group, src_billtype);
								if (ib == null)
									throw new BusinessException(FipInterfaceCenter.getNoInterfaceFoundMessage(src_billtype, "IBillReflectorService"));
								billlist = ib.queryBillByRelations(srcinfo);
							}
							
							HashMap<String, FipExtendAggVO> map = new HashMap<String, FipExtendAggVO>();
							if (billlist != null && !billlist.isEmpty()) {
								for (FipExtendAggVO fipExtendAggVO : billlist) {
									map.put(fipExtendAggVO.getRelationID(), fipExtendAggVO);
								}
							}
							FipMessageVO[] fipmessagevos = new FipMessageVO[volist.size()];
							StringBuffer sb = new StringBuffer();
							for (int i = 0; i < fipmessagevos.length; i++) {
								fipmessagevos[i] = new FipMessageVO();
								FipExtendAggVO fipExtendAggVO = map.get(srcinfo.get(i).getRelationID());
								if (fipExtendAggVO == null) {
									sb.append(",").append(srcinfo.get(i).getRelationID());
									continue;
								}
								if(!NCCEnv.isMerged()){
									if (fipExtendAggVO.getMessageinfo() != null){
										fipExtendAggVO.getMessageinfo().setBatchno(global_batchno);
										fipmessagevos[i].setMessageinfo(fipExtendAggVO.getMessageinfo());
									}else{
										srcinfo.get(i).setBatchno(global_batchno);
										fipmessagevos[i].setMessageinfo(srcinfo.get(i));
									}
								}else{
									if (fipExtendAggVO.getMessageinfo() != null)
										fipmessagevos[i].setMessageinfo(fipExtendAggVO.getMessageinfo());
									else
										fipmessagevos[i].setMessageinfo(srcinfo.get(i));
								}
								fipmessagevos[i].setMessagetype(FipMessageVO.MESSAGETYPE_ADD);
								fipmessagevos[i].setBillVO(fipExtendAggVO.getBillVO());
							}
							if (sb.length() > 0) {
								throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("common", "MC7", null, new String[] { nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("common", "UC000-0002747")/* @res "Դ" */+ src_billtype + ":", "[" + sb.substring(1) + "]" })/* @res "{0}{1}" */);
							}
							new FipMessageBO().sendMessages(fipmessagevos);
						}
					}
				}
			}
			return;
		}
		Map<String,Object> recomputeMap = null;
		if(!NCCEnv.isMerged()){
			recomputeMap = new HashMap<String,Object>();
			// ȡ
			Integer batchSize = computeBatchSize(pklist);
			//
			recomputeMap.put("batchSize", batchSize);
			//ȫκ
			recomputeMap.put("global_batchno", global_batchno);
		}
		int runthreadlimit = 1000;// ̫Сʱ򣬶̲߳û̫Եƣӷѹ
		int listsize = pklist.size();
		if (listsize > runthreadlimit) {
			// ȡ
			String serviceName = MiddlewareRuntimeEnvironment.get(IConfigKey.Keys.APP_CODE);
			// жǷԭ
		    if (serviceName != null) {
		    	recomputeByPKs_CloudDist(pklist, recomputeMap);
		    } else {
		    	recomputeByPKs_PrimitiveDist(pklist);
		    }
		} else {
			// ̫٣ֵ̼߳
			recomputeByPKs_RequiresNew(pklist, recomputeMap);
		}
	}
	
	/*
	 * recomputeByPKsIFipRelationеʵ
	 * 
	 * @see nc.itf.fip.relation.IFipRelation#recomputeByPKs(java.lang.String[])
	 */
	public void recomputeByPKList(List<String> pklist, boolean isUseOrgRule) throws BusinessException {
		FipBSCacheCleaner.clearAllCache();
		if (pklist == null || pklist.isEmpty())
			return;
		if (isUseOrgRule) {
			// ϷԣʱΪԴݿɲͬϵͳ֯ĵݣҪĿϵͳ֯ﶼûʽݲſ
			String wherepart = " " + FipRelationVO.SRC_RELATIONID + " in (select " + OperatingLogVO.SRC_RELATIONID + " from " + OperatingLogVO.getDefaultTableName() + " where " + SqlTools.getInStr(OperatingLogVO.PK_OPERATINGLOG, pklist, true) + ")";
			FipRelationVO[] vos = new FipRelationBO().queryByWhere(wherepart);
			if (vos != null && vos.length > 0) {
				throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0024")/* @res "ѡΧвԴѾʽĿ굥ݣ޷ʹõѡѡ㷶Χ㷽ʽ" */);
			}
			BaseDAO dao = new BaseDAO();
			String upsql1 = "update " + OperatingLogVO.getDefaultTableName() + " set " + OperatingLogVO.OPERATEFLAG + "=99 where " + wherepart;
			dao.executeUpdate(upsql1);
			String delsql1 = "delete from " + OperatingLogVO.getDefaultTableName() + " where " + OperatingLogVO.PK_OPERATINGLOG + ">(select min(" + OperatingLogVO.PK_OPERATINGLOG + ") from " + OperatingLogVO.getDefaultTableName() + " a where a." + OperatingLogVO.SRC_ORG + "=" + OperatingLogVO.getDefaultTableName() + "." + OperatingLogVO.SRC_ORG + " and a." + OperatingLogVO.SRC_BILLTYPE + "="
					+ OperatingLogVO.getDefaultTableName() + "." + OperatingLogVO.SRC_BILLTYPE + " and a." + OperatingLogVO.SRC_RELATIONID + "=" + OperatingLogVO.getDefaultTableName() + "." + OperatingLogVO.SRC_RELATIONID + " and a." + OperatingLogVO.OPERATEFLAG + "=" + OperatingLogVO.getDefaultTableName() + "." + OperatingLogVO.OPERATEFLAG + ") and " + OperatingLogVO.OPERATEFLAG + "=99";
			dao.executeUpdate(delsql1);
			OperatingLogVO[] tmpvos = queryByWhere(" " + OperatingLogVO.OPERATEFLAG + "=99 ");
			String delsql2 = "delete from " + OperatingLogVO.getDefaultTableName() + " where " + OperatingLogVO.OPERATEFLAG + "=99";
			dao.executeUpdate(delsql2);
			if (tmpvos != null && tmpvos.length > 0) {
				HashMap<String, List<OperatingLogVO>> billmap = new HashMap<String, List<OperatingLogVO>>();
				for (OperatingLogVO operatingLogVO : tmpvos) {
					String src_billtype = operatingLogVO.getSrc_billtype();
					List<OperatingLogVO> list = billmap.get(src_billtype);
					if (list == null) {
						list = new ArrayList<OperatingLogVO>();
						billmap.put(src_billtype, list);
					}
					list.add(operatingLogVO);
				}
				//УǷ΢,岿߼ֿ
				boolean isMerged = NCCEnv.isMerged();
				if (!billmap.isEmpty()) {
					Set<Entry<String, List<OperatingLogVO>>> entrySet = billmap.entrySet();
					for (Entry<String, List<OperatingLogVO>> entry : entrySet) {
						List<OperatingLogVO> volist = entry.getValue();
						String src_billtype = entry.getKey();
						List<FipRelationInfoVO> srcinfo = new ArrayList<FipRelationInfoVO>();
						Collection<FipExtendAggVO> billlist = null;
						for (OperatingLogVO operatingLogVO : volist) {
							srcinfo.add(FipBasicRelationVO.convertFromOperatingVO(operatingLogVO).getSrcRelation());
						}
						
						if (volist != null && !volist.isEmpty()) {
							String src_group = volist.get(0).getSrc_group();
							//УǷΪϵͳ
							TXMsgDataUtil.checkTXMsgDataType(src_group, src_billtype);
							if(!isMerged){
								//ȡηӿ
								IFipInterfaceCenterService destService = SagasUtil.getFipInterfaceCenterService(src_billtype);
								Map<String,Serializable> params = new HashMap<String,Serializable>();
								params.put("pk_group", src_group);
								params.put("billtype", src_billtype);
								billlist = destService.queryBillByRelations(params, srcinfo);
							}else{
								IBillReflectorService ib = FipInterfaceCenter.getBillReflectorService(src_group, src_billtype);
								if (ib == null)
									throw new BusinessException(FipInterfaceCenter.getNoInterfaceFoundMessage(src_billtype, "IBillReflectorService"));
								billlist = ib.queryBillByRelations(srcinfo);
							}
							
							HashMap<String, FipExtendAggVO> map = new HashMap<String, FipExtendAggVO>();
							if (billlist != null && !billlist.isEmpty()) {
								for (FipExtendAggVO fipExtendAggVO : billlist) {
									map.put(fipExtendAggVO.getRelationID(), fipExtendAggVO);
								}
							}
							FipMessageVO[] fipmessagevos = new FipMessageVO[volist.size()];
							StringBuffer sb = new StringBuffer();
							for (int i = 0; i < fipmessagevos.length; i++) {
								fipmessagevos[i] = new FipMessageVO();
								FipExtendAggVO fipExtendAggVO = map.get(srcinfo.get(i).getRelationID());
								if (fipExtendAggVO == null) {
									sb.append(",").append(srcinfo.get(i).getRelationID());
									continue;
								}
								if (fipExtendAggVO.getMessageinfo() != null)
									fipmessagevos[i].setMessageinfo(fipExtendAggVO.getMessageinfo());
								else
									fipmessagevos[i].setMessageinfo(srcinfo.get(i));
								fipmessagevos[i].setMessagetype(FipMessageVO.MESSAGETYPE_ADD);
								fipmessagevos[i].setBillVO(fipExtendAggVO.getBillVO());
							}
							if (sb.length() > 0) {
								throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("common", "MC7", null, new String[] { nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("common", "UC000-0002747")/* @res "Դ" */+ src_billtype + ":", "[" + sb.substring(1) + "]" })/* @res "{0}{1}" */);
							}
							new FipMessageBO().sendMessages(fipmessagevos);
						}
					}
				}
			}
			return;
		}
		int runthreadlimit = 1000;// ̫Сʱ򣬶̲߳û̫Եƣӷѹ
		int listsize = pklist.size();
		if (listsize > runthreadlimit) {
			if (!ServerConfiguration.getServerConfiguration().isSingle()) {
				// ȺģʽԽ
				boolean canRunThread = !ServerConfiguration.getServerConfiguration().isMaster();
				String masterURL = ServerConfiguration.getServerConfiguration().getMasterEndpointURL();
				if (canRunThread) {
					LiveServerAgent ip = NCLocator.getInstance().lookup(LiveServerAgent.class);
					ServerInstance[] svi = ip.getServerInstances();
					HashMap<String, String> serverURLmap = new HashMap<String, String>();// ¼Ѿʹ˵ķURLֹظø÷
					serverURLmap.put(":" + masterURL + ":", "master");// masterϲҵԵȷ˵ʱҪųmaster
					ArrayList<RecomputeCallable<Object>> calllist = new ArrayList<RecomputeCallable<Object>>();
					RecomputeCallable<Object> selfproxy = null; // ķ
					for (int i = 0; i < svi.length; i++) {
						Properties prop = new Properties();
						prop.setProperty(NCLocator.SERVICEDISPATCH_URL, ServerConfiguration.getServerConfiguration().getServerEndpointURL(svi[i].getName()));
						// prop.setProperty(NCLocator.LOCATOR_PROVIDER_PROPERTY, ModuleNCLocator.class.getName());
						prop.setProperty(NCLocator.TARGET_MODULE, "fip");
						String key = ":" + prop.getProperty(NCLocator.SERVICEDISPATCH_URL) + ":";
						if (serverURLmap.get(key) == null) {
							final IOperatingLog ipt = NCLocator.getInstance(prop).lookup(IOperatingLog.class);
							final String datasource = InvocationInfoProxy.getInstance().getUserDataSource();
							final String langcode = InvocationInfoProxy.getInstance().getLangCode();
							final String userid = InvocationInfoProxy.getInstance().getUserId();
							final String loglevel = InvocationInfoProxy.getInstance().getLogLevel();
							final String groupid = InvocationInfoProxy.getInstance().getGroupId();
							if (ipt != null) {
								RecomputeCallable<Object> c = new RecomputeCallable<Object>() {
									@Override
									public Object call() throws Exception {
										InvocationInfoProxy.getInstance().setUserDataSource(datasource);
										InvocationInfoProxy.getInstance().setLangCode(langcode);
										InvocationInfoProxy.getInstance().setUserId(userid);
										InvocationInfoProxy.getInstance().setLogLevel(loglevel);
										InvocationInfoProxy.getInstance().setGroupId(groupid);
										preProcess();
										try {
											ipt.recomputeByPKs_RequiresNew(getPklist(), null);
											postProcess();
											return Boolean.TRUE;
										} catch (Exception e) {
											postErrorProcess(e);
											throw e;
										} finally {
											clearProcess();
										}
									}
								};
								if (prop.getProperty(NCLocator.SERVICEDISPATCH_URL).equals(ServerConfiguration.getServerConfiguration().getServerEndpointURL(ServerConfiguration.getServerConfiguration().getServerName())))
									selfproxy = c;
								calllist.add(c);
								serverURLmap.put(key, key);
							} else {
								serverURLmap.put(key, "deadserver");
							}
						}
					}
					if (calllist.isEmpty()) {
						// ûлķ
						recomputeByPKs_RequiresNew(pklist, null);
					} else {
						int servercount = calllist.size();
						if (servercount > 5) {
							// ķ5ʱ򣬿԰ѱΪʹãԼҵ
							if (selfproxy != null) {
								calllist.remove(selfproxy);
							}
						}
						servercount = calllist.size();
						if (servercount > 10) {
							// ķ10ʱΪֹֻ̫̣߳ʹ10
							servercount = 10;
						}
						int groupcount = (listsize / servercount) + 1;
						ArrayList<FutureTask<Object>> futurelist = new ArrayList<FutureTask<Object>>();
						for (int i = 0; i < servercount; i++) {
							List<String> sublist;
							if (i == servercount - 1) {
								sublist = pklist.subList(groupcount * i, listsize);
							} else {
								sublist = pklist.subList(groupcount * i, groupcount * i + groupcount);
							}
							ArrayList<String> tmplist = new ArrayList<String>();
							tmplist.addAll(sublist);
							calllist.get(i).setPklist(tmplist);
							FutureTask<Object> f = new FutureTask<Object>(calllist.get(i));
							futurelist.add(f);
							Executor e = new Executor(f, "RecomputeCallableThread4Servers" + i);
							e.start();
						}
						for (FutureTask<Object> futureTask : futurelist) {
							try {
								futureTask.get(groupcount * 300, TimeUnit.MILLISECONDS);
							} catch (InterruptedException e) {
								Logger.error("", e);
							} catch (ExecutionException e) {
								Logger.error("", e);
								// ִִ̳
								if (e.getCause() instanceof BusinessException)
									throw (BusinessException) e.getCause();
							} catch (TimeoutException e) {
								// ʱ󣬿ܽ
								if (!futureTask.isDone() && !futureTask.isCancelled())
									futureTask.cancel(true);
								// ִִ̳
							}
						}
					}
				} else {
					// master̡߳ȻҵӦñȵmasterϣߵӦǴķ֧ݴҵȥ
					recomputeByPKs_RequiresNew(pklist, null);
				}
			} else {
				// ǼȺģʽ޷ʹöмɢѹ
				recomputeByPKs_RequiresNew(pklist, null);
			}
		} else {
			// ̫٣ֵ̼߳
			recomputeByPKs_RequiresNew(pklist, null);
		}
	}
	
	//㳡
	private Integer computeBatchSize(List<String> pklist) throws BusinessException{
		Integer batchSize = 0;
		int runthreadlimit = 1000;// ̫Сʱ򣬶̲߳û̫Եƣӷѹ
		int listsize = pklist.size();
		if (listsize > runthreadlimit) {
			String serviceName = MiddlewareRuntimeEnvironment.get(IConfigKey.Keys.APP_CODE);//ȡ
			// жǷԭ
		    if (serviceName != null) {
		    	SystemInfo sysinfo = getSysInfo();
			    IpAndPort[] ipp = sysinfo.getIps();
			    // 
			    if (ipp.length == 1) {
			    	// ǰserver
			    	batchSize = batchSize + computeSingleServerBatchSize(pklist);
			    } else {
					HashMap<String, String> serverURLmap = new HashMap<String, String>();// ¼Ѿʹ˵ķURLֹظø÷
					ArrayList<String> calllist = new ArrayList<String>();
					IpAndPort localIpPort = getLocalIpPortCloud();// IPPort
					for (int i = 0; i < ipp.length; i++) {
						Properties prop = new Properties();
					    prop.setProperty(NCLocator.SERVICEDISPATCH_URL, getUrl(ipp[i]));
						String key = ":" + prop.getProperty(NCLocator.SERVICEDISPATCH_URL) + ":";
						if (serverURLmap.get(key) == null) {
							// ΪʹãԼҵ
							if (!prop.getProperty(NCLocator.SERVICEDISPATCH_URL).equals(getUrl(localIpPort))){
								calllist.add(key);
								serverURLmap.put(key, key);
							}
						}
					}
					if (!calllist.isEmpty()) {
						int servercount = calllist.size();
						if (servercount > 10) {
							// ķ10ʱΪֹֻ̫̣߳ʹ10
							servercount = 10;
						}
						int groupcount = (listsize / servercount) + 1;
						for (int i = 0; i < servercount; i++) {
							List<String> sublist;
							if (i == servercount - 1) {
								sublist = pklist.subList(groupcount * i, listsize);
							} else {
								sublist = pklist.subList(groupcount * i, groupcount * i + groupcount);
							}
							ArrayList<String> tmplist = new ArrayList<String>();
							tmplist.addAll(sublist);
							//server
							batchSize = batchSize + computeSingleServerBatchSize(tmplist);
						}
					}
			    }
		    } 
		} else {
			// ǰserver
	    	batchSize = batchSize + computeSingleServerBatchSize(pklist);
		}
		return batchSize;
	}
	
	//㵥serverķ
	private Integer computeSingleServerBatchSize(List<String> pklist) throws BusinessException{
		Integer batchSize = 0;
		int threadcount = 3;
		int runthreadlimit = 100;// ̫Сʱ򣬶̲߳û̫Եƣӷѹ
		int listsize = pklist.size();
		if (listsize > runthreadlimit) {
			int groupcount = (listsize / threadcount) + 1;
			for (int i = 0; i < threadcount; i++) {
				List<String> sublist;
				if (i == threadcount - 1) {
					sublist = pklist.subList(groupcount * i, listsize);
				} else {
					sublist = pklist.subList(groupcount * i, groupcount * i + groupcount);
				}
				ArrayList<String> tmplist = new ArrayList<String>();
				tmplist.addAll(sublist);
				//server
				batchSize = batchSize + computeDataBatchSize(tmplist);
			}
		} else {
			//ǰserver
			batchSize = batchSize + computeDataBatchSize(pklist);
		}
		return batchSize;
	}
	
	//ҵݷ
	private Integer computeDataBatchSize(List<String> pklist) throws BusinessException{
		Integer batchSize = 0;
		String wherepart = SqlTools.getInStr("pk_operatinglog", pklist, true);
		BaseDAO dao = new BaseDAO();
		Collection<OperatingLogVO> opvolist = dao.retrieveByClause(OperatingLogVO.class, wherepart);
		if (opvolist == null || opvolist.isEmpty()){
			return batchSize;
		}
		ArrayList<FipBasicRelationVO> volist = new ArrayList<FipBasicRelationVO>();
		ArrayList<FipBasicRelationVO> sumvolist = new ArrayList<FipBasicRelationVO>();
		for (OperatingLogVO operatingLogVO : opvolist) {
			if (operatingLogVO.getSumflag() != null && operatingLogVO.getSumflag().booleanValue()) {
				// ɵļ¼
				sumvolist.add(FipBasicRelationVO.convertFromOperatingVO(operatingLogVO));
			} else {
				// ǻɵļ¼
				volist.add(FipBasicRelationVO.convertFromOperatingVO(operatingLogVO));
			}
		}
		if (!volist.isEmpty()){
			batchSize = batchSize + 1 * 2;
		}
		if (!sumvolist.isEmpty()){
			ArrayList<String> grouplist = new ArrayList<String>();
			for (FipBasicRelationVO vo : sumvolist) {
				grouplist.add(vo.getSrcRelation().getRelationID());
			}
			// ѯܵԴϢ
			SumRelationVO[] sumvos = new FipSumRelationProxy().queryByWhere(SqlTools.getInStr("groupid", grouplist, true));
			if (sumvos != null){
				// Դͺͷŷ
				HashMap<String, String> groupbill = new HashMap<String, String>();
				for (int i = 0; i < sumvos.length; i++) {
					SumRelationVO vo = sumvos[i];
					if (vo == null)
						continue;
					String pk_billtype = groupbill.get(vo.getSrc_billtype());
					if (pk_billtype == null) {
						groupbill.put(vo.getSrc_billtype(), vo.getSrc_billtype());
					}
				}
				batchSize = batchSize + groupbill.keySet().size() * 2;
			}
		}
		return batchSize;
	}
	
	//ȡطϢ
	private IpAndPort getLocalIpPortCloud() throws BusinessException{
		IpAndPort ipAndPort;
		try {
			ipAndPort = IpAndPortUtils.getLocalIpPortCloud();
			return ipAndPort;
		} catch (Exception ex) {
			throw new BusinessException(ex);
		}
	}
	
	//ȡserverϢ
	private SystemInfo getSysInfo() throws BusinessException {
		try{
			IDistributedEnv env = DistEnvFactory.getInstance().getDistributedEnv();
		    SystemInfo info = env.getDistEnv();
		    return info;
		}catch(Exception ex){
			throw new BusinessException(ex);
		}
	}
	
	private String getUrl(IpAndPort ipp) {
	    String urlPostfix = "/ServiceDispatcherServlet";
	    String prefix = "http://";
	    String masterUrl = ServerConfiguration.getServerConfiguration().getMasterEndpointURL();
	    if (masterUrl.startsWith("https")) {
	    	prefix = "https://";
	    }
	    String url = prefix + ipp.getIp() + ":" + ipp.getPort() + urlPostfix;
	    return url;
	}
	
	//ԭ
	private void recomputeByPKs_CloudDist(List<String> pklist, Map<String,Object> recomputeMap) throws BusinessException{
		long start = System.currentTimeMillis();
		// ȡϢ
	    SystemInfo sysinfo = this.getSysInfo();
	    IpAndPort[] ipp = sysinfo.getIps();
	    // 
	    if (ipp.length == 1) {
	    	// serverģʽ޷ʹöмɢѹ
	    	recomputeByPKs_RequiresNew(pklist, recomputeMap);
	    } else {
	    	int listsize = pklist.size();
			HashMap<String, String> serverURLmap = new HashMap<String, String>();// ¼Ѿʹ˵ķURLֹظø÷
			ArrayList<RecomputeCallable<Object>> calllist = new ArrayList<RecomputeCallable<Object>>();
			IpAndPort localIpPort = this.getLocalIpPortCloud();// IPPort
			for (int i = 0; i < ipp.length; i++) {
				Properties prop = new Properties();
			    prop.setProperty(NCLocator.SERVICEDISPATCH_URL,this.getUrl(ipp[i]));
			    prop.setProperty(NCLocator.LOCATOR_PROVIDER_PROPERTY,"nc.bs.framework.rmi.RmiNCLocator");
				String key = ":" + prop.getProperty(NCLocator.SERVICEDISPATCH_URL) + ":";
				if (serverURLmap.get(key) == null) {
					final IOperatingLog ipt = NCLocator.getInstance(prop).lookup(IOperatingLog.class);
					final String datasource = InvocationInfoProxy.getInstance().getUserDataSource();
					final String langcode = InvocationInfoProxy.getInstance().getLangCode();
					final String userid = InvocationInfoProxy.getInstance().getUserId();
					final String loglevel = InvocationInfoProxy.getInstance().getLogLevel();
					final String groupid = InvocationInfoProxy.getInstance().getGroupId();
					final String callid = InvocationInfoProxy.getInstance().getCallId();
					String env = "nc.bs.framework.core.service.RequestAttributeManager";
					IAttributeManager manager = (IAttributeManager) NCLocator.getInstance().lookup(env);
					Object tabid = manager.getAttribute("tabid");
					recomputeMap.put("tabid", tabid);
					final Map<String,Object> map = recomputeMap;
					if (ipt != null) {
						RecomputeCallable<Object> c = new RecomputeCallable<Object>() {
							@Override
							public Object call() throws Exception {
								InvocationInfoProxy.getInstance().setUserDataSource(datasource);
								InvocationInfoProxy.getInstance().setLangCode(langcode);
								InvocationInfoProxy.getInstance().setUserId(userid);
								InvocationInfoProxy.getInstance().setLogLevel(loglevel);
								InvocationInfoProxy.getInstance().setGroupId(groupid);
								InvocationInfoProxy.getInstance().setCallId(callid);
								preProcess();
								try {
									ipt.recomputeByPKs_RequiresNew(getPklist(), map);
									postProcess();
									return Boolean.TRUE;
								} catch (Exception e) {
									postErrorProcess(e);
									throw e;
								} finally {
									clearProcess();
								}
							}
						};
						// ΪʹãԼҵ
						if (!prop.getProperty(NCLocator.SERVICEDISPATCH_URL).equals(this.getUrl(localIpPort))){
							calllist.add(c);
							serverURLmap.put(key, key);
						}
					} else {
						serverURLmap.put(key, "deadserver");
					}
				}
			}
			if (calllist.isEmpty()) {
				// ûлķ
				recomputeByPKs_RequiresNew(pklist, recomputeMap);
			} else {
				int servercount = calllist.size();
				if (servercount > 10) {
					// ķ10ʱΪֹֻ̫̣߳ʹ10
					servercount = 10;
				}
				int groupcount = (listsize / servercount) + 1;
				ArrayList<FutureTask<Object>> futurelist = new ArrayList<FutureTask<Object>>();
				for (int i = 0; i < servercount; i++) {
					List<String> sublist;
					if (i == servercount - 1) {
						sublist = pklist.subList(groupcount * i, listsize);
					} else {
						sublist = pklist.subList(groupcount * i, groupcount * i + groupcount);
					}
					ArrayList<String> tmplist = new ArrayList<String>();
					tmplist.addAll(sublist);
					calllist.get(i).setPklist(tmplist);
					FutureTask<Object> f = new FutureTask<Object>(calllist.get(i));
					futurelist.add(f);
					Executor e = new Executor(f, "RecomputeCallableThread4Servers" + i);
					e.start();
				}
				for (FutureTask<Object> futureTask : futurelist) {
					try {
						futureTask.get(groupcount * 300, TimeUnit.MILLISECONDS);
					} catch (InterruptedException e) {
						Logger.error("", e);
					} catch (ExecutionException e) {
						Logger.error("", e);
						// ִִ̳
						if (e.getCause() instanceof BusinessException)
							throw (BusinessException) e.getCause();
					} catch (TimeoutException e) {
						// ʱ󣬿ܽ
						if (!futureTask.isDone() && !futureTask.isCancelled())
							futureTask.cancel(true);
						// ִִ̳
					}
				}
			}
	    }
	    long end = System.currentTimeMillis();
	    Logger.error("[FIP Distribute] total cost ms " + (end - start));
	}
	
	//˽л
	private void recomputeByPKs_PrimitiveDist(List<String> pklist) throws BusinessException{
		int listsize = pklist.size();
		if (!ServerConfiguration.getServerConfiguration().isSingle()) {
			// ȺģʽԽ
			boolean canRunThread = !ServerConfiguration.getServerConfiguration().isMaster();
			String masterURL = ServerConfiguration.getServerConfiguration().getMasterEndpointURL();
			if (canRunThread) {
				LiveServerAgent ip = NCLocator.getInstance().lookup(LiveServerAgent.class);
				ServerInstance[] svi = ip.getServerInstances();
				HashMap<String, String> serverURLmap = new HashMap<String, String>();// ¼Ѿʹ˵ķURLֹظø÷
				serverURLmap.put(":" + masterURL + ":", "master");// masterϲҵԵȷ˵ʱҪųmaster
				ArrayList<RecomputeCallable<Object>> calllist = new ArrayList<RecomputeCallable<Object>>();
				RecomputeCallable<Object> selfproxy = null; // ķ
				for (int i = 0; i < svi.length; i++) {
					Properties prop = new Properties();
					prop.setProperty(NCLocator.SERVICEDISPATCH_URL, ServerConfiguration.getServerConfiguration().getServerEndpointURL(svi[i].getName()));
					// prop.setProperty(NCLocator.LOCATOR_PROVIDER_PROPERTY, ModuleNCLocator.class.getName());
					prop.setProperty(NCLocator.TARGET_MODULE, "fip");
					String key = ":" + prop.getProperty(NCLocator.SERVICEDISPATCH_URL) + ":";
					if (serverURLmap.get(key) == null) {
						final IOperatingLog ipt = NCLocator.getInstance(prop).lookup(IOperatingLog.class);
						final String datasource = InvocationInfoProxy.getInstance().getUserDataSource();
						final String langcode = InvocationInfoProxy.getInstance().getLangCode();
						final String userid = InvocationInfoProxy.getInstance().getUserId();
						final String loglevel = InvocationInfoProxy.getInstance().getLogLevel();
						final String groupid = InvocationInfoProxy.getInstance().getGroupId();
						if (ipt != null) {
							RecomputeCallable<Object> c = new RecomputeCallable<Object>() {
								@Override
								public Object call() throws Exception {
									InvocationInfoProxy.getInstance().setUserDataSource(datasource);
									InvocationInfoProxy.getInstance().setLangCode(langcode);
									InvocationInfoProxy.getInstance().setUserId(userid);
									InvocationInfoProxy.getInstance().setLogLevel(loglevel);
									InvocationInfoProxy.getInstance().setGroupId(groupid);
									preProcess();
									try {
										ipt.recomputeByPKs_RequiresNew(getPklist(), null);
										postProcess();
										return Boolean.TRUE;
									} catch (Exception e) {
										postErrorProcess(e);
										throw e;
									} finally {
										clearProcess();
									}
								}
							};
							if (prop.getProperty(NCLocator.SERVICEDISPATCH_URL).equals(ServerConfiguration.getServerConfiguration().getServerEndpointURL(ServerConfiguration.getServerConfiguration().getServerName())))
								selfproxy = c;
							calllist.add(c);
							serverURLmap.put(key, key);
						} else {
							serverURLmap.put(key, "deadserver");
						}
					}
				}
				if (calllist.isEmpty()) {
					// ûлķ
					recomputeByPKs_RequiresNew(pklist, null);
				} else {
					int servercount = calllist.size();
					if (servercount > 5) {
						// ķ5ʱ򣬿԰ѱΪʹãԼҵ
						if (selfproxy != null) {
							calllist.remove(selfproxy);
						}
					}
					servercount = calllist.size();
					if (servercount > 10) {
						// ķ10ʱΪֹֻ̫̣߳ʹ10
						servercount = 10;
					}
					int groupcount = (listsize / servercount) + 1;
					ArrayList<FutureTask<Object>> futurelist = new ArrayList<FutureTask<Object>>();
					for (int i = 0; i < servercount; i++) {
						List<String> sublist;
						if (i == servercount - 1) {
							sublist = pklist.subList(groupcount * i, listsize);
						} else {
							sublist = pklist.subList(groupcount * i, groupcount * i + groupcount);
						}
						ArrayList<String> tmplist = new ArrayList<String>();
						tmplist.addAll(sublist);
						calllist.get(i).setPklist(tmplist);
						FutureTask<Object> f = new FutureTask<Object>(calllist.get(i));
						futurelist.add(f);
						Executor e = new Executor(f, "RecomputeCallableThread4Servers" + i);
						e.start();
					}
					for (FutureTask<Object> futureTask : futurelist) {
						try {
							futureTask.get(groupcount * 300, TimeUnit.MILLISECONDS);
						} catch (InterruptedException e) {
							Logger.error("", e);
						} catch (ExecutionException e) {
							Logger.error("", e);
							// ִִ̳
							if (e.getCause() instanceof BusinessException)
								throw (BusinessException) e.getCause();
						} catch (TimeoutException e) {
							// ʱ󣬿ܽ
							if (!futureTask.isDone() && !futureTask.isCancelled())
								futureTask.cancel(true);
							// ִִ̳
						}
					}
				}
			} else {
				// master̡߳ȻҵӦñȵmasterϣߵӦǴķ֧ݴҵȥ
				recomputeByPKs_RequiresNew(pklist, null);
			}
		} else {
			// ǼȺģʽ޷ʹöмɢѹ
			recomputeByPKs_RequiresNew(pklist, null);
		}
	}

	/*
	 * recomputeByWhereIFipRelationеʵ
	 * 
	 * @see nc.itf.fip.relation.IFipRelation#recomputeByWhere(java.lang.String)
	 */
	public void recomputeByWhere(String wherepart, boolean isUseOrgRule) throws BusinessException {
		if (wherepart == null)
			return;
		List<String> pklist = null;
		try {
			// wherepart = SQL_Translator.getSQL(new BaseDAO().getDBType(), wherepart);
			pklist = new FipOperatingLogDAO().queryPKListByWhere(wherepart);
		} catch (DbException e) {
			Logger.error("", e);
			throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0025")/* @res "̷" */, e);
		}
		recomputeByPKList(pklist, isUseOrgRule);
	}
	
	/*
	 * recomputeByWhereIFipRelationеʵ
	 * 
	 * @see nc.itf.fip.relation.IFipRelation#recomputeByWhere(java.lang.String)
	 */
	public void recomputeByWhere(Map<String, Object> map) throws BusinessException {
		if (map == null || map.get("queryWhere") == null)
			return;
		List<String> pklist = null;
		try {
			// wherepart = SQL_Translator.getSQL(new BaseDAO().getDBType(), wherepart);
			pklist = new FipOperatingLogDAO().queryPKListByWhere((String)map.get("queryWhere"));
			map.put("pklist", pklist);
		} catch (DbException e) {
			Logger.error("", e);
			throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0025")/* @res "̷" */, e);
		}
		recomputeByPKList(map);
	}

	/*
	 * recomputeIFipRelationеʵ
	 * 
	 * @see nc.itf.fip.relation.IFipRelation#recompute(nc.vo.fip.relation.FipRelationVO[])
	 */
	public void recompute(OperatingLogVO[] vos) throws BusinessException {
		// ܼ¼ͷǻܼ¼Ҫֿ
		if (ServerDistributeCenter.getServerCount() > 1) {
			// ȺģʽԽ
		} else {
			// ǼȺģʽ޷ʹöмɢѹ
		}
	}

	/**
	 * ˵
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param pks
	 * @return
	 * @throws BusinessException
	 * @throws DAOException
	 * @see
	 * @since V6.0
	 */
	@SuppressWarnings("unchecked")
	public FipExtendAggVO[] queryDesBill(String[] pks) throws DAOException, BusinessException {
		Collection<OperatingLogVO> volist = new BaseDAO().retrieveByClause(OperatingLogVO.class, SqlTools.getInStr("pk_operatinglog", pks, true));
		if (volist == null || volist.isEmpty())
			return null;
		// Ŀ굥ͷ
		HashMap<String, List<OperatingLogVO>> billtypemap = new HashMap<String, List<OperatingLogVO>>();
		for (OperatingLogVO operatingLogVO : volist) {
			List<OperatingLogVO> list = billtypemap.get(operatingLogVO.getDes_billtype());
			if (list == null) {
				list = new ArrayList<OperatingLogVO>();
				billtypemap.put(operatingLogVO.getDes_billtype(), list);
			}
			list.add(operatingLogVO);
		}
		Set<String> keyset = billtypemap.keySet();
		ArrayList<FipExtendAggVO> rslist = new ArrayList<FipExtendAggVO>();
		List<OperatingLogVO> list = null;
		Collection<FipExtendAggVO> billlist = null;
		for (String billtype : keyset) {
			list = billtypemap.get(billtype);
			IBillReflectorService ib = FipInterfaceCenter.getBillReflectorService(list.get(0).getDes_group(), billtype);
			if (ib == null)
				throw new BusinessException(FipInterfaceCenter.getNoInterfaceFoundMessage(billtype, "IBillReflectorService"));
			List<FipRelationInfoVO> srcinfo = new ArrayList<FipRelationInfoVO>();
			for (OperatingLogVO operatingLogVO : list) {
				srcinfo.add(FipBasicRelationVO.convertFromOperatingVO(operatingLogVO).getDesRelation());
			}
			if (ib instanceof IBillReflectorExService) {
				billlist = ((IBillReflectorExService) ib).queryTempBillByRelations(srcinfo);
			} else {
				billlist = ib.queryBillByRelations(srcinfo);
			}
			rslist.addAll(billlist);
		}
		return rslist.toArray(new FipExtendAggVO[0]);
	}

	/**
	 * ˵
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param pks
	 * @return
	 * @throws BusinessException
	 * @throws DAOException
	 * @see
	 * @since V6.0
	 */
	@SuppressWarnings("unchecked")
	public FipExtendAggVO[] querySrcBill(String[] pks) throws DAOException, BusinessException {
		Collection<OperatingLogVO> volist = new BaseDAO().retrieveByClause(OperatingLogVO.class, SqlTools.getInStr("pk_operatinglog", pks, true));
		if (volist == null || volist.isEmpty())
			return null;
		// Ŀ굥ͷ
		HashMap<String, List<OperatingLogVO>> billtypemap = new HashMap<String, List<OperatingLogVO>>();
		for (OperatingLogVO operatingLogVO : volist) {
			List<OperatingLogVO> list = billtypemap.get(operatingLogVO.getSrc_billtype());
			if (list == null) {
				list = new ArrayList<OperatingLogVO>();
				billtypemap.put(operatingLogVO.getSrc_billtype(), list);
			}
			list.add(operatingLogVO);
		}
		Set<String> keyset = billtypemap.keySet();
		ArrayList<FipExtendAggVO> rslist = new ArrayList<FipExtendAggVO>();
		List<OperatingLogVO> list = null;
		Collection<FipExtendAggVO> billlist = null;
		for (String billtype : keyset) {
			list = billtypemap.get(billtype);
			IBillReflectorService ib = FipInterfaceCenter.getBillReflectorService(list.get(0).getSrc_group(), billtype);
			if (ib == null)
				throw new BusinessException(FipInterfaceCenter.getNoInterfaceFoundMessage(billtype, "IBillReflectorService"));
			List<FipRelationInfoVO> srcinfo = new ArrayList<FipRelationInfoVO>();
			for (OperatingLogVO operatingLogVO : list) {
				srcinfo.add(FipBasicRelationVO.convertFromOperatingVO(operatingLogVO).getSrcRelation());
			}
			if (ib instanceof IBillReflectorExService) {
				billlist = ((IBillReflectorExService) ib).queryTempBillByRelations(srcinfo);
			} else {
				billlist = ib.queryBillByRelations(srcinfo);
			}
			rslist.addAll(billlist);
		}
		return rslist.toArray(new FipExtendAggVO[0]);
	}

	/**
	 * Դ,Ŀ굥
	 * 
	 * @param relation
	 * @param condition
	 * @return
	 * @throws BusinessException
	 */
	public Integer[] drawSrcBill(FipBasicRelationVO relation, Object condition) throws BusinessException {
		// ,ֹӰҵʱЧ
		FipBSCacheCleaner.clearAllCache();
		Integer[] rs = new Integer[] { 0, 0, 0 };
		String srcBillType = relation.getSrcRelation().getPk_billtype();
		String pk_group = relation.getSrcRelation().getPk_group();

		Collection<FipBaseMessageVO> srcbill = new ArrayList<FipBaseMessageVO>();
		Collection<FipBaseMessageVO> newsrcbill = new ArrayList<FipBaseMessageVO>();
		HashMap<String, String> addvopkmap = new HashMap<String, String>();
		//ʽȡsaga
		NCCSagas.startNewSaga();
		Collection<FipBaseMessageVO> drawOneGroup = null;
		//УǷ΢,岿߼ֿ
		boolean isMerged = NCCEnv.isMerged();
		{
			if(!isMerged) {
				//ȡηӿ
				IFipInterfaceCenterService drawService = SagasUtil.getFipInterfaceCenterService(srcBillType);
				Map<String,Serializable> params = new HashMap<String,Serializable>();
				params.put("pk_group", pk_group);
				params.put("billtype", srcBillType);
				// ԴϵͳжȡҪ(Ŀǰģʽȫȡ)
				Collection<FipBaseMessageVO> srcBillList = drawService.loadSrcBill(params, condition);
				if (srcBillList != null && srcBillList.size() > 0){
					srcbill.addAll(srcBillList);
				}
				//˵ļ˷Լӣƽ̨
				//ϸм
//				List<String> detailList = new ArrayList<String>();
//				for(FipBaseMessageVO message : srcbill){
//					detailList.add(message.getMessageinfo().getRelationID());
//				}
//				String[] array = detailList.toArray(new String[0]);
//				if(array != null && array.length > 0){
//					if (!PKLock.getInstance().addBatchDynamicLock(array)) {
//						 throw new LockFailedException(array);
//					}
//				}
			} else {
				IBillDrawService ids = FipInterfaceCenter.getBillDrawService(pk_group, srcBillType);
				if (ids == null)
					throw new BusinessException(FipInterfaceCenter.getNoInterfaceFoundMessage(srcBillType, "IBillDrawService"));
				// ԴϵͳжȡҪ(Ŀǰģʽȫȡ)
				ids.setQueryCondition(condition);
				while (ids.hasNext()) {
					Collection<FipBaseMessageVO> next = ids.next();
					if (next != null && !next.isEmpty())
						srcbill.addAll(next);
					if (srcbill.size() >= DrawGroupingNum) {
						drawOneGroup = drawOneGroup(relation, srcbill, rs, addvopkmap);
						if (!drawOneGroup.isEmpty())
							newsrcbill.addAll(drawOneGroup);
						srcbill.clear();
					}
				}
			}
			
		}
		if (!srcbill.isEmpty()) {
			BilltypeVO billtype = FipBaseDataProxy.getBilltype(relation.getDesRelation().getPk_group(), relation.getDesRelation().getPk_billtype());
			if(billtype != null && billtype.getSystemcode() != null && relation.getDesRelation().getPk_system() == null){
				relation.getDesRelation().setPk_system(billtype.getSystemcode());
			}
			drawOneGroup = drawOneGroup(relation, srcbill, rs, addvopkmap);
			if (!drawOneGroup.isEmpty())
				newsrcbill.addAll(drawOneGroup);
			srcbill.clear();
		}
		//УǷ΢,岿߼ֿ
		if(isMerged){
			//΢Զʽȡʱƾ֤ʽƾ֤Ĳ΢ֶ
			EventDispatcher.fireEvent(new BusinessEvent("drawsrcbills", IEventType.TYPE_INSERT_AFTER, new Object[] { relation, newsrcbill }));
		}
		ArrayList<String> arrayList = new ArrayList<String>();
		arrayList.addAll(addvopkmap.keySet());
		String wherepart = SqlTools.getInStr(OperatingLogVO.SRC_RELATIONID, arrayList, true);
		wherepart = wherepart + " and " + OperatingLogVO.DES_ORG + "='" + relation.getDesRelation().getPk_org() + "' and " + OperatingLogVO.DES_BILLTYPE + "='" + relation.getDesRelation().getPk_billtype() + "' and " + OperatingLogVO.OPERATEFLAG + "<>" + OperatingFlagEmu.FLAG_saved + "";
		OperatingLogVO[] queryByWhere = queryByWhere(wherepart);
		rs[2] = queryByWhere == null ? 0 : queryByWhere.length;
		return rs;
	}

	/**
	 * ִһ
	 * 
	 * @param relation
	 * @param rs
	 * @param srcbill
	 * @param addvopkmap
	 * @throws BusinessException
	 */
	private Collection<FipBaseMessageVO> drawOneGroup(FipBasicRelationVO relation, Collection<FipBaseMessageVO> srcbill, Integer[] rsnum, HashMap<String, String> addvopkmap) throws BusinessException {
		Collection<FipBaseMessageVO> newsrcbill = new ArrayList<FipBaseMessageVO>();
		if (srcbill.isEmpty())
			return newsrcbill;
		rsnum[0] = rsnum[0] + srcbill.size();

		// Ѿ͹ƽ̨
		List<FipBasicRelationVO> rlist = new ArrayList<FipBasicRelationVO>();
		{
			for (FipBaseMessageVO fipBaseMessageVO : srcbill) {
				FipBasicRelationVO tmpvo = new FipBasicRelationVO();
				tmpvo.setSrcRelation(fipBaseMessageVO.getMessageinfo());
				// ҪcloneΪõͬһϣ̴ҲûclonenewĻĿ굥Ϣһ
				tmpvo.setDesRelation((FipRelationInfoVO) relation.getDesRelation().clone());
				rlist.add(tmpvo);
			}
			rlist = retainExists(rlist);
		}
		if (rlist == null || rlist.isEmpty())
			return newsrcbill;
		rsnum[1] = rsnum[1] + rlist.size();

		for (FipBasicRelationVO fipBasicRelationVO : rlist) {
			addvopkmap.put(fipBasicRelationVO.getSrcRelation().getRelationID(), "");
		}
		for (FipBaseMessageVO fipBaseMessageVO : srcbill) {
			if (addvopkmap.get(fipBaseMessageVO.getMessageinfo().getRelationID()) != null)
				newsrcbill.add(fipBaseMessageVO);
		}
		srcbill.clear();

		new FipGenerateProxy().draw_RequiresNew(relation, newsrcbill);
		for (FipBaseMessageVO fipBaseMessageVO : newsrcbill) {
			fipBaseMessageVO.setBillVO(null);
		}
		return newsrcbill;
	}

	/**
	 * 趨úԴϢԶĿ굥
	 * 
	 * @param relation
	 * @param srcbill
	 * @throws BusinessException
	 */
	public void drawSrcBillByBill(FipBasicRelationVO relation, Collection<FipBaseMessageVO> srcbill) throws BusinessException {
		FipBSCacheCleaner.clearAllCache();
		Map<String,Object> drawParams = new HashMap<String,Object>();
		drawParams.put("generatemode", Integer.valueOf(1));//ɷʽ1Ϊʽȡ
		drawParams.put("srcbill", srcbill);//Դ
		drawParams.put("batchSize",1*2);
		disposeResult(convertBill(relation, srcbill),drawParams);
	}

	public List<FipTranslateResultVO> convertBill(FipBasicRelationVO relation, Collection<FipBaseMessageVO> srcbill) throws BusinessException {

		if (srcbill == null || srcbill.isEmpty())
			return null;

		// Ϣ
		String srcBillType = relation.getSrcRelation().getPk_billtype();
		String desBillType = relation.getDesRelation().getPk_billtype();
		String pk_group = relation.getSrcRelation().getPk_group();

		// жԴϢǷʵϢʵϢ˵Ϣֱʹãʵݻ档
		// ʵϢӿ²ѯһΡ
		HashMap<String, FipBaseMessageVO> datamap = new HashMap<String, FipBaseMessageVO>(); // ݻ
		boolean hasBillBody = false;
		{
			FipBaseMessageVO firstvo = srcbill.iterator().next();
			if (firstvo != null && firstvo.getBillVO() != null)
				hasBillBody = true;
			if (hasBillBody) {
				for (FipBaseMessageVO fipBaseMessageVO : srcbill) {
					datamap.put(fipBaseMessageVO.getMessageinfo().getRelationID(), fipBaseMessageVO);
				}
			}
		}

		// Ѿ͹ƽ̨
		List<FipBasicRelationVO> rlist = new ArrayList<FipBasicRelationVO>();
		{
			for (FipBaseMessageVO fipBaseMessageVO : srcbill) {
				FipBasicRelationVO tmpvo = new FipBasicRelationVO();
				tmpvo.setSrcRelation(fipBaseMessageVO.getMessageinfo());
				// ҪcloneΪõͬһϣ̴ҲûclonenewĻĿ굥Ϣһ
				tmpvo.setDesRelation((FipRelationInfoVO) relation.getDesRelation().clone());
				rlist.add(tmpvo);
			}
			// rlist = retainExists(rlist);
		}
		if (rlist == null || rlist.isEmpty())
			return null;

		List<FipTranslateResultVO> desbill = null;
		// жǷҪ
		ConfigVO cfgvos = FipConfigCache.getCacheData(pk_group, srcBillType, desBillType, false);
		// if (cfgvos == null)
		// throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0026")/* @res "ƽ̨" */+ srcBillType + "->" + desBillType);
		boolean isSumMode = false;
		if (cfgvos != null)
			isSumMode = cfgvos.getIssum() == null ? false : cfgvos.getIssum().booleanValue();
		//ʽȡϸ->ƾ֤ϸ->ĵδʵֻģʽҪʵIBillSumService
		if (isSumMode) {
			// ɵķʽ
			// ȣЩ¼ܵĻܳ
			ArrayList<SumRelationVO> sumlist = new ArrayList<SumRelationVO>();
			for (FipBasicRelationVO fipBasicRelationVO : rlist) {
				sumlist.add(fipBasicRelationVO.convertToSumRelationVO());
			}
			// ִлԴ
			ArrayList<FipRelationInfoVO> relationvos = new ArrayList<FipRelationInfoVO>();
			for (FipBasicRelationVO fipBasicRelationVO : rlist) {
				relationvos.add(fipBasicRelationVO.getSrcRelation());
			}
			ArrayList<Collection<FipRelationInfoVO>> relationlist = new ArrayList<Collection<FipRelationInfoVO>>();
			relationlist.add(relationvos);
			Collection<FipBillSumRSVO> sumrs = null;
			if (!NCCEnv.isMerged()) {
				//ȡηӿ
				IFipInterfaceCenterService srcService = SagasUtil.getFipInterfaceCenterService(srcBillType);
				Map<String,Serializable> params = new HashMap<String,Serializable>();
				params.put("pk_group", pk_group);
				params.put("billtype", srcBillType);
				try{
					sumrs = srcService.querySumBill(params, relationlist, null, UFBoolean.TRUE);
				} catch (BusinessException ex){
					throw ex;
				} catch (Exception ex1){//ʱֳܻʱ
					throw new BusinessException(ex1);
				}
			} else {
				IBillSumService iss = FipInterfaceCenter.getBillSumService(pk_group, srcBillType);
				if (iss == null) {
					throw new BusinessException(FipInterfaceCenter.getNoInterfaceFoundMessage(srcBillType, "IBillSumService"));
				}
				sumrs = iss.querySumBill(relationlist, null, UFBoolean.TRUE);
			}
			HashMap<String, String> groupmap = new HashMap<String, String>();
			if (sumrs != null && !sumrs.isEmpty()) {
				ArrayList<FipTransVO> list = new ArrayList<FipTransVO>();
				for (FipBillSumRSVO fipBillSumRSVO : sumrs) {
					if (fipBillSumRSVO == null)
						continue;
					FipRelationInfoVO[] subvos = fipBillSumRSVO.getRelationvos();
					for (FipRelationInfoVO fipRelationInfoVO : subvos) {
						groupmap.put(fipRelationInfoVO.getRelationID(), fipBillSumRSVO.getMessageinfo().getRelationID());
					}
					FipTransVO vo = new FipTransVO();
					FipBasicRelationVO rl = new FipBasicRelationVO();
					rl.setSrcRelation(fipBillSumRSVO.getMessageinfo());
					rl.setDesRelation((FipRelationInfoVO) rlist.get(0).getDesRelation().clone());
					vo.setDatavo(fipBillSumRSVO.getBillVO());
					vo.setMessagevo(rl);
					vo.setIsImmediatelyRun(UFBoolean.TRUE);
					list.add(vo);
				}
				desbill = constructDesBillWithData(list);
			}
			for (SumRelationVO sumRelationVO : sumlist) {
				sumRelationVO.setGroupid(groupmap.get(sumRelationVO.getSrc_relationid()));
			}
			new FipSumRelationBO().insert(sumlist);
		} else {
			// ǻ
			if (hasBillBody) {
				// ʹôݵķʽΪĻdatamapҪռúܴڴռ䣬ⲿݻǲҪ
				List<FipTransVO> volist = new ArrayList<FipTransVO>();
				for (FipBasicRelationVO basicrelation : rlist) {
					FipTransVO vo = new FipTransVO();
					FipBaseMessageVO msgvo = datamap.get(basicrelation.getSrcRelation().getRelationID());
					vo.setDatavo(msgvo == null ? null : msgvo.getBillVO());
					vo.setMessagevo(basicrelation);
					vo.setIsImmediatelyRun(UFBoolean.TRUE);
					volist.add(vo);
				}
				desbill = constructDesBillWithData(volist);
			} else {
				desbill = constructDesBillWithoutData(rlist);
			}
		}

		return desbill;
	}

	/**
	 * Ӽ޳Ѿ͹ƽ̨
	 * 
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param rlist
	 * @return
	 * @throws BusinessException
	 * @see
	 * @since V6.0
	 */
	private List<FipBasicRelationVO> retainExists(List<FipBasicRelationVO> rlist) throws BusinessException {
		ArrayList<FipBasicRelationVO> rs = null;
		if (rlist != null && !rlist.isEmpty()) {
			// Ŀ굥ݷ飬ΪϵǰĿŵ
			HashMap<String, List<FipBasicRelationVO>> map = new HashMap<String, List<FipBasicRelationVO>>();
			for (FipBasicRelationVO fipBasicRelationVO : rlist) {
				if (fipBasicRelationVO == null)
					continue;
				List<FipBasicRelationVO> list = map.get(fipBasicRelationVO.getDesRelation().getPk_billtype());
				if (list == null) {
					list = new ArrayList<FipBasicRelationVO>();
					map.put(fipBasicRelationVO.getDesRelation().getPk_billtype(), list);
				}
				list.add(fipBasicRelationVO);
			}
			Set<String> keyset = map.keySet();
			if (!keyset.isEmpty()) {
				rs = new ArrayList<FipBasicRelationVO>();
				for (String billtype : keyset) {
					rs.addAll(retainExistsPerDes(map.get(billtype)));
				}
			}
		}
		return rs;
	}

	/**
	 * Ŀ굥޳͹ƽ̨ݡƽ̨ԼһԴһĿֻ֯һĿ굥
	 * 
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param list
	 * @return
	 * @throws BusinessException
	 * @see
	 * @since V6.0
	 */
	@SuppressWarnings("unchecked")
	private List<FipBasicRelationVO> retainExistsPerDes(List<FipBasicRelationVO> list) throws BusinessException {
		ArrayList<FipBasicRelationVO> rs = new ArrayList<FipBasicRelationVO>();
		if (list != null && !list.isEmpty()) {
			FipBasicRelationVO first = list.get(0);
			HashMap<String, FipBasicRelationVO> map = new HashMap<String, FipBasicRelationVO>();
			for (FipBasicRelationVO fipBasicRelationVO : list) {
				String key = fipBasicRelationVO.getSrcRelation().getPk_billtype() + fipBasicRelationVO.getSrcRelation().getRelationID() + fipBasicRelationVO.getDesRelation().getPk_billtype() + fipBasicRelationVO.getDesRelation().getPk_org();
				map.put(key, fipBasicRelationVO);
			}
			// ʱ
			String tablename = TempTableTool.getTempTablename(first.getDesRelation().getPk_billtype());
			String[] colname = new String[] { "src_billtype", "src_relationid", "des_billtype", "des_org" };
			String[] coltype = new String[] { "varchar(60)", "varchar(60)", "varchar(60)", "varchar(60)" };
			try {
				tablename = TempTableTool.createTempTable(tablename, colname, coltype);
			} catch (SQLException e) {
				Logger.error("", e);
			}
			if (tablename == null)
				throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0027")/* @res "ʱʧܡ" */);
			try {
				insertIntoTable(tablename, list);
			} catch (Exception e) {
				Logger.error("", e);
				throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0028")/* @res "ʱʧܡ" */);
			}
			BaseDAO dao = new BaseDAO();
			String delsql = null;
			// ܳ
			String sumtable = "fip_sumrelation";
			delsql = "delete from " + tablename + " where exists(select 1 from " + sumtable + " A where A.src_billtype=" + tablename + ".src_billtype and A.src_relationid=" + tablename + ".src_relationid and A.des_billtype=" + tablename + ".des_billtype and A.des_org=" + tablename + ".des_org) ";
			dao.executeUpdate(delsql);
			// ״̬
			String oplogtable = "fip_operatinglog";
			delsql = "delete from " + tablename + " where exists(select 1 from " + oplogtable + " A where A.src_billtype=" + tablename + ".src_billtype and A.src_relationid=" + tablename + ".src_relationid and A.des_billtype=" + tablename + ".des_billtype and A.des_org=" + tablename + ".des_org) ";
			dao.executeUpdate(delsql);
			// ϵ
			String relatable = "fip_relation";
			delsql = "delete from " + tablename + " where exists(select 1 from " + relatable + " A where A.src_billtype=" + tablename + ".src_billtype and A.src_relationid=" + tablename + ".src_relationid and A.des_billtype=" + tablename + ".des_billtype and A.des_org=" + tablename + ".des_org) ";
			dao.executeUpdate(delsql);
			// ʣЧ¼
			String querysql = "select src_billtype,src_relationid,des_billtype,des_org from " + tablename;
			Object o = dao.executeQuery(querysql, new ResultSetProcessor() {

				@Override
				public Object handleResultSet(ResultSet rs) throws SQLException {
					ArrayList<FipRelationVO> rsdata = new ArrayList<FipRelationVO>();
					while (rs.next()) {
						FipRelationVO vo = new FipRelationVO();
						vo.setSrc_billtype(rs.getString("src_billtype"));
						vo.setSrc_relationid(rs.getString("src_relationid"));
						vo.setDes_billtype(rs.getString("des_billtype"));
						vo.setDes_org(rs.getString("des_org"));
						rsdata.add(vo);
					}
					return rsdata;
				}
			});
			if (o != null) {
				List<FipRelationVO> tmprs = (List<FipRelationVO>) o;
				if (!tmprs.isEmpty()) {
					String key = null;
					for (FipRelationVO fipRelationVO : tmprs) {
						key = fipRelationVO.getSrc_billtype() + fipRelationVO.getSrc_relationid() + fipRelationVO.getDes_billtype() + fipRelationVO.getDes_org();
						rs.add(map.get(key));
					}
				}
			}
		}
		return rs;
	}

	/**
	 * ݲʱ
	 * 
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param tableName
	 * @param colName
	 * @param datas
	 * @throws java.sql.SQLException
	 * @throws DbException
	 * @see
	 * @since V6.0
	 */
	private void insertIntoTable(String tableName, List<FipBasicRelationVO> list) throws java.sql.SQLException, DbException {
		java.sql.Connection con = null;
		JdbcSession session = null;
		try {
			PersistenceManager manager = PersistenceManager.getInstance(DataSourceCenter.getInstance().getSourceName());
			manager.setAddTimeStamp(false);
			session = manager.getJdbcSession();
			con = session.getConnection();
			if (con instanceof CrossDBConnection) {
				((CrossDBConnection) con).setAddTimeStamp(false);
			}
			String sql_insert = "insert into " + tableName + " (src_billtype,src_relationid,des_billtype,des_org)  values( ?,?,?,? ) ";

			for (FipBasicRelationVO fipBasicRelationVO : list) {
				SQLParameter sqlParam = new SQLParameter();
				sqlParam.addParam(fipBasicRelationVO.getSrcRelation().getPk_billtype());
				sqlParam.addParam(fipBasicRelationVO.getSrcRelation().getRelationID());
				sqlParam.addParam(fipBasicRelationVO.getDesRelation().getPk_billtype());
				sqlParam.addParam(fipBasicRelationVO.getDesRelation().getPk_org());
				session.addBatch(sql_insert, sqlParam);
			}
			session.executeBatch();
		} finally {
			try {
				if (con != null)
					con.close();
			} catch (Exception e) {
			}
			try {
				if (session != null)
					session.closeAll();
			} catch (Exception e) {
			}
		}
	}

	/**
	 * ݹϵתĽͨʽУҪݵݲѯ²ѯVO
	 * 
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param list
	 * @throws BusinessException
	 * @see
	 * @since V6.0
	 */
	private List<FipTranslateResultVO> constructDesBillWithoutData(List<FipBasicRelationVO> list) throws BusinessException {
		if (list == null || list.isEmpty())
			return null;
		List<FipTranslateResultVO> rs = null;
		FipBasicRelationVO firstelement = list.iterator().next();
		String src_group = firstelement.getSrcRelation().getPk_group();
		String src_billtype = firstelement.getSrcRelation().getPk_billtype();
		//УǷΪϵͳ
		TXMsgDataUtil.checkTXMsgDataType(src_group, src_billtype);
		Collection<FipExtendAggVO> billlist = null;
		//УǷ΢,岿߼ֿ
		boolean isMerged = NCCEnv.isMerged();
		if(!isMerged){
			//ȡηӿ
			IFipInterfaceCenterService ib = SagasUtil.getFipInterfaceCenterService(src_billtype);
			Map<String,Serializable> params = new HashMap<String,Serializable>();
			params.put("pk_group", src_group);
			params.put("billtype", src_billtype);
			List<FipRelationInfoVO> srcinfo = new ArrayList<FipRelationInfoVO>();
			for (FipBasicRelationVO operatingLogVO : list) {
				srcinfo.add(operatingLogVO.getSrcRelation());
			}
			billlist = ib.queryBillByRelations(params,srcinfo);
		}else{
			IBillReflectorService ib = FipInterfaceCenter.getBillReflectorService(src_group, src_billtype);
			if (ib == null)
				throw new BusinessException(FipInterfaceCenter.getNoInterfaceFoundMessage(src_billtype, "IBillReflectorService"));
			List<FipRelationInfoVO> srcinfo = new ArrayList<FipRelationInfoVO>();
			for (FipBasicRelationVO operatingLogVO : list) {
				srcinfo.add(operatingLogVO.getSrcRelation());
			}
			billlist = ib.queryBillByRelations(srcinfo);
		}
		
		ArrayList<FipTransVO> translist = new ArrayList<FipTransVO>();
		if (billlist == null || billlist.isEmpty()) {
			// ûв,ƽ̨־
			for (FipBasicRelationVO operatingLogVO : list) {
				FipTransVO transvo = new FipTransVO();
				// ȫΪִеķʽ
				transvo.setIsImmediatelyRun(UFBoolean.TRUE);
				// ͬ⣬ԴѾûصݺ͸ü¼Ӧ
				transvo.setMessagevo(operatingLogVO);
				translist.add(transvo);
			}
		} else {
			HashMap<String, FipExtendAggVO> srcDataMap = new HashMap<String, FipExtendAggVO>();
			for (FipExtendAggVO fipExtendAggVO : billlist) {
				srcDataMap.put(fipExtendAggVO.getRelationID(), fipExtendAggVO);
			}
			{
				for (FipBasicRelationVO operatingLogVO : list) {
					FipTransVO transvo = new FipTransVO();
					// ȫΪִеķʽ
					transvo.setIsImmediatelyRun(UFBoolean.TRUE);
					FipExtendAggVO fipExtendAggVO = srcDataMap.get(operatingLogVO.getSrcRelation().getRelationID());
					if (fipExtendAggVO == null) {
						// ͬ⣬ԴѾûصݺ͸ü¼Ӧ
						transvo.setMessagevo(operatingLogVO);
						translist.add(transvo);
					} else {
						if (fipExtendAggVO.getMessageinfo() != null)
							operatingLogVO.setSrcRelation(fipExtendAggVO.getMessageinfo());
						transvo.setDatavo(fipExtendAggVO.getBillVO());
						transvo.setMessagevo(operatingLogVO);
						translist.add(transvo);
					}
				}
			}
		}
		rs = constructDesBillWithData(translist);
		return rs;
	}

	/**
	 * ݹϵתĽͨʽ
	 * 
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param list
	 * @throws BusinessException
	 * @see
	 * @since V6.0
	 */
	private List<FipTranslateResultVO> constructDesBillWithData(List<FipTransVO> list) throws BusinessException {
		if (list == null || list.isEmpty())
			return null;
		ArrayList<FipTranslateResultVO> rs = new ArrayList<FipTranslateResultVO>();
		{
			for (FipTransVO transvo : list) {
				FipTranslateResultVO vo = new FipTranslateResultVO();
				FipBasicRelationVO operatingLogVO = transvo.getMessagevo();
				// תǰҪĿ굥ϢĿ꼯šĿ֯Ŀ굥͡ĿϵͳĿҵڣÿչšԱ
				operatingLogVO.setExbusimessage1(null);
				operatingLogVO.setExbusimessage2(null);
				operatingLogVO.setExbusimessage3(null);
				FipRelationInfoVO desRelation = operatingLogVO.getDesRelation();
				FipRelationInfoVO srcRelation = operatingLogVO.getSrcRelation();
				desRelation.setBusidate(srcRelation.getBusidate());
				desRelation.setPk_operator(srcRelation.getPk_operator());
				desRelation.setRelationID(null);
				desRelation.setDefdoc1(null);
				desRelation.setDefdoc2(null);
				desRelation.setDefdoc3(null);
				desRelation.setFreedef1(null);
				desRelation.setFreedef2(null);
				desRelation.setFreedef3(null);
				desRelation.setFreedef4(null);
				desRelation.setFreedef5(null);
				if (transvo.getDatavo() == null) {
					// ݽƽ̨־
					List<FipTransVO> rslist = new ArrayList<FipTransVO>();
					rslist.add(transvo);
					vo.setDesBills(rslist);
					vo.setErrorMsg(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0029")/* @res "һԳ⣬Դϵͳûеݺ͹" */
							+ srcRelation.getRelationID() + nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0030")/* @res "Ӧ" */);
					rs.add(vo);
				} else {
					// ԴϵͳĿ굥
					if(desRelation.getPk_system() == null){
						desRelation.setPk_system(srcRelation.getPk_system());
					}
					try {
						List<FipTransVO> rslist = BOTranslateCenter.translate(transvo);
						if (rslist == null) {
							// ģΪɷʽ
							if (operatingLogVO.getPk_relation() != null) {
								// ɣҪϢ
								rslist = new ArrayList<FipTransVO>();
								FipTransVO clone = (FipTransVO) transvo.clone();
								clone.setDatavo(null);
								try {
									BilltypeVO billtype = FipBaseDataProxy.getBilltype(desRelation.getPk_group(), desRelation.getPk_billtype());
									desRelation.setPk_system(billtype == null ? null : billtype.getSystemcode());
								} catch (Exception e) {
									Logger.error("FipBaseDataProxy.getBilltype error!" + desRelation.getPk_group() + ":" + desRelation.getPk_billtype(), e);
								}
								rslist.add(clone);
							}
						}
						vo.setDesBills(rslist);
						rs.add(vo);
					} catch (Exception e) {
						String errmsg = null;
						if (e.getCause() != null)
							errmsg = e.getCause().getMessage();
						else
							errmsg = e.getMessage();
						if (errmsg == null || errmsg.trim().length() == 0)
							errmsg = e.getClass().getName();
						if (errmsg.getBytes().length > 1000) {
							errmsg = errmsg.substring(0, 500);
						}
						List<FipTransVO> rslist = new ArrayList<FipTransVO>();
						rslist.add(transvo);
						vo.setDesBills(rslist);
						vo.setErrorMsg(errmsg);
						rs.add(vo);
					}
				}
			}
		}
		return rs;
	}

	/**
	 * ĽΪ췢ʱϵȻ״̬ʱ״̬ϵֻڴ״̬лδɣڹϵ
	 * 
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param desbill
	 * @throws BusinessException
	 * @see
	 * @since V6.0
	 */
	private void disposeResult(List<FipTranslateResultVO> desbill, Map<String,Object> generateParams) throws BusinessException {
		if (desbill != null && !desbill.isEmpty()) {
			ArrayList<OperatingLogVO> erroraddlist = new ArrayList<OperatingLogVO>(); // дݣⲿݼ¼ڴ״̬
			ArrayList<OperatingLogVO> erroruplist = new ArrayList<OperatingLogVO>(); // дݣⲿݼ¼ڴ״̬

			ArrayList<FipSaveResultVO> savelist = new ArrayList<FipSaveResultVO>(); // ҪԶȷϵĿ굥
			ArrayList<FipBasicRelationVO> savelog = new ArrayList<FipBasicRelationVO>(); // ҪԶȷϵĿ굥ɵĹϵ

			ArrayList<FipSaveResultVO> confirmlist = new ArrayList<FipSaveResultVO>(); // ҪԶȷϵĿ굥
			ArrayList<FipBasicRelationVO> confirmrelation = new ArrayList<FipBasicRelationVO>(); // ҪԶȷϵĿ굥ɵĹϵ
			
			ArrayList<String> savePkList = new ArrayList<String>();// ҪԶȷϵϢ
			ArrayList<String> confirmPkList = new ArrayList<String>();// ҪԶȷϵϢ

			for (FipTranslateResultVO fipTranslateResultVO : desbill) {
				if (fipTranslateResultVO.getErrorMsg() != null) {
					OperatingLogVO opvo = fipTranslateResultVO.getDesBills().get(0).getMessagevo().convertToOperatingLogVO();
					opvo.setOpmessage(fipTranslateResultVO.getErrorMsg());
					opvo.setOperateflag(OperatingFlagEmu.FLAG_no_process);
					if (opvo.getPk_operatinglog() == null)
						erroraddlist.add(opvo);
					else
						erroruplist.add(opvo);
				} else {
					List<FipTransVO> tmpdesbill = fipTranslateResultVO.getDesBills();
					if (tmpdesbill != null && !tmpdesbill.isEmpty()) {
						for (FipTransVO fipTransVO : tmpdesbill) {
							Object datavo = fipTransVO.getDatavo();
							FipBasicRelationVO messagevo = fipTransVO.getMessagevo();
							FipRelationInfoVO desRelation = messagevo.getDesRelation();
							if (datavo == null || desRelation == null) {
								// ûĿ굥
								OperatingLogVO opvo = messagevo.convertToOperatingLogVO();
								opvo.setOpmessage(fipTranslateResultVO.getErrorMsg());
								opvo.setOperateflag(OperatingFlagEmu.FLAG_no_process);
								if (opvo.getPk_operatinglog() == null)
									erroraddlist.add(opvo);
								else
									erroruplist.add(opvo);
								continue;
							}
							FipSaveResultVO srvo = new FipSaveResultVO();
							srvo.setBillVO(datavo);
							srvo.setMessageinfo(desRelation);
							// ڱĿ굥˵ҪԴԴϵͳʱͨĿϵͳ͸
							srvo.getMessageinfo().setPk_system(messagevo.getSrcRelation().getPk_system());
							srvo.getMessageinfo().setPk_operator(messagevo.getSrcRelation().getPk_operator());
							srvo.getMessageinfo().setBusidate(messagevo.getSrcRelation().getBusidate());
							if (fipTransVO.getIsAutoConfirm() != null && fipTransVO.getIsAutoConfirm().booleanValue()) {
								confirmlist.add(srvo);
								confirmrelation.add(messagevo);
								if (messagevo.getPk_relation() != null && !"".equals(messagevo.getPk_relation())) {
									confirmPkList.add(messagevo.getPk_relation());
								}
							} else {
								savelist.add(srvo);
								savelog.add(messagevo);
								if (messagevo.getPk_relation() != null && !"".equals(messagevo.getPk_relation())) {
									savePkList.add(messagevo.getPk_relation());
								}
							}
						}
					} else {
						// GBH add
						throw new BusinessException("unkown error!" + nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10170410", "1101704100022")/* @res "ûתӦƾ֤Ҳû״" */);
					}
				}
			}
			if (erroraddlist != null && !erroraddlist.isEmpty()) {
				insert(erroraddlist);
			}
			if (erroruplist != null && !erroruplist.isEmpty()) {
				update(erroruplist);
			}
			//УǷ΢,岿߼ֿ
			boolean isMerged = NCCEnv.isMerged();
			String global_batchno = null;//ȫκ
			Integer batchSize = null;//
			if ((savelist == null || savelist.isEmpty()) && (confirmlist == null || confirmlist.isEmpty())){
				if(!isMerged){
					if(generateParams != null){
						if (generateParams.get("global_batchno") != null) {
							global_batchno = (String)generateParams.get("global_batchno");//ȫκ
						}
						if(generateParams.get("batchSize") != null){
							batchSize = Integer.parseInt(String.valueOf(generateParams.get("batchSize")));
							SagasUtil.processMsgsResult(global_batchno, 1*2, batchSize, FipRedisKeyConst.REBUILD_KEY1, FipRedisKeyConst.REBUILD_KEY2);
						}
					}
				}
				return;
			}
			FipBasicRelationVO first = null;
			if (!savelog.isEmpty())
				first = savelog.get(0);
			else if (!confirmrelation.isEmpty()) {
				first = confirmrelation.get(0);
			}
			String pk_group = first.getDesRelation().getPk_group();
			String desBillType = first.getDesRelation().getPk_billtype();
			if(!isMerged){
				Integer generatemode = null;//ɷʽ
				boolean isSum = FipSceneUtil.isSumScene();//Ƿ
				UFBoolean isDraw = UFBoolean.FALSE;//Ƿʽȡ
				Collection<FipBaseMessageVO> srcbill = null;//ʽȡԴҵϢ
				ArrayList<FipRelationInfoVO> realdellist = new ArrayList<FipRelationInfoVO>();//ʱҪɾʱƾ֤
				//-ʱҵ
				Collection<FipBillSumRSVO> sumBills = null;
				FipRelationInfoVO desinfo = null;
				if(generateParams != null){
					generatemode = (Integer)generateParams.get("generatemode");
					//ʽȡ
					if(generatemode != null && generatemode == 1){
						isDraw = UFBoolean.TRUE;
						srcbill = (Collection<FipBaseMessageVO>)generateParams.get("srcbill");
					}
					//-ǻʱɾʱƾ֤
					realdellist = (ArrayList<FipRelationInfoVO>) generateParams.get("realdellist");
					//-ʱҵ
					sumBills = (Collection<FipBillSumRSVO>) generateParams.get("sumvos");//
					desinfo = (FipRelationInfoVO) generateParams.get("desinfo");//ĿϢ
					if (generateParams.get("global_batchno") != null) {
						global_batchno = (String)generateParams.get("global_batchno");//ȫκ
					}
					if(generateParams.get("batchSize") != null){
						batchSize = Integer.parseInt(String.valueOf(generateParams.get("batchSize")));//
					}
				}
				//ȡηӿ
				IFipInterfaceCenterService destService = SagasUtil.getFipInterfaceCenterService(desBillType);
				Map<String,Serializable> params = new HashMap<String,Serializable>();
				params.put("pk_group", pk_group);
				params.put("billtype", desBillType);
				UFBoolean needConfirm = destService.needConfirm(params);
				//ϲΪ0
				List<OperatingLogVO> oplist = new ArrayList<OperatingLogVO>();
				List<String> src_relationids = new ArrayList<String>();//Դrelationid
				if (needConfirm != null && needConfirm.booleanValue()) {
					// Ŀ굥ʱݣҪȷϲʽݣҪԶȷϵĵݱΪʱݣϵڴ״̬ҪԶȷϵĵֱӱΪʽƾ֤ϢڹϢ
					if (savelist != null && !savelist.isEmpty()) {
						DestWFWParamsVO paramVO = new DestWFWParamsVO();
						paramVO.setScene(GenerateDestSceneEnum.FLAG_CONFIRM_TEMP);
						paramVO.setIsSum(UFBoolean.valueOf(isSum));//Ƿ
						paramVO.setSumBills(sumBills);//
						paramVO.setDesinfo(desinfo);//ĿϢ
						paramVO.setIsDraw(isDraw);//Ƿʽȡ
						paramVO.setSrcbill(srcbill);//Դ
						paramVO.setDellist_des(realdellist);
						paramVO.setPk_group((String) params.get("pk_group"));
						paramVO.setPk_billTypeCode((String) params.get("billtype"));
						paramVO.setSavelog(savelog);// ҪԶȷϵĿ굥ɵĹϵ
						if (global_batchno != null) {
							paramVO.setGlobal_batchno(global_batchno);//ȫκ
						}
						if(batchSize != null){
							paramVO.setBatch_size(batchSize);//
						}
						if (savePkList != null) {
							paramVO.setPkList(savePkList);
						}
						//΢޸
						Collection<FipSaveResultVO> saveBill = destService.saveBill(paramVO,savelist);
						// ʱƾ֤¼Ϊսƽ̨־
					    if (saveBill == null || saveBill.isEmpty()) {
							for (FipSaveResultVO fipSaveResultVO : savelist) {
								FipRelationInfoVO messageinfo = fipSaveResultVO.getMessageinfo();
								OperatingLogVO vo = new OperatingLogVO();
								vo.setSrc_group(messageinfo.getPk_group());
								vo.setSrc_org(messageinfo.getPk_org());
								vo.setSrc_system(messageinfo.getPk_system());
								vo.setSrc_billtype(messageinfo.getPk_billtype());
								vo.setSrc_relationid(messageinfo.getRelationID());
								vo.setSrc_operator(messageinfo.getPk_operator());
								vo.setSrc_busidate(messageinfo.getBusidate());
								vo.setSrc_defdoc1(messageinfo.getDefdoc1());
								vo.setSrc_defdoc2(messageinfo.getDefdoc2());
								vo.setSrc_defdoc3(messageinfo.getDefdoc3());
								vo.setSrc_freedef1(messageinfo.getFreedef1());
								vo.setSrc_freedef2(messageinfo.getFreedef2());
								vo.setSrc_freedef3(messageinfo.getFreedef3());
								vo.setSrc_freedef4(messageinfo.getFreedef4());
								vo.setSrc_freedef5(messageinfo.getFreedef5());
								vo.setDes_group(desinfo.getPk_group());
								vo.setDes_org(desinfo.getPk_org());
								vo.setDes_system(desinfo.getPk_system());
								vo.setDes_billtype(desinfo.getPk_billtype());
								vo.setOpmessage("תģƾ֤¼Ϊգ");
								vo.setOperateflag(OperatingFlagEmu.FLAG_no_process);
								oplist.add(vo);
							}
					    } 
						
					}
					if (confirmlist != null && !confirmlist.isEmpty()) {
						// ʽ ֱʽݵģĿ굥кϲڱǰҪһκϲ
						BillRegisterVO billregvo = FipBillRegisterCache.getInstance().getBillRegisterInfo(pk_group, desBillType);
						String desBillSumService = billregvo.getDesbillsumclass();
						if (desBillSumService != null) {
							ArrayList<FipBillSumRSVO> volist = new ArrayList<FipBillSumRSVO>();
							List<FipSaveResultVO> resultList = new ArrayList<FipSaveResultVO>();
							for (FipSaveResultVO vo : confirmlist) {
								if (vo.getBillVO() == null) {
									continue;
								}
								FipBillSumRSVO svo = new FipBillSumRSVO();
								svo.setBillVO(vo.getBillVO());
								svo.setMessageinfo(vo.getMessageinfo());
								volist.add(svo);
								resultList.add(vo);
							}
							try{
								Collection<FipBillSumRSVO> sumvolist = destService.querySumBill(params, volist, null);
								if (sumvolist != null && !sumvolist.isEmpty()) {
									int index = 0;
									for(FipBillSumRSVO ssvo : sumvolist){
										FipSaveResultVO vo = resultList.get(index);
										vo.setBillVO(ssvo.getBillVO());
										vo.setMessageinfo(ssvo.getMessageinfo());
										index = index + 1;
									}
								}else {
									for (FipBillSumRSVO fipBillSumRSVO : sumvolist) {
										FipRelationInfoVO messageinfo = fipBillSumRSVO.getMessageinfo();
										OperatingLogVO vo = new OperatingLogVO();
										vo.setSrc_group(messageinfo.getPk_group());
										vo.setSrc_org(messageinfo.getPk_org());
										vo.setSrc_system(messageinfo.getPk_system());
										vo.setSrc_billtype(messageinfo.getPk_billtype());
										vo.setSrc_relationid(messageinfo.getRelationID());
										vo.setSrc_operator(messageinfo.getPk_operator());
										vo.setSrc_busidate(messageinfo.getBusidate());
										vo.setSrc_defdoc1(messageinfo.getDefdoc1());
										vo.setSrc_defdoc2(messageinfo.getDefdoc2());
										vo.setSrc_defdoc3(messageinfo.getDefdoc3());
										vo.setSrc_freedef1(messageinfo.getFreedef1());
										vo.setSrc_freedef2(messageinfo.getFreedef2());
										vo.setSrc_freedef3(messageinfo.getFreedef3());
										vo.setSrc_freedef4(messageinfo.getFreedef4());
										vo.setSrc_freedef5(messageinfo.getFreedef5());
										vo.setDes_group(desinfo.getPk_group());
										vo.setDes_org(desinfo.getPk_org());
										vo.setDes_system(desinfo.getPk_system());
										vo.setDes_billtype(desinfo.getPk_billtype());
										vo.setOpmessage("תģƾ֤¼Ϊգ");
										vo.setOperateflag(OperatingFlagEmu.FLAG_no_process);
										oplist.add(vo);
									}
								}
							} catch (BusinessException ex){
								throw ex;
							} catch (Exception ex1){//ʱֳܻʱ
								throw new BusinessException(ex1);
							}
						}
						// ϲΪ0Ҫ
						ArrayList<FipBasicRelationVO> dellist = new ArrayList<FipBasicRelationVO>();
						int size = confirmlist.size();
						for (int i = size - 1; i >= 0; i--) {
							FipBasicRelationVO vo = confirmrelation.get(i);
							FipSaveResultVO fipSaveResultVO = confirmlist.get(i);
							if (fipSaveResultVO == null || fipSaveResultVO.getBillVO() == null || fipSaveResultVO.getMessageinfo() == null) {
								vo.setDesRelation(null);
								if (vo.getPk_relation() != null) {
									dellist.add(vo);
								}
								confirmlist.remove(i);
								confirmrelation.remove(i);
								//ϲΪ0
								OperatingLogVO oplogvo = vo.convertToOperatingLogVO();
								oplogvo.setOperateflag(OperatingFlagEmu.FLAG_error_on_generate);
								oplogvo.setOpmessage(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0703") + vo.getSrcRelation().getFreedef1() + nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0704"));
								oplist.add(oplogvo);
								src_relationids.add(vo.getSrcRelation().getRelationID());
							}
						}
						if(confirmlist != null && !confirmlist.isEmpty()){
							DestWFWParamsVO paramVO = new DestWFWParamsVO();
							paramVO.setScene(GenerateDestSceneEnum.FLAG_CONFIRM_REAL);
							paramVO.setIsSum(UFBoolean.valueOf(isSum));//Ƿ
							paramVO.setSumBills(sumBills);//
							paramVO.setDesinfo(desinfo);//ĿϢ
							paramVO.setIsDraw(isDraw);//Ƿʽȡ
							paramVO.setPk_group((String) params.get("pk_group"));
							paramVO.setPk_billTypeCode((String) params.get("billtype"));
							paramVO.setDellist(dellist);
							paramVO.setConfirmrelation(confirmrelation);// ҪԶȷϵĿ굥ɵĹϵ
							if (global_batchno != null) {
								paramVO.setGlobal_batchno(global_batchno);//ȫκ
							}
							if(batchSize != null){
								paramVO.setBatch_size(batchSize);//
							}
							if (confirmPkList != null) {
								paramVO.setPkList(confirmPkList);
							}
							//΢޸
							destService.confirmBill(paramVO,confirmlist);
						}
					}
				} else {
					// Ŀ굥ݲҪȷϣеݶΪʽݣϵ¼ڹϵ
					if (savelist != null && !savelist.isEmpty()) {
						DestWFWParamsVO paramVO = new DestWFWParamsVO();
						paramVO.setScene(GenerateDestSceneEnum.FLAG_NOCONFIRM_TEMP);
						paramVO.setIsSum(UFBoolean.valueOf(isSum));//Ƿ
						paramVO.setSumBills(sumBills);//
						paramVO.setDesinfo(desinfo);//ĿϢ
						paramVO.setIsDraw(isDraw);//Ƿʽȡ
						paramVO.setSrcbill(srcbill);//Դ
						paramVO.setDellist_des(realdellist);
						paramVO.setPk_group((String) params.get("pk_group"));
						paramVO.setPk_billTypeCode((String) params.get("billtype"));
						paramVO.setSavelog(savelog);// ҪԶȷϵĿ굥ɵĹϵ
						if (global_batchno != null) {
							paramVO.setGlobal_batchno(global_batchno);//ȫκ
						}
						if(batchSize != null){
							paramVO.setBatch_size(batchSize);//
						}
						if (savePkList != null) {
							paramVO.setPkList(savePkList);
						}
						//΢޸
						destService.confirmBill(paramVO,savelist);
					}
					if (confirmlist != null && !confirmlist.isEmpty()) {
						DestWFWParamsVO paramVO = new DestWFWParamsVO();
						paramVO.setScene(GenerateDestSceneEnum.FLAG_NOCONFIRM_REAL);
						paramVO.setIsSum(UFBoolean.valueOf(isSum));//Ƿ
						paramVO.setSumBills(sumBills);//
						paramVO.setDesinfo(desinfo);//ĿϢ
						paramVO.setIsDraw(isDraw);//Ƿʽȡ
						paramVO.setPk_group((String) params.get("pk_group"));
						paramVO.setPk_billTypeCode((String) params.get("billtype"));
						paramVO.setConfirmrelation(confirmrelation);// ҪԶȷϵĿ굥ɵĹϵ
						if (global_batchno != null) {
							paramVO.setGlobal_batchno(global_batchno);//ȫκ
						}
						if(batchSize != null){
							paramVO.setBatch_size(batchSize);//
						}
						if (confirmPkList != null) {
							paramVO.setPkList(confirmPkList);
						}
						//΢޸
						destService.confirmBill(paramVO,confirmlist);
					}
				}
				//Ϣܽ
				if(generateParams != null && generateParams.get("batchSize") != null){
					if(savelist == null || savelist.size() == 0){
						SagasUtil.processMsgsResult(global_batchno, 1, batchSize, FipRedisKeyConst.REBUILD_KEY1, FipRedisKeyConst.REBUILD_KEY2);
					}
					if(confirmlist == null || confirmlist.size() == 0){
						SagasUtil.processMsgsResult(global_batchno, 1, batchSize, FipRedisKeyConst.REBUILD_KEY1, FipRedisKeyConst.REBUILD_KEY2);
					}
				}
				//ϲΪ0
				if(oplist != null && oplist.size() > 0){
					//ϲΪ0
					FipOperatingLogProxy ip = new FipOperatingLogProxy();
					String wherepart_oplog = " " + SqlTools.getInStr(OperatingLogVO.SRC_RELATIONID, src_relationids, false);
					OperatingLogVO[] oplogs = ip.queryByWhere(wherepart_oplog);
					if(oplogs != null){
						ip.deleteOplog(oplogs);
					}
					//ƽ̨־Ϣ
					ip.insert(oplist.toArray(new OperatingLogVO[0]));
				}
			} else {
				IDesBillService itf = FipInterfaceCenter.getDesBillService(pk_group, desBillType);
				if (itf == null)
					throw new BusinessException(FipInterfaceCenter.getNoInterfaceFoundMessage(desBillType, "IDesBillService"));
				if (itf.needConfirm() != null && itf.needConfirm().booleanValue()) {
					// Ŀ굥ʱݣҪȷϲʽݣҪԶȷϵĵݱΪʱݣϵڴ״̬ҪԶȷϵĵֱӱΪʽƾ֤ϢڹϢ
					if (savelist != null && !savelist.isEmpty()) {
						ArrayList<FipBasicRelationVO> addlist = new ArrayList<FipBasicRelationVO>();
						ArrayList<FipBasicRelationVO> updatelist = new ArrayList<FipBasicRelationVO>();

						Collection<FipSaveResultVO> rs = itf.saveBill(savelist);
						if (rs instanceof List) {
							for (int i = 0; i < savelog.size(); i++) {
								FipBasicRelationVO vo = savelog.get(i);
								FipSaveResultVO fipSaveResultVO = ((List<FipSaveResultVO>) rs).get(i);
								if (fipSaveResultVO == null || fipSaveResultVO.getBillVO() == null || fipSaveResultVO.getMessageinfo() == null) {
									vo.setDesRelation(null);
								} else {
									vo.setDesRelation(fipSaveResultVO.getMessageinfo());
								}
								vo.setOpmessage(null);
								if (vo.getPk_relation() == null) {
									addlist.add(vo);
								} else {
									updatelist.add(vo);
								}
							}
						} else {
							int index = 0;
							for (FipSaveResultVO fipSaveResultVO : rs) {
								FipBasicRelationVO vo = savelog.get(index);
								if (fipSaveResultVO == null || fipSaveResultVO.getBillVO() == null || fipSaveResultVO.getMessageinfo() == null) {
									vo.setDesRelation(null);
								} else {
									vo.setDesRelation(fipSaveResultVO.getMessageinfo());
								}
								if (vo.getPk_relation() == null) {
									addlist.add(vo);
								} else {
									updatelist.add(vo);
								}
								index++;
							}
						}
						if (addlist != null && !addlist.isEmpty()) {
							ArrayList<OperatingLogVO> vos = new ArrayList<OperatingLogVO>();
							for (FipBasicRelationVO operatingLogVO : addlist) {
								if (operatingLogVO.getDesRelation() == null)
									continue;
								OperatingLogVO opvo = operatingLogVO.convertToOperatingLogVO();
								opvo.setOpmessage(null);
								opvo.setOperateflag(OperatingFlagEmu.FLAG_saved);
								vos.add(opvo);
							}
							if (!vos.isEmpty())
								insert(vos);
						}
						if (updatelist != null && !updatelist.isEmpty()) {
							ArrayList<OperatingLogVO> vos = new ArrayList<OperatingLogVO>();
							List<String> pklist = new ArrayList<String>();
							for (FipBasicRelationVO operatingLogVO : updatelist) {
								if (operatingLogVO.getDesRelation() == null) {
									pklist.add(operatingLogVO.getPk_relation());
								} else {
									OperatingLogVO opvo = operatingLogVO.convertToOperatingLogVO();
									opvo.setOpmessage(null);
									opvo.setOperateflag(OperatingFlagEmu.FLAG_saved);
									vos.add(opvo);
								}
							}
							if (!vos.isEmpty())
								update(vos);
							if (!pklist.isEmpty()) {
								deleteByPKs(pklist.toArray(new String[0]));
							}
						}
					}
					if (confirmlist != null && !confirmlist.isEmpty()) {
						// ʽ ֱʽݵģĿ굥кϲڱǰҪһκϲ
						IDesBillSumService desBillSumService = FipInterfaceCenter.getDesBillSumService(pk_group, desBillType);
						if (desBillSumService != null) {
							for (FipSaveResultVO vo : confirmlist) {
								if (vo.getBillVO() == null) {
									continue;
								}
								FipBillSumRSVO svo = new FipBillSumRSVO();
								svo.setBillVO(vo.getBillVO());
								svo.setMessageinfo(vo.getMessageinfo());
								ArrayList<FipBillSumRSVO> volist = new ArrayList<FipBillSumRSVO>();
								volist.add(svo);
								Collection<FipBillSumRSVO> sumvolist = desBillSumService.querySumBill(volist, null);
								if (sumvolist != null && !sumvolist.isEmpty()) {
									FipBillSumRSVO ssvo = sumvolist.iterator().next();
									if (ssvo != null) {
										vo.setBillVO(ssvo.getBillVO());
										vo.setMessageinfo(ssvo.getMessageinfo());
									} else {
										vo.setBillVO(null);
									}
								} else {
									vo.setBillVO(null);
								}
							}
						}
						// ϲΪ0Ҫ
						ArrayList<FipBasicRelationVO> addlist = new ArrayList<FipBasicRelationVO>();
						ArrayList<FipBasicRelationVO> dellist = new ArrayList<FipBasicRelationVO>();
						int size = confirmlist.size();
						for (int i = size - 1; i >= 0; i--) {
							FipBasicRelationVO vo = confirmrelation.get(i);
							FipSaveResultVO fipSaveResultVO = confirmlist.get(i);
							if (fipSaveResultVO == null || fipSaveResultVO.getBillVO() == null || fipSaveResultVO.getMessageinfo() == null) {
								vo.setDesRelation(null);
								if (vo.getPk_relation() != null) {
									dellist.add(vo);
								}
								confirmlist.remove(i);
								confirmrelation.remove(i);
							}
						}
						Collection<FipSaveResultVO> rs = itf.confirmBill(confirmlist);
						if (rs instanceof List) {
							for (int i = 0; i < rs.size(); i++) {
								FipBasicRelationVO vo = confirmrelation.get(i);
								FipSaveResultVO fipSaveResultVO = ((List<FipSaveResultVO>) rs).get(i);
								if (fipSaveResultVO == null || fipSaveResultVO.getBillVO() == null || fipSaveResultVO.getMessageinfo() == null) {
									vo.setDesRelation(null);
								} else {
									vo.setDesRelation(fipSaveResultVO.getMessageinfo());
								}
								if (vo.getPk_relation() == null) {
									addlist.add(vo);
								} else {
									dellist.add(vo);
								}
							}
						} else {
							int index = 0;
							for (FipSaveResultVO fipSaveResultVO : rs) {
								FipBasicRelationVO vo = confirmrelation.get(index);
								if (fipSaveResultVO == null || fipSaveResultVO.getBillVO() == null || fipSaveResultVO.getMessageinfo() == null) {
									vo.setDesRelation(null);
								} else {
									vo.setDesRelation(fipSaveResultVO.getMessageinfo());
								}
								if (vo.getPk_relation() == null) {
									addlist.add(vo);
								} else {
									dellist.add(vo);
								}
								index++;
							}
						}
						if (dellist != null && !dellist.isEmpty()) {
							List<String> pklist = new ArrayList<String>();
							for (FipBasicRelationVO operatingLogVO : dellist) {
								pklist.add(operatingLogVO.getPk_relation());
							}
							deleteByPKs(pklist.toArray(new String[0]));
						}
						addlist.addAll(dellist);
						if (addlist != null && !addlist.isEmpty()) {
							ArrayList<FipRelationVO> vos = new ArrayList<FipRelationVO>();
							for (FipBasicRelationVO operatingLogVO : addlist) {
								if (operatingLogVO.getDesRelation() == null)
									continue;
								operatingLogVO.setOpmessage(null);
								vos.add(operatingLogVO.convertToRelationVO());
							}
							if (!vos.isEmpty())
								new FipRelationBO().insert(vos);
						}
					}
				} else {
					// Ŀ굥ݲҪȷϣеݶΪʽݣϵ¼ڹϵ
					ArrayList<FipBasicRelationVO> addlist = new ArrayList<FipBasicRelationVO>();
					ArrayList<FipBasicRelationVO> dellist = new ArrayList<FipBasicRelationVO>();
					if (savelist != null && !savelist.isEmpty()) {
						Collection<FipSaveResultVO> rs = itf.confirmBill(savelist);
						if (rs instanceof List) {
							for (int i = 0; i < savelog.size(); i++) {
								FipBasicRelationVO vo = savelog.get(i);
								FipSaveResultVO fipSaveResultVO = ((List<FipSaveResultVO>) rs).get(i);
								if (fipSaveResultVO == null || fipSaveResultVO.getBillVO() == null || fipSaveResultVO.getMessageinfo() == null) {
									vo.setDesRelation(null);
								} else {
									vo.setDesRelation(fipSaveResultVO.getMessageinfo());
								}
								if (vo.getPk_relation() == null) {
									addlist.add(vo);
								} else {
									dellist.add(vo);
								}
							}
						} else {
							int index = 0;
							for (FipSaveResultVO fipSaveResultVO : rs) {
								FipBasicRelationVO vo = savelog.get(index);
								if (fipSaveResultVO == null || fipSaveResultVO.getBillVO() == null || fipSaveResultVO.getMessageinfo() == null) {
									vo.setDesRelation(null);
								} else {
									vo.setDesRelation(fipSaveResultVO.getMessageinfo());
								}
								if (vo.getPk_relation() == null) {
									addlist.add(vo);
								} else {
									dellist.add(vo);
								}
								index++;
							}
						}
					}
					if (confirmlist != null && !confirmlist.isEmpty()) {
						Collection<FipSaveResultVO> rs = itf.confirmBill(confirmlist);
						if (rs instanceof List) {
							for (int i = 0; i < rs.size(); i++) {
								FipBasicRelationVO vo = confirmrelation.get(i);
								FipSaveResultVO fipSaveResultVO = ((List<FipSaveResultVO>) rs).get(i);
								if (fipSaveResultVO == null || fipSaveResultVO.getBillVO() == null || fipSaveResultVO.getMessageinfo() == null) {
									vo.setDesRelation(null);
								} else {
									vo.setDesRelation(fipSaveResultVO.getMessageinfo());
								}
								if (vo.getPk_relation() == null) {
									addlist.add(vo);
								} else {
									dellist.add(vo);
								}
							}
						} else {
							int index = 0;
							for (FipSaveResultVO fipSaveResultVO : rs) {
								FipBasicRelationVO vo = confirmrelation.get(index);
								if (fipSaveResultVO == null || fipSaveResultVO.getBillVO() == null || fipSaveResultVO.getMessageinfo() == null) {
									vo.setDesRelation(null);
								} else {
									vo.setDesRelation(fipSaveResultVO.getMessageinfo());
								}
								if (vo.getPk_relation() == null) {
									addlist.add(vo);
								} else {
									dellist.add(vo);
								}
								index++;
							}
						}
					}
					if (dellist != null && !dellist.isEmpty()) {
						List<String> pklist = new ArrayList<String>();
						for (FipBasicRelationVO operatingLogVO : dellist) {
							pklist.add(operatingLogVO.getPk_relation());
						}
						deleteByPKs(pklist.toArray(new String[0]));
					}
					addlist.addAll(dellist);
					if (addlist != null && !addlist.isEmpty()) {
						ArrayList<FipRelationVO> vos = new ArrayList<FipRelationVO>();
						for (FipBasicRelationVO operatingLogVO : addlist) {
							if (operatingLogVO.getDesRelation() == null)
								continue;
							operatingLogVO.setOpmessage(null);
							vos.add(operatingLogVO.convertToRelationVO());
						}
						if (!vos.isEmpty())
							new FipRelationBO().insert(vos);
					}
				}
			}
		}
	}
	
	/**
	 * ƾ֤󣬴ƽ̨ϵ
	 * @param scene Ŀ굥ݵĳ
	 * @param dataMap Ŀ굥Ҫҵ
	 * @param rs Ŀ굥
	 * @throws BusinessException
	 */
	public void handleFipMessageAfterDispose(DestWFWParamsVO dataVO) {
		try{
			IFipMsgCallbackProcessService ip = NCLocator.getInstance().lookup(IFipMsgCallbackProcessService.class);
			ip.processFipMsgAfterDispose(dataVO);
		}catch(BusinessException ex){
			Logger.error(ex.getMessage(), ex);
		}
	}

	/**
	 * ˵
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param opstate
	 * 
	 * @param pkOperatinglog
	 * @see
	 * @since V6.0
	 */
	public void processByPK(String pk, int opstate) throws BusinessException {
		//УǷ΢,岿߼ֿ
		boolean isMerged = NCCEnv.isMerged();
		if(!isMerged){
			IOperatingLog ip = NCLocator.getInstance().lookup(IOperatingLog.class);
			//״̬Ϊִ
			ip.processRunningFlag_RequiresNew(pk, opstate);
		} else {
			processRunningFlag(pk, opstate);
		}
		ArrayList<String> pklist = new ArrayList<String>();
		pklist.add(pk);
		// 
		recomputeByPKs_atomic(pklist, false, null);
	}
	
	public void processRunningFlag(String pk, int opstate) throws BusinessException {
		// Ϊ˷ֹ֮ûȺݿ⼶ȴ
		String locksql = "update " + OperatingLogVO.getDefaultTableName() + " set " + OperatingLogVO.OPERATEFLAG + "=" + OperatingFlagEmu.FLAG_running + " where " + OperatingLogVO.OPERATEFLAG + "=" + opstate + " and " + OperatingLogVO.PK_OPERATINGLOG + "='" + pk + "' ";
		int upcount = new BaseDAO().executeUpdate(locksql);
		if (upcount != 1)
			return;
	}

	/**
	 * ˵
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param opstate
	 * 
	 * @param pkOperatinglog
	 * @see
	 * @since V6.0
	 */
	public void processAndLog(String pk, int opstate) throws BusinessException {
		//УǷ΢,岿߼ֿ
		boolean isMerged = NCCEnv.isMerged();
		try {
			IOperatingLog ip = NCLocator.getInstance().lookup(IOperatingLog.class);
			ip.process_RequiresNew(pk, opstate);
		} catch (BusinessException e) {
			// гִ
			Logger.error("", e);
			if (pk != null) {
				String msg = e.getMessage();
				if (msg != null && msg.length() > 500) {
					msg = msg.substring(0, 500);
				}
				//΢񳡾УϢʼʱȽ״̬óFLAG_running
				if(!isMerged){
					opstate = OperatingFlagEmu.FLAG_running;
				}
				String upsql = "update " + OperatingLogVO.getDefaultTableName() + " set " + OperatingLogVO.OPERATEFLAG + "=" + OperatingFlagEmu.FLAG_error_on_generate + "," + OperatingLogVO.OPMESSAGE + "='" + msg + "' where " + OperatingLogVO.PK_OPERATINGLOG + "='" + pk + "' and " + OperatingLogVO.OPERATEFLAG + "=" + opstate + " ";
				new BaseDAO().executeUpdate(upsql);
			}
		} catch (Exception e) {
			// гִ
			Logger.error("", e);
			if (pk != null) {
				String msg = e.getMessage();
				if (msg != null && msg.length() > 500) {
					msg = msg.substring(0, 500);
				}
				//΢񳡾УϢʼʱȽ״̬óFLAG_running
				if(!isMerged){
					opstate = OperatingFlagEmu.FLAG_running;
				}
				String upsql = "update " + OperatingLogVO.getDefaultTableName() + " set " + OperatingLogVO.OPERATEFLAG + "=" + OperatingFlagEmu.FLAG_error_on_generate + "," + OperatingLogVO.OPMESSAGE + "='" + msg + "' where " + OperatingLogVO.PK_OPERATINGLOG + "='" + pk + "' and " + OperatingLogVO.OPERATEFLAG + "=" + opstate + " ";
				new BaseDAO().executeUpdate(upsql);
			}
		}
	}

	public Integer getBatchSize() {
		return batchSize;
	}

	public void setBatchSize(Integer batchSize) {
		this.batchSize = batchSize;
	}
}