/**
 *
 */
package nc.impl.fip.service.pub;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;
import java.util.Vector;

import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.logging.Logger;
import nc.bs.pf.pub.BillTypeCacheKey;
import nc.bs.pf.pub.PfDataCache;
import nc.impl.fip.message.FipMessageImpl;
import nc.impl.fip.messagelogs.FipMessageLogsProxy;
import nc.impl.fip.operatinglog.FipOperatingLogProxy;
import nc.impl.fip.relation.FipRelationProxy;
import nc.impl.fip.sumrelation.FipSumRelationProxy;
import nc.itf.fip.cache.memcache.FipConfigCache;
import nc.itf.fip.message.IFipMessage;
import nc.itf.fip.messageprocess.MessageProcessCenter;
import nc.itf.fip.opreatinglog.IOperatingLog;
import nc.itf.fip.pub.FipBillVOAdapter;
import nc.itf.fip.pub.FipInterfaceCenter;
import nc.itf.fip.pub.formula.FipFormulaParser;
import nc.itf.fip.relation.IFipRelation;
import nc.itf.fip.sumrelation.IFipSumRelation;
import nc.itf.fip.trans.BOTranslateCenter;
import nc.pub.fip.pubtools.FipBSCacheCleaner;
import nc.pub.fip.pubtools.FipSceneUtil;
import nc.pub.fip.pubtools.SagasUtil;
import nc.pubitf.fip.external.IBillReflectorService;
import nc.pubitf.fip.external.IBillSumService;
import nc.pubitf.fip.service.IFipBillProcessService;
import nc.pubitf.fip.service.IFipInterfaceCenterService;
import nc.pubitf.fip.service.IFipSagasCompensateCall;
import nc.vo.fip.config.ConfigVO;
import nc.vo.fip.config.ProcessConfigVO;
import nc.vo.fip.external.FipBillSumRSVO;
import nc.vo.fip.external.FipExtendAggVO;
import nc.vo.fip.messagelogs.MessageLogVO;
import nc.vo.fip.operatinglogs.FipRollbackSceneEnum;
import nc.vo.fip.operatinglogs.OperatingFlagEmu;
import nc.vo.fip.operatinglogs.OperatingLogVO;
import nc.vo.fip.operatinglogs.OperatinglogSceneEnum;
import nc.vo.fip.pub.SqlTools;
import nc.vo.fip.relation.FipRelationVO;
import nc.vo.fip.service.FipBasicRelationVO;
import nc.vo.fip.service.FipExtRelationVO;
import nc.vo.fip.service.FipMessageVO;
import nc.vo.fip.service.FipMsgResultVO;
import nc.vo.fip.service.FipRelationInfoVO;
import nc.vo.fip.sumrelation.SumRelationVO;
import nc.vo.fip.trans.FipTransVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.billtype.BilltypeVO;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;

import com.yonyou.cloud.ncc.NCCEnv;
import com.yonyou.cloud.ncc.NCCSagas;

/**
 * <p>
 * TODO ӿ/๦˵ʹ˵ӿǷΪʹߣǷ̰߳ȫȣ
 * </p>
 * 
 * ޸ļ¼<br>
 * <li>޸ˣ޸ڣ޸ݣ</li> <br>
 * <br>
 * 
 * @see
 * @author gbh
 * @version V6.0
 * @since V6.0 ʱ䣺2010-3-25 02:42:45
 */
public class FipMessageBO {
	
	public FipMsgResultVO[] sendMessages(FipMessageVO[] fipmessagevos) throws BusinessException {
		//УǷ΢,岿߼ֿ
		boolean isMerged = NCCEnv.isMerged();
		if(isMerged) {
			FipBSCacheCleaner.clearAllCache();
		}
		FipMsgResultVO[] rs = null;
		if (fipmessagevos != null && fipmessagevos.length > 0) {
			// ϢĺϷ
			checkMessages(fipmessagevos);
			if(!isMerged) {
				rs = processMessages_microservice(fipmessagevos, false);
			}else {
				// ¼Ϣ־
				logMessages(fipmessagevos);
				rs = processMessages(fipmessagevos);
			}
		}
		return rs;
	}
	
	public FipMsgResultVO[] sendMessages(FipMessageVO[] fipmessagevos, boolean isBatch) throws BusinessException {
		//УǷ΢,岿߼ֿ
		boolean isMerged = NCCEnv.isMerged();
		if(isMerged) {
			FipBSCacheCleaner.clearAllCache();
		}
		FipMsgResultVO[] rs = null;
		if (fipmessagevos != null && fipmessagevos.length > 0) {
			// ϢĺϷ
			checkMessages(fipmessagevos);
			rs = processMessages_microservice(fipmessagevos, isBatch);
		}
		return rs;
	}

	/**
	 * ϢΪ
	 * 
	 * @param fipmessagevo
	 * @return
	 * @throws BusinessException
	 */
	private FipMsgResultVO[] processMessages(FipMessageVO[] fipmessagevo) throws BusinessException {
		FipMsgResultVO[] rs = null;
		ArrayList<FipMessageVO> addlist = new ArrayList<FipMessageVO>();
		ArrayList<FipMessageVO> dellist = new ArrayList<FipMessageVO>();
		for (int i = 0; i < fipmessagevo.length; i++) {
			if (fipmessagevo[i].getMessagetype() == FipMessageVO.MESSAGETYPE_ADD) {
				addlist.add(fipmessagevo[i]);
			} else if (fipmessagevo[i].getMessagetype() == FipMessageVO.MESSAGETYPE_DEL) {
				dellist.add(fipmessagevo[i]);
			}
		}
		if (!addlist.isEmpty() && !dellist.isEmpty()) {
			throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0038")/* @res "ƽ̨治֧Ӻɾһҵдֿͻƽ̨" */);
		} else {
			if (!addlist.isEmpty()) {
				List<FipMsgResultVO> list = addMessageArray(addlist, null);
				if (list != null && !list.isEmpty()) {
					rs = new FipMsgResultVO[list.size()];
					list.toArray(rs);
				}
			} else if (!dellist.isEmpty()) {
				deleteMessageArray(dellist);
			}
		}
		return rs;
	}
	
	/**
	 * ϢΪ
	 * 
	 * @param fipmessagevo
	 * @param logvos
	 * @return
	 * @throws BusinessException
	 */
	private FipMsgResultVO[] processMessages_microservice(FipMessageVO[] fipmessagevo, boolean isBatch) throws BusinessException {
		//addsaga,˲ӿ񲻽ȥ
		NCCSagas.startAddSaga();
		FipMsgResultVO[] rs = null;
		OperatingLogVO[] logvos = null;
		ArrayList<FipMessageVO> addlist = new ArrayList<FipMessageVO>();
		ArrayList<FipMessageVO> dellist = new ArrayList<FipMessageVO>();
		for (int i = 0; i < fipmessagevo.length; i++) {
			if (fipmessagevo[i].getMessagetype() == FipMessageVO.MESSAGETYPE_ADD) {
				addlist.add(fipmessagevo[i]);
			} else if (fipmessagevo[i].getMessagetype() == FipMessageVO.MESSAGETYPE_DEL) {
				dellist.add(fipmessagevo[i]);
			}
		}
		if (!addlist.isEmpty() && !dellist.isEmpty()) {
			throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0038")/* @res "ƽ̨治֧Ӻɾһҵдֿͻƽ̨" */);
		} else {
			try{
				if (!addlist.isEmpty()) {
					//ȡɵĳ
					String scene = FipSceneUtil.getGenerateScene();
					//ɾʼϢ
					if (OperatinglogSceneEnum.GENERATE_CONFIRM_INITLOG.equals(scene)) {
						List<String> srcRelationids = new ArrayList<String>();
						for (FipMessageVO messagevo : addlist) {
							srcRelationids.add(messagevo.getMessageinfo().getRelationID());
						}
						if (srcRelationids.size() > 0) {
							String wherepart = SqlTools.getInStr(OperatingLogVO.SRC_RELATIONID, srcRelationids, true);
							OperatingLogVO[] oplogvos = new FipOperatingLogProxy().queryByWhere(wherepart);
							if (oplogvos != null && oplogvos.length > 0) {
								//ݽм
								SagasUtil.addDynamicLock(oplogvos);
								SagasUtil.checkBillsTs(oplogvos);
								//ɾƽ̨־Ϣ
								new FipOperatingLogProxy().deleteOplog(oplogvos);
							}
						}
					}
					//¼Ϣ־ƽ̨־ʼϢ,¼ĳʼϢ,̽޸,ɾȲ
					logvos = logMessages_microservice(addlist.toArray(new FipMessageVO[0]), isBatch);
					Map<String,Serializable> paramMap = new HashMap<String,Serializable>();
					paramMap.put("logvos", logvos);//ʼϢ
					paramMap.put("fipmessagevos", addlist);//ƽ̨Ϣ
					paramMap.put("scene", FipRollbackSceneEnum.GENERATE_ROLLBACK);//ƾ֤Ļ˲
					//ҵ񵥾ݴƽ̨첽߼,Ϊص߼
					if(OperatinglogSceneEnum.GENERATE_CONFIRM_DEFAULT.equals(scene)){
						//ע˽ӿڣҵ񵥾ݵʱִлƽ̨Ĳ߼
						NCCSagas.compensate(IFipSagasCompensateCall.class, paramMap);
						//עconfirmӿڣƾ֤
						SagasUtil.confirm(OperatinglogSceneEnum.GENERATE_CONFIRM, paramMap);
					} else {
						//ԳʼϢжᣬҪǼ¼ȫID쳣ʱ쳣׷
						NCCSagas.startNewSaga();
						String gtxid = NCCSagas.getGtxid();//ȫid
						String ltxid = NCCSagas.getTxid(); //id
						//дΪ
						if(logvos != null && logvos.length > 0) {
							for(OperatingLogVO logvo : logvos) {
								logvo.setOperateflag(OperatingFlagEmu.FLAG_init_running);
								logvo.setSaga_gtxid(gtxid);
								logvo.setSaga_btxid(ltxid);
							}
						}
						//ò񣬷ֹʼϢinsertupdateķ
						NCLocator.getInstance().lookup(IOperatingLog.class).update(logvos);
						//΢񳡾洦ʱ
						FipBSCacheCleaner.clearAllCache();
						//ɻƽ̨Ϣ
						addMessageArray_microservice(addlist, logvos);
					}
				} else if (!dellist.isEmpty()) {
					//ɾƾ֤¼ʼϢ,ֻ¼fip_messagelogϢ
					logMessages(dellist.toArray(new FipMessageVO[0]));
					//ɾƾ֤Ϣ
					deleteMessageArray(dellist);
				}
			} catch(Exception e) {
				String errMsg = null;
				if (e.getMessage() != null) {
					if (e instanceof DAOException) {
						if (e.getMessage().indexOf("ORA-") > 0) {
							int index = e.getMessage().indexOf("ORA-");
							int index1 = e.getMessage().indexOf("ORA-",index + 1);
							if (index1 > index) {
								errMsg = e.getMessage().substring(index, index1);
							} else {
								errMsg = e.getMessage().substring(index);
							}
						} else {
							errMsg = e.getMessage();
						}
					} else {
						errMsg = e.getMessage();
					}
				}
				throw new BusinessException(errMsg != null ? errMsg : (e.getCause() != null ? e.getCause().getMessage() : e.getMessage()));
			}
		}
		return rs;
	}

	/**
	 * ϢĺϷ
	 * 
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param fipmessagevos
	 * @throws BusinessException
	 * @see
	 * @since V6.0
	 */
	public void checkMessages(FipMessageVO[] fipmessagevos) throws BusinessException {
		for (FipMessageVO fipmessagevo : fipmessagevos) {
			FipRelationInfoVO infovo = fipmessagevo.getMessageinfo();
			if (infovo == null)
				throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0039")/* @res "MessageinfoΪ" */);
			if (infovo.getPk_group() == null)
				throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0040")/* @res "ŲΪ" */);
			if (infovo.getPk_org() == null)
				throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0041")/* @res "֯Ϊ" */);
			if (infovo.getPk_system() == null)
				throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0042")/* @res "ԴϵͳΪ" */);
			if (infovo.getPk_billtype() == null)
				throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0043")/* @res "ͲΪ" */);
			if (infovo.getPk_operator() == null)
				infovo.setPk_operator(InvocationInfoProxy.getInstance().getUserId());
			if (infovo.getPk_operator() == null)
				throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0044")/* @res "ԱΪ" */);
			if (infovo.getBusidate() == null)
				infovo.setBusidate(new UFDate());
			if (fipmessagevo.getMessagetype() == FipMessageVO.MESSAGETYPE_ADD) {
				if (infovo.getFreedef3() == null || infovo.getFreedef3().trim().length() == 0) {
					infovo.setFreedef3("0.00");
				} else {
					new UFDouble(infovo.getFreedef3());
				}
			}
		}
	}

	/**
	 * ¼Ϣ־
	 * 
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param fipmessagevos
	 * @throws BusinessException
	 * @see
	 * @since V6.0
	 */
	private void logMessages(FipMessageVO[] fipmessagevos) throws BusinessException {
		// ȣȼ¼һ־ʾϢѾ˻ƽ̨
		MessageLogVO[] logvos = new MessageLogVO[fipmessagevos.length];
		for (int i = 0; i < logvos.length; i++) {
			logvos[i] = fipmessagevos[i].convertToMessageLogVO();
		}
		new FipMessageLogsProxy().insert(logvos);
	}
	
	/**
	 * ΢,¼Ϣ־ƽ̨־ʼϢ
	 * 
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param fipmessagevos
	 * @return OperatingLogVO[]
	 * @throws BusinessException
	 * @see
	 * @since V6.0
	 */
	private OperatingLogVO[] logMessages_microservice(FipMessageVO[] fipmessagevos, boolean isBatch) throws BusinessException {
		//һ񱣴Ϣfip_messagelogfip_operatinglog
		//IFipMsgLog ip1 = NCLocator.getInstance().lookup(IFipMsgLog.class);
		return new FipMessageLogsProxy().insert_RequiresNew(fipmessagevos, isBatch);
	}

	/**
	 * ˵
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param fipRelationVO
	 * @param fipmessagevo
	 * @return
	 * @throws BusinessException
	 * @see
	 * @since V6.0
	 */
	private FipMsgResultVO addMessageAndSaveBill(FipExtRelationVO fipRelationVO, FipMessageVO fipmessagevo) throws BusinessException {
		if (fipRelationVO == null)
			throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0045")/* @res "ĲfipRelationVO̸òΪա" */);
		FipMsgResultVO rs = null;
		FipBasicRelationVO relation = null;
		{
			// һҪɵĵݷŵܴ
			if (fipRelationVO.getIssum() != null && fipRelationVO.getIssum().booleanValue()) {
				// ҪܵݣȴܵϢ
				FipSumRelationProxy ip = new FipSumRelationProxy();
				ip.insert(new SumRelationVO[] { fipRelationVO.convertToSumRelationVO() });
				return rs;
			} else {
				// Ҫܵݣ
			}
		}
		OperatingLogVO oplogvo = null;
		IOperatingLog ip = new FipOperatingLogProxy();
		// {
		// // ڶϢ뵽״̬УΪδ
		// oplogvo = fipRelationVO.convertToOperatingLogVO();
		// oplogvo.setOperateflag(0);
		// }
		{
			// ϢΪ
			// oplogvo.setOperateflag(1);
			// еݵת
			FipTransVO transvo = new FipTransVO();
			transvo.setDatavo(fipmessagevo.getBillVO());
			transvo.setMessagevo(fipRelationVO);
			List<FipTransVO> rslist = BOTranslateCenter.translate(transvo);
			if (rslist == null || rslist.isEmpty()) {
				// ƾ֤ģΪʱɣɵʱ򣬲תĽ
				return rs;
			}
			// Ĳתĵ
			FipTransVO rsvo = rslist.get(0);
			if (rsvo.getMessagevo().getOpmessage() == null) {
				if (rsvo.getIsEffect() != null && rsvo.getIsEffect().booleanValue()) {
					// Ӱҵ
					List<OperatingLogVO> volist = new FipMessageImpl().saveDesBill_RequiresNew(rslist);
					if (volist != null && !volist.isEmpty())
						oplogvo = volist.get(0);
				} else {
					try {
						IFipMessage ip1 = NCLocator.getInstance().lookup(IFipMessage.class);
						List<OperatingLogVO> volist = ip1.saveDesBill_RequiresNew(rslist);
						if (volist != null && !volist.isEmpty())
							oplogvo = volist.get(0);
					} catch (BusinessException e) {
						Logger.error("", e);
						oplogvo = fipRelationVO.convertToOperatingLogVO();
						oplogvo.setOpmessage(e.getMessage());
						oplogvo.setOperateflag(OperatingFlagEmu.FLAG_no_process);
						/*УǷ΢,岿߼ֿ*/
						boolean isMerged = NCCEnv.isMerged();
						if(!isMerged){
							ip.insert(new OperatingLogVO[] { oplogvo });
						}
					}
				}
			} else {
				oplogvo = rsvo.getMessagevo().convertToOperatingLogVO();
				oplogvo.setOperateflag(OperatingFlagEmu.FLAG_no_process);
			}
		}
		if (oplogvo == null) {
			// ϼƽΪ0ûб浥
		} else {
			if (oplogvo.getOpmessage() == null)
				relation = FipBasicRelationVO.convertFromOperatingVO(oplogvo);
			if (oplogvo.getDes_relationid() != null) {
				if (oplogvo.getOperateflag() != OperatingFlagEmu.FLAG_confirmed) {
					ip.insert(new OperatingLogVO[] { oplogvo });
				} else {
					IFipRelation ip1 = new FipRelationProxy();
					ip1.insert(new FipRelationVO[] { relation.convertToRelationVO() });
				}
			}
		}
		rs = new FipMsgResultVO();
		rs.addRelation(relation);
		return rs;
	}
	
	/*
	 * -(΢ô˷)
	 */
	@SuppressWarnings("unchecked")
	private List<FipMsgResultVO> addMessageAndSaveBillBatch(List<FipExtRelationVO> fipRelationlist, List<FipMessageVO> fipmessagelist, Map<String,Object> params) throws BusinessException {
		List<FipMsgResultVO> rs = new ArrayList<FipMsgResultVO>();
		{
			List<FipTransVO> translist = new ArrayList<FipTransVO>();// Ҫ
			List<FipTransVO> errlist = new ArrayList<FipTransVO>();// ת̳
			List<FipTransVO> effectlist = new ArrayList<FipTransVO>();// ʧӰҵ̵
			List<FipTransVO> uneffectlist = new ArrayList<FipTransVO>();// ʧܲӰҵ̵
			for(int i = 0;i < fipRelationlist.size();i++){
				FipExtRelationVO fipRelationVO = fipRelationlist.get(i);
				FipMessageVO fipmessagevo = fipmessagelist.get(i);
				// еݵת
				FipTransVO transvo = new FipTransVO();
				translist.add(transvo);
				transvo.setDatavo(fipmessagevo.getBillVO());
				transvo.setMessagevo(fipRelationVO);
			}
			List<String> messageList = new ArrayList<String>();//ҪɾĳʼϢ
			List<FipBillSumRSVO> sumBillsList = null;
			FipRelationInfoVO desinfo = null;
			if(params != null){
				sumBillsList = (List<FipBillSumRSVO>) params.get("sumvos");//
				desinfo = (FipRelationInfoVO) params.get("desinfo");//ĿϢ
			}
			if (!translist.isEmpty()) {
				List<FipTransVO> transrslist = new ArrayList<FipTransVO>();
				int index = 0;
				for (FipTransVO transvo : translist) {
					List<FipTransVO> rslist = null;
					try{
						rslist = BOTranslateCenter.translate(transvo);
					} catch (Exception e) {
						FipTransVO rsvo = new FipTransVO();
						rsvo.setMessagevo(transvo.getMessagevo());
						rsvo.getMessagevo().setOpmessage(e.getMessage());
						rsvo.setDatavo(null);
						rsvo.setIsAutoConfirm(UFBoolean.FALSE);
						if (rslist == null) {
							rslist = new ArrayList<FipTransVO>();
						}
						rslist.add(rsvo);
						if(sumBillsList != null){
							FipBillSumRSVO sumrsvo = sumBillsList.get(index);
							if(sumrsvo != null){
								FipRelationInfoVO[] relations = sumrsvo.getRelationvos();
								for(FipRelationInfoVO relation : relations){
									messageList.add(relation.getRelationID());
								}
							}
						}
					}
					//תģò
					if(rslist == null || rslist.isEmpty()){
						if(sumBillsList != null){
							FipBillSumRSVO sumrsvo = sumBillsList.get(index);
							if(sumrsvo != null){
								FipRelationInfoVO[] relations = sumrsvo.getRelationvos();
								for(FipRelationInfoVO relation : relations){
									messageList.add(relation.getRelationID());
								}
							}
						}
					}
					index++;
					if (rslist == null || rslist.isEmpty()) {
						// ƾ֤ģΪʱɣɵʱ򣬲תĽ
						continue;
					}
					for (FipTransVO fipTransVO : rslist) {
						transrslist.add(fipTransVO);
					}
				}
				//ɾʼϢƾ֤תʧܣʱ
				if(messageList.size() > 0){
					deleteByRelationIds(messageList);
				}
				for (FipTransVO rsvo : transrslist) {
					// תɹģϢΪ
					if (rsvo.getMessagevo().getOpmessage() == null) {
						if (rsvo.getIsEffect() != null && rsvo.getIsEffect().booleanValue()) {
							// Ӱҵ
							effectlist.add(rsvo);
						} else {
							uneffectlist.add(rsvo);
						}
					} else {
						errlist.add(rsvo);
					}
				}
			}
			
			List<OperatingLogVO> oplist = new ArrayList<OperatingLogVO>();// ¼ʱ
			List<FipRelationVO> relist = new ArrayList<FipRelationVO>();// ¼ʽ
			//Ӱ̻ǲӰ̣Ҫƽ̨ϢĿϵͳ
			String gtxid = NCCSagas.getGtxid();//ȫid
			String ltxid = NCCSagas.getTxid(); //id
			if (!effectlist.isEmpty()) {
				try{
					new FipMessageImpl().saveDesBill_RequiresNew(effectlist,UFBoolean.valueOf(true),params);
				} catch (Exception e){
					Logger.error(e.getMessage(), e);
					OperatingLogVO vo = null;
					for (FipTransVO fipTransVO : effectlist) {
						vo = fipTransVO.getMessagevo().convertToOperatingLogVO();
						vo.setOpmessage(e.getMessage());
						vo.setOperateflag(OperatingFlagEmu.FLAG_no_process);
						vo.setSaga_gtxid(gtxid);
						vo.setSaga_btxid(ltxid);
						//΢Ŀ굥ݱʧҪ¼־
						oplist.add(vo);
					}
				}
			}
			if (!errlist.isEmpty()) {
				// ת̳
				for (FipTransVO fipTransVO : errlist) {
					OperatingLogVO vo = fipTransVO.getMessagevo().convertToOperatingLogVO();
					vo.setOperateflag(OperatingFlagEmu.FLAG_no_process);
					vo.setSaga_gtxid(gtxid);
					vo.setSaga_btxid(ltxid);
					oplist.add(vo);
				}
			}
			if (!uneffectlist.isEmpty()) {
				try{
					new FipMessageImpl().saveDesBill_RequiresNew(uneffectlist,UFBoolean.valueOf(false),params);
				} catch (Exception e){
					Logger.error(e.getMessage(), e);
					OperatingLogVO vo = null;
					for (FipTransVO fipTransVO : uneffectlist) {
						vo = fipTransVO.getMessagevo().convertToOperatingLogVO();
						vo.setOpmessage(e.getMessage());
						vo.setOperateflag(OperatingFlagEmu.FLAG_no_process);
						vo.setSaga_gtxid(gtxid);
						vo.setSaga_btxid(ltxid);
						//΢Ŀ굥ݱʧҪ¼־
						oplist.add(vo);
					}
				}
			}
			if (!oplist.isEmpty()) {
				//sagasκ,쳣ͬʱ¼ƾ֤Ϣsagas_business_log
				String sagas_business_batch_no = SagasUtil.generateUID();
				for(OperatingLogVO logvo : oplist){
					if(logvo != null){
						logvo.setBatchno(sagas_business_batch_no);
					}
				}
				FipOperatingLogProxy ip = new FipOperatingLogProxy();
				OperatingLogVO[] oplogs = ip.insert(oplist.toArray(new OperatingLogVO[0]));
				//ƽ̨תʧʱsumrelationoperatinglogϢ
				if(messageList.size() > 0){
					if(sumBillsList != null){
						for(FipBillSumRSVO fipBillSumRSVO : sumBillsList){
							updateSumRelation(fipBillSumRSVO, desinfo);
						}
					}
				}
				//ɾʼϢ 
				List<String> src_relationids = new ArrayList<String>();//Դrelationid
				for(OperatingLogVO oplog : oplogs){
					src_relationids.add(oplog.getSrc_relationid());
				}
				this.deleteByRelationIds(src_relationids);
				//ʹϢ
				Map<String, Object> errMap = new HashMap<String, Object>();
				errMap.put("pks", src_relationids);
				errMap.put("scene", OperatinglogSceneEnum.GENERATE_FORWARD);
				errMap.put("errMsg", nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10170410", "1101704100034"));
				errMap.put("msg", nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10170410", "1101704100034"));
				errMap.put("sagas_business_batch_no", sagas_business_batch_no);
				//ϢĲwebsocketϢ
				SagasUtil.saveAndPushErrorMsg(errMap);
			}
			if (!relist.isEmpty()) {
				FipRelationProxy ip = new FipRelationProxy();
				ip.insert(relist.toArray(new FipRelationVO[0]));
			}
		}	
		return rs;
	}
	
	/*
	 * ·
	 */
	private void updateSumRelation(FipBillSumRSVO fipBillSumRSVO, FipRelationInfoVO desinfo) throws BusinessException{
		FipRelationInfoVO[] relationvos = fipBillSumRSVO.getRelationvos();
		if (relationvos != null) {
			String relationID = fipBillSumRSVO.getMessageinfo().getRelationID();
			updateSumRelation(relationID, relationvos, desinfo);
		}
	}

	private ProcessConfigVO[] processByConfig(FipMessageVO fipmessagevo) throws BusinessException {
		// ݻƽ̨ýд
		ProcessConfigVO[] processedvos = null;
		ConfigVO[] vos = FipConfigCache.getCacheData(fipmessagevo.getMessageinfo().getPk_group(), fipmessagevo.getMessageinfo().getPk_billtype(), true); // ԶҪļ¼
		if (vos != null && vos.length > 0) {
			ArrayList<ProcessConfigVO> list = new ArrayList<ProcessConfigVO>();
			for (int i = 0; i < vos.length; i++) {
				ConfigVO configVO = vos[i];
				BilltypeVO billType = PfDataCache.getBillType(new BillTypeCacheKey().buildBilltype(configVO.getSrc_billtype()).buildPkGroup(fipmessagevo.getMessageinfo().getPk_group()));
				if (billType == null)
					continue;
				//ͨXMLעɵĿ굥ֻ֧ƾ֤
				if("FIP".equalsIgnoreCase(billType.getSystemcode()) && !"TX01".equalsIgnoreCase(billType.getPk_billtypecode()) 
						&& !"C0".equalsIgnoreCase(configVO.getDes_billtype()) && !"RA00".equalsIgnoreCase(configVO.getDes_billtype())){
					continue;
				}
				ProcessConfigVO processConfigVO = new ProcessConfigVO();
				processConfigVO.setGeneratemode(configVO.getGeneratemode());
				processConfigVO.setIssum(configVO.getIssum() == null ? false : configVO.getIssum().booleanValue());
				processConfigVO.setGenerateflag(false);
				UFBoolean isaccount = billType.getIsaccount();// Ƿͻƽ̨
				if (isaccount != null && isaccount.booleanValue()) {
					if (configVO.getLeachformula() == null || configVO.getLeachformula().trim().length() == 0) {
						processConfigVO.setGenerateflag(configVO.getGenerateflag() == null ? false : configVO.getGenerateflag() == 1);
					} else {
						// ҪжϹʽֵ
						boolean gf = configVO.getGenerateflag() == null ? false : configVO.getGenerateflag() == 1;
						Object billvo = fipmessagevo.getBillVO();
						int loopcount = 1;
						int rowcount = FipBillVOAdapter.getChildCount(billvo);
						loopcount = rowcount > 0 ? rowcount : 1;
						for (int j = 0; j < loopcount; j++) {
							Object o = FipFormulaParser.getInstance().getParseValue(null, null, configVO.getLeachformula(), billvo, null, j);
							if (o != null) {
								if (UFBoolean.valueOf(o.toString()).booleanValue()) {
									processConfigVO.setGenerateflag(true);
									break;
								}
							}
						}
						if (!gf) {
							processConfigVO.setGenerateflag(!processConfigVO.isGenerateflag());
						}
					}
				}
				processConfigVO.setPk_group(configVO.getPk_group());
				processConfigVO.setSrc_billtype(configVO.getSrc_billtype());
				processConfigVO.setDes_billtype(configVO.getDes_billtype());
				processConfigVO.setPk_system(billType.getSystemcode());
				processConfigVO.setModulecode(processConfigVO.getPk_system());
				list.add(processConfigVO);
			}
			if (!list.isEmpty()) {
				processedvos = new ProcessConfigVO[list.size()];
				list.toArray(processedvos);
			}
		} else {
			Logger.debug("ƽ̨ûйڸõ͵ľã޷ͨƽ̨εεݣƽ̨ƽ̨ãͣ" + fipmessagevo.getMessageinfo().getPk_billtype());
		}
		return processedvos;
	}

	/**
	 * ɾϢ
	 * 
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param fipmessagevo
	 * @throws BusinessException
	 * @see
	 * @since V6.0
	 */
	private ArrayList<FipMsgResultVO> deleteMessageArray(ArrayList<FipMessageVO> fipmessagevo) throws BusinessException {
		HashMap<String, List<FipMessageVO>> billmap = new HashMap<String, List<FipMessageVO>>();
		ArrayList<FipMsgResultVO> rs = null;
		// ֵͽɾ
		for (FipMessageVO fipMessageVO2 : fipmessagevo) {
			String pkBilltype = fipMessageVO2.getMessageinfo().getPk_billtype();
			List<FipMessageVO> list = billmap.get(pkBilltype);
			if (list == null) {
				list = new ArrayList<FipMessageVO>();
				billmap.put(pkBilltype, list);
			}
			list.add(fipMessageVO2);
		}
		Set<Entry<String, List<FipMessageVO>>> entrySet = billmap.entrySet();
		for (Entry<String, List<FipMessageVO>> entry : entrySet) {
			deleteMessagePerType(entry.getKey(), entry.getValue());
		}
		return rs;
	}
	
	/**
	 * ѯʱϢ
	 * @throws BusinessException 
	 */
	public List<OperatingLogVO> batchQueryByRelationIds(String billtype, List<String> idlist) throws BusinessException {
		List<OperatingLogVO> logvoList = new ArrayList<OperatingLogVO>();
		int size = idlist.size();
		if (size == 0) {
			return null;
		}
		// ΪUAPÿֻܶ10¼Խз
		int loopstep = 5000;
		int loopcount = (size - 1) / loopstep + 1;
		for (int i = 0; i < loopcount; i++) {
			int fromIndex = i * loopstep;
			int toIndex = (i == loopcount - 1 ? size : (fromIndex + loopstep));
			List<String> subList = idlist.subList(fromIndex, toIndex);// ҪעtoIndexָǽֹλãλòtoIndexԼҲ˵0-499toIndexҪ500
			String wherepart = OperatingLogVO.SRC_BILLTYPE + "='" + billtype + "' and " + SqlTools.getInStr(OperatingLogVO.SRC_RELATIONID, subList, true);
			//ѯݶӦʱϢ
			List<OperatingLogVO> logvos = querySumRelations(wherepart);
			//ϢѯʱϢ
			OperatingLogVO[] oplogs = new FipOperatingLogProxy().queryByWhere(wherepart);
			if (logvos != null && logvos.size() > 0) {
				logvoList.addAll(logvos);
			}
			if (oplogs != null && oplogs.length > 0) {
				logvoList.addAll(Arrays.asList(oplogs));
			}
		}
		return logvoList;
	}
	
	/**
	 * ѯ
	 * @throws BusinessException 
	 */
	public List<OperatingLogVO> querySumRelations(String wherepart) throws BusinessException {
		List<OperatingLogVO> logvos = new ArrayList<OperatingLogVO>();
		SumRelationVO[] sumvos = new FipSumRelationProxy().queryByWhere(wherepart);
		if (sumvos != null && sumvos.length > 0) {
			// ѾܵϢgroupidǹϵsrc_relationid
			HashMap<String, List<String>> groupmap = new HashMap<String, List<String>>();
			String[] pks = new String[sumvos.length];
			for (int i = 0; i < sumvos.length; i++) {
				SumRelationVO sumRelationVO = sumvos[i];
				pks[i] = sumRelationVO.getPrimaryKey();
				String groupid = sumRelationVO.getGroupid();
				if (groupid != null) {
					List<String> list = groupmap.get(sumRelationVO.getSrc_billtype());
					if (list == null) {
						list = new ArrayList<String>();
						groupmap.put(sumRelationVO.getSrc_billtype(), list);
					}
					list.add(groupid);
				}
			}
			IOperatingLog ip = new FipOperatingLogProxy();
			Set<String> keySet = groupmap.keySet();
			for (String billtype : keySet) {
				List<String> list = groupmap.get(billtype);
				String wheresql = OperatingLogVO.SRC_BILLTYPE + "='" + billtype + "' and " + SqlTools.getInStr(OperatingLogVO.SRC_RELATIONID, list, true);
				OperatingLogVO[] vos1 = ip.queryByWhere(wheresql);
				if (vos1 != null) {
					logvos.addAll(Arrays.asList(vos1));
				}
			}
		}
		return logvos;
	}
	
	/**
	 * ɻƽ̨Ϣ
	 * 
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param fipmessagevo
	 * @param logvos
	 * @param isSum
	 * @return
	 * @throws BusinessException
	 */
	public FipMsgResultVO[] addMessageArray_microservice(ArrayList<FipMessageVO> fipmessagevo, OperatingLogVO[] logvos) {
		FipMsgResultVO[] rs = null;
		List<FipMsgResultVO> list = null;
		try {
			//ƽ̨Ϣ
			list = addMessageArray(fipmessagevo, logvos);
		} catch (Exception e) {
			//жǷǱصó,Ϊطô,ֱ׳쳣
			String scene = FipSceneUtil.getGenerateScene();
			if(!OperatinglogSceneEnum.GENERATE_CONFIRM_DEFAULT.equals(scene)){
				throw new RuntimeException(e.getMessage(), e);
			}
			Logger.debug("#FIP DEBUG#" + "ƽ̨Ϣʧ" + e.getMessage());
			String errMsg = "####" + nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0702") + "######" + e.getMessage() == null ? (e.getCause() == null ? "" : e.getCause().getMessage()) : e.getMessage();
			//ʼϢ
			List<String> pks = new ArrayList<String>();
			//sagasκ,쳣ͬʱ¼ƾ֤Ϣsagas_business_log
			String sagas_business_batch_no = SagasUtil.generateUID();
			//³ʼϢ״̬ΪFLAG_init_error
			if(logvos != null && logvos.length > 0) {
				for(OperatingLogVO logvo : logvos) {
					if(logvo != null) {
						pks.add(logvo.getSrc_relationid());
						logvo.setOperateflag(OperatingFlagEmu.FLAG_init_error);
						logvo.setOpmessage(errMsg);
						logvo.setBatchno(sagas_business_batch_no);
					}
				}
			}
			try {
				//Ϣ״̬ΪϢʧ
				NCLocator.getInstance().lookup(IOperatingLog.class).update_RequiresNew(logvos);
				//Ϣ
				Map<String, Object> errMap = new HashMap<String, Object>();
				errMap.put("pks",pks);
				errMap.put("scene", OperatinglogSceneEnum.GENERATE_FORWARD);
				errMap.put("errMsg", errMsg);
				errMap.put("msg", errMsg);
				errMap.put("sagas_business_batch_no", sagas_business_batch_no);
				//ϢĲwebsocketϢ
				SagasUtil.saveAndPushErrorMsg(errMap);
			} catch (Exception e1) {
				Logger.error(e1.getMessage(), e1);
			}
		}	
		if (list != null && !list.isEmpty()) {
			rs = new FipMsgResultVO[list.size()];
			list.toArray(rs);
		}
		return rs;
	}

	/**
	 * ɾϢ
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param billtypecode
	 * @param list
	 * @throws BusinessException
	 * @see
	 * @since V6.0
	 */
	private void deleteMessagePerType(String billtypecode, List<FipMessageVO> list) throws BusinessException {
		// Ϊ60һĵЧһЧֶ֧ЧԷЧҲһΣЧͬʱɾɹĿ굥
		if (list == null || list.isEmpty())
			return;
		ArrayList<String> idlist = new ArrayList<String>();
		for (FipMessageVO fipMessageVO2 : list) {
			FipRelationInfoVO vo = fipMessageVO2.getMessageinfo();
			if (!idlist.contains(vo.getRelationID()))
				idlist.add(vo.getRelationID());
		}
		int size = idlist.size();
		if (size == 0)
			return;
		// ΪUAPÿֻܶ10¼Խз
		int loopstep = 5000;
		int loopcount = (size - 1) / loopstep + 1;
		for (int i = 0; i < loopcount; i++) {
			int fromIndex = i * loopstep;
			int toIndex = (i == loopcount - 1 ? size : (fromIndex + loopstep));
			List<String> subList = idlist.subList(fromIndex, toIndex);// ҪעtoIndexָǽֹλãλòtoIndexԼҲ˵0-499toIndexҪ500
			String wherepart = OperatingLogVO.SRC_BILLTYPE + "='" + billtypecode + "' and " + SqlTools.getInStr(OperatingLogVO.SRC_RELATIONID, subList, true);
			deleteSumRelationByCon(wherepart);
			deleteOperatinglogByCon(wherepart);
			deleteRelationByCon(wherepart);
		}
	}

	private void deleteSumRelationByCon(String con) throws BusinessException {
		IFipSumRelation ip2 = new FipSumRelationProxy();
		SumRelationVO[] sumvos = ip2.queryByWhere(con);
		if (sumvos != null) {
			ip2.delete(sumvos);
		}
	}

	private void deleteOperatinglogByCon(String con) throws BusinessException {
		IOperatingLog ip = new FipOperatingLogProxy();
		OperatingLogVO[] oplogs = ip.queryByWhere(con);
		if (oplogs != null) {
			ip.delete(oplogs);
		}
	}

	private void deleteRelationByCon(String con) throws BusinessException {
		IFipRelation ip1 = new FipRelationProxy();
		FipRelationVO[] relations = ip1.queryByWhere(con);
		if (relations != null) {
			ip1.deleteReal(relations);
		}
	}

	/**
	 * Ϣ
	 * 
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param fipmessagevo
	 * @param logvos
	 * @throws BusinessException
	 * @see
	 * @since V6.0
	 */
	@SuppressWarnings("unchecked")
	private List<FipMsgResultVO> addMessageArray(List<FipMessageVO> fipmessagevo, OperatingLogVO[] logvos) throws BusinessException {
		ArrayList<FipMsgResultVO> rs = new ArrayList<FipMsgResultVO>();
		// һνյϢ࣬ȫתĻܺľڴԴԵϢ500
		int size = fipmessagevo.size();
		int loopstep = 500;
		int loopcount = (size - 1) / loopstep + 1;
		boolean isMerged = NCCEnv.isMerged();
		if (!isMerged) {
			//¼ƽ̨úõĽ
			List<Map<String,Object>> extRelations = new ArrayList<Map<String,Object>>();
			//ƽ̨ú
			for (int i = 0; i < loopcount; i++) {
				int fromIndex = i * loopstep;
				int toIndex = i == loopcount - 1 ? size : fromIndex + loopstep;
				List<FipMessageVO> subList = fipmessagevo.subList(fromIndex, toIndex);// ҪעtoIndexָǽֹλãλòtoIndexԼҲ˵0-499toIndexҪ500
				Map<String,Object> relationmap = new HashMap<String,Object>();
				// check billvo
				complementBillVO(subList);
				//ƽ̨ú,¼ؽ
				relationmap.put("fipmessagelist", subList);
				relationmap.put("processResult", processConfigAndOrgRule(subList, null));
				extRelations.add(relationmap);
			}
			//Դͷ
			Map<String, List<FipRelationInfoVO>> map = new HashMap<String,List<FipRelationInfoVO>>();
			Set<String> messageSet = new HashSet<String>();//ݵƽ̨Ϣ
			Set<String> processSet = new HashSet<String>();//ƽ̨ù˺Ϣ
			Set<String> difference = new HashSet<String>();//Set
			//ƽ̨úõ,ڷתģƾ֤
			for (Map<String,Object> processmap : extRelations) {
				//ɾƽ̨ΪɵĳʼϢ BEGIN
				List<FipMessageVO> messageList = (List<FipMessageVO>)processmap.get("fipmessagelist");
				List<List<FipExtRelationVO>> processResult = (List<List<FipExtRelationVO>>)processmap.get("processResult");
				if (!isMerged) {
					if(messageList != null && messageList.size() > 0){
						for(FipMessageVO messageVO : messageList){
							String relationid = messageVO.getMessageinfo().getRelationID();
							messageSet.add(relationid);
						}
					}
					if(processResult != null && processResult.size() > 0){
						for(List<FipExtRelationVO> list : processResult){
							if (list != null && list.size() > 0) {
								FipExtRelationVO relationvo = list.get(0);
								if(relationvo != null){
									processSet.add(relationvo.getSrcRelation().getRelationID());
								}
							}
						}
					}
				}
				//ɾƽ̨ΪɵĳʼϢ END
				List<FipMsgResultVO> resultList = addMessageAndDesBill(processResult, messageList);
				if (resultList != null && resultList.size() > 0) {
					//resultList
					if (resultList.get(0) != null && resultList.get(0).getRelations() != null && resultList.get(0).getRelations().size() > 0) {
						for (FipBasicRelationVO relationVo : resultList.get(0).getRelations()) {
							if (relationVo != null && relationVo.getSrcRelation() != null) {
								String key = "" + relationVo.getSrcRelation().getPk_billtype() + relationVo.getDesRelation().getPk_billtype() + relationVo.getDesRelation().getPk_org();
								List<FipRelationInfoVO> infos = map.get(key);
								if (infos == null) {
									infos = new ArrayList<FipRelationInfoVO>();
									map.put(key, infos);
								}
								infos.add(relationVo.getSrcRelation());
							}
						}
					}
				}
				rs.addAll(resultList);
			}
			//ɾƽ̨ΪɵĳʼϢ BEGIN
			if (!isMerged) {
				if(messageSet != null && messageSet.size() > 0){
					difference.addAll(messageSet);
					if(processSet != null && processSet.size() > 0){
						difference.removeAll(processSet);
					}
					if(difference != null && difference.size() > 0){
						List<String> temp = new ArrayList<String>();
						temp.addAll(difference);
						//ɾʼϢ
						new FipMessageBO().deleteByRelationIds(temp);
					}
				}
			}
			//ɾƽ̨ΪɵĳʼϢ END
			if (map.size() > 0) {
				//ݰԴ,Ŀ굥,Ŀ˲,ֱƾ֤
				for (List<FipRelationInfoVO> vos : map.values()) {
					if (vos != null) {
						//ǰԴ,Ŀ굥,Ŀ˲ƾ֤,ǰֺ,ֱӷ
						List<FipRelationInfoVO[]> relations = new ArrayList<FipRelationInfoVO[]>();
						relations.add(vos.toArray(new FipRelationInfoVO[0]));
						//߼תǰͬѯε,ܻʧ,ʧ򲶻쳣,쳣ϢµʼϢ
						try {
							//תĻƾ֤
							NCLocator.getInstance().lookup(IFipBillProcessService.class).generateSumBills(relations.toArray(new FipRelationInfoVO[map.size()][]));
						} catch (Exception e) {
							String errMsg = "####" + nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0702") + "######" + e.getMessage() == null ? (e.getCause() == null ? "" : e.getCause().getMessage()) : e.getMessage();
							//Դ Դϵkeyļ
							Set<String> keys = new HashSet<String>();
							for (FipRelationInfoVO relationvo : vos) {
								keys.add(relationvo.getPk_billtype() + relationvo.getRelationID());
							}
							//Ҫ쳣ϢϢ
							List<OperatingLogVO> updatevos = new ArrayList<OperatingLogVO>();
							for (OperatingLogVO logvo : logvos) {
								if (logvo != null) {
									if (keys.contains(logvo.getSrc_billtype() + logvo.getSrc_relationid())) {
										updatevos.add(logvo);
									}
								}
							}
							//ʼϢ
							List<String> pks = new ArrayList<String>();
							//sagasκ,쳣ͬʱ¼ƾ֤Ϣsagas_business_log
							String sagas_business_batch_no = SagasUtil.generateUID();
							//³ʼϢ״̬ΪFLAG_init_error
							if(updatevos != null && updatevos.size() > 0) {
								for(OperatingLogVO logvo : updatevos) {
									if(logvo != null) {
										pks.add(logvo.getSrc_relationid());
										logvo.setOperateflag(OperatingFlagEmu.FLAG_init_error);
										logvo.setOpmessage(errMsg);
										logvo.setBatchno(sagas_business_batch_no);
									}
								}
							}
							//Ϣ״̬ΪϢʧ
							NCLocator.getInstance().lookup(IOperatingLog.class).update_RequiresNew(updatevos.toArray(new OperatingLogVO[0]));
							Map<String, Object> errMap = new HashMap<String, Object>();
							errMap.put("pks", pks);
							errMap.put("scene", OperatinglogSceneEnum.GENERATE_FORWARD);
							errMap.put("errMsg", errMsg);
							errMap.put("msg", errMsg);
							errMap.put("sagas_business_batch_no", sagas_business_batch_no);
							//ϢĲwebsocketϢ
							SagasUtil.saveAndPushErrorMsg(errMap);
							
						}
					}
				}
			}
		} else {
			for (int i = 0; i < loopcount; i++) {
				int fromIndex = i * loopstep;
				int toIndex = i == loopcount - 1 ? size : fromIndex + loopstep;
				List<FipMessageVO> subList = fipmessagevo.subList(fromIndex, toIndex);// ҪעtoIndexָǽֹλãλòtoIndexԼҲ˵0-499toIndexҪ500
				rs.addAll(addMessageOneStep(subList));
			}
		}
		return rs;
	}

	/**
	 * СϢҪֹڴ
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param fipmessagelist
	 * @return
	 * @throws BusinessException
	 * @see
	 * @since V6.0
	 */
	private List<FipMsgResultVO> addMessageOneStep(List<FipMessageVO> fipmessagelist) throws BusinessException {
		// check billvo
		complementBillVO(fipmessagelist);
		return addMessageAndDesBill(processConfigAndOrgRule(fipmessagelist, null), fipmessagelist);
	}

	/**
	 * ƽ̨ú
	 * 
	 * @param fipmessagelist
	 * @param desinfos
	 * @return
	 * @throws BusinessException
	 */
	public List<List<FipExtRelationVO>> processConfigAndOrgRule(List<FipMessageVO> fipmessagelist, FipRelationInfoVO[] desinfos) throws BusinessException {
		List<List<FipExtRelationVO>> msgrelationlist = new ArrayList<List<FipExtRelationVO>>();
		// ƽ̨ú
		for (FipMessageVO fipmessagevo : fipmessagelist) {
			// ͨƽ̨ãݣ//ʽȷݵϵͳ/λ/ɱ
			List<FipExtRelationVO> list = new ArrayList<FipExtRelationVO>();
			ProcessConfigVO[] vos = processByConfig(fipmessagevo);
			if (vos != null) {
				ArrayList<ProcessConfigVO> vec = new ArrayList<ProcessConfigVO>();
				Set<String> desset = null;
				if (desinfos != null) {
					desset = new HashSet<String>();
					for (FipRelationInfoVO desinfo : desinfos) {
						desset.add(desinfo.getPk_billtype());
					}
				}
				for (int i = 0; i < vos.length; i++) {
					// ʽɡ ֱɣ
					if (!vos[i].isGenerateflag())
						continue;
					if (vos[i].getGeneratemode() == 1)
						continue;
					if (desset == null || desset.contains(vos[i].getDes_billtype()))
						vec.add(vos[i]);
				}
				if (!vec.isEmpty()) {
					// ֱɵĵݣ
					for (ProcessConfigVO processConfigVO : vec) {
						FipExtRelationVO[] dmvs = null;
						{
							// 
							long s_time = System.currentTimeMillis();
							dmvs = MessageProcessCenter.processMessage(fipmessagevo, processConfigVO, "fip", "nc.itf.fip.messageprocess.DefaultMessageProcessor");
							long e_time = System.currentTimeMillis();
							Logger.debug("#FIP DEBUG#" + "ʱ" + (e_time - s_time));
						}
						{
							if (dmvs != null && dmvs.length > 0) {
								for (int i = 0; i < dmvs.length; i++) {
									if (dmvs[i] == null)
										continue;
									list.add(dmvs[i]);
								}
							} else {
								throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0046")/* @res "ƽ̨Ŀ굥ݣûЧĿ֯" */+ "[" + nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017pub_0", "01017pub-2-0002")/* @res "Դݱ" */+ ":" + processConfigVO.getSrc_billtype() + "->"
										+ nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017pub_0", "01017pub-2-0003")/* @res "Ŀ굥ݱ" */+ ":" + processConfigVO.getDes_billtype() + "]");
								// throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0046")/* @res "ƽ̨Ŀ굥ݣûЧĿ֯" */+ processConfigVO.getSrc_billtype() + "->" + processConfigVO.getDes_billtype());
							}
						}
					}
				}
			}
			msgrelationlist.add(list);
		}
		return msgrelationlist;
	}

	private void complementBillVO(List<FipMessageVO> fipmessagelist) throws BusinessException {
		// find incomplete data
		List<FipMessageVO> list = new ArrayList<FipMessageVO>();
		for (FipMessageVO fipmessagevo : fipmessagelist) {
			if (fipmessagevo.getBillVO() == null)
				list.add(fipmessagevo);
		}
		if (!list.isEmpty()) {
			// complete incomplete data
			// group by pk_group and pk_billtype
			HashMap<String, List<FipMessageVO>> map = new HashMap<String, List<FipMessageVO>>();
			for (FipMessageVO fipMessageVO : list) {
				FipRelationInfoVO messageinfo = fipMessageVO.getMessageinfo();
				String key = "" + messageinfo.getPk_group() + messageinfo.getPk_billtype();
				List<FipMessageVO> list2 = map.get(key);
				if (list2 == null) {
					list2 = new ArrayList<FipMessageVO>();
					map.put(key, list2);
				}
				list2.add(fipMessageVO);
			}
			if (!map.isEmpty()) {
				Collection<List<FipMessageVO>> values = map.values();
				// complete each pk_group and pk_billtype
				for (List<FipMessageVO> list2 : values) {
					if (list2 == null || list2.isEmpty())
						continue;
					FipMessageVO firstelement = list2.get(0);
					String src_group = firstelement.getMessageinfo().getPk_group();
					String src_billtype = firstelement.getMessageinfo().getPk_billtype();
					List<FipRelationInfoVO> infolist = new ArrayList<FipRelationInfoVO>();
					for (FipMessageVO fipMessageVO : list2) {
						infolist.add(fipMessageVO.getMessageinfo());
					}
					Collection<FipExtendAggVO> queryBillByRelations = null;
					//УǷ΢,岿߼ֿ
					boolean isMerged = NCCEnv.isMerged();
					if(!isMerged){
						//ȡηӿ
						IFipInterfaceCenterService destService = SagasUtil.getFipInterfaceCenterService(src_billtype);
						Map<String,Serializable> params = new HashMap<String,Serializable>();
						params.put("pk_group", src_group);
						params.put("billtype", src_billtype);
						queryBillByRelations = destService.queryBillByRelations(params, infolist);
					} else {
						IBillReflectorService ib = FipInterfaceCenter.getBillReflectorService(src_group, src_billtype);
						if (ib == null)
							throw new BusinessException(FipInterfaceCenter.getNoInterfaceFoundMessage(src_billtype, "IBillReflectorService"));
						queryBillByRelations = ib.queryBillByRelations(infolist);
					}
					if (queryBillByRelations != null) {
						HashMap<String, FipExtendAggVO> map1 = new HashMap<String, FipExtendAggVO>();
						for (FipExtendAggVO fipExtendAggVO : queryBillByRelations) {
							map1.put(fipExtendAggVO.getRelationID(), fipExtendAggVO);
						}
						for (FipMessageVO fipMessageVO : list2) {
							FipExtendAggVO fipExtendAggVO = map1.get(fipMessageVO.getMessageinfo().getRelationID());
							if (fipExtendAggVO != null) {
								fipMessageVO.setBillVO(fipExtendAggVO.getBillVO());
								if (fipExtendAggVO.getMessageinfo() != null)
									fipMessageVO.setMessageinfo(fipExtendAggVO.getMessageinfo());
							}
						}
					}
				}
			}
		}
	}

	/**
	 * ˵
	 * <p>
	 * ޸ļ¼
	 * </p>
	 * 
	 * @param msgrelationlist
	 *            ÿϢ
	 * @param fipmessagelist
	 *            Ϣ
	 * @return
	 * @throws BusinessException
	 * @see
	 * @since V6.0
	 */
	private List<FipMsgResultVO> addMessageAndDesBill(List<List<FipExtRelationVO>> msgrelationlist, List<FipMessageVO> fipmessagelist) throws BusinessException {
		List<FipMsgResultVO> rs = new ArrayList<FipMsgResultVO>();
		ArrayList<SumRelationVO> sumlist = new ArrayList<SumRelationVO>();// ɵ
		List<FipTransVO> translist = new ArrayList<FipTransVO>();// Ҫ
		List<FipTransVO> errlist = new ArrayList<FipTransVO>();// ת̳
		List<FipTransVO> effectlist = new ArrayList<FipTransVO>();// ʧӰҵ̵
		List<FipTransVO> uneffectlist = new ArrayList<FipTransVO>();// ʧܲӰҵ̵
		FipMsgResultVO resultVO = new FipMsgResultVO();
		Vector<FipBasicRelationVO> relationInfos = new Vector<FipBasicRelationVO>();// ΢,ɴݲ
		int size = msgrelationlist.size();
		/*УǷ΢,岿߼ֿ*/
		boolean isMerged = NCCEnv.isMerged();
		//Ϣ,ģδõĴʹ
		String errMSG = "";
		// ϢòתĿ굥
		for (int i = 0; i < size; i++) {
			List<FipExtRelationVO> list = msgrelationlist.get(i);
			FipMessageVO fipMessageVO = fipmessagelist.get(i);
			if (list == null || list.isEmpty())
				continue;
			for (FipExtRelationVO fipExtRelationVO : list) {
				if (fipExtRelationVO.getIssum() != null && fipExtRelationVO.getIssum().booleanValue()) {
					// ɵ
					sumlist.add(fipExtRelationVO.convertToSumRelationVO());
					//΢񳡾,ػ
					if(!isMerged){
						relationInfos.add(fipExtRelationVO);
					}
				} else {
					// Ҫĵ
					FipTransVO transvo = new FipTransVO();
					transvo.setDatavo(fipMessageVO.getBillVO());
					transvo.setMessagevo(fipExtRelationVO);
					translist.add(transvo);
				}
			}
		}
		if(relationInfos != null && relationInfos.size() > 0){
			resultVO.setRelations(relationInfos);
			rs.add(resultVO);
		}
		List<String> messageList = new ArrayList<String>();//ҪɾĳʼϢ
		List<OperatingLogVO> oplist = new ArrayList<OperatingLogVO>();// ¼ʱ
		if (!translist.isEmpty()) {
			List<FipTransVO> transrslist = new ArrayList<FipTransVO>();
			for (FipTransVO transvo : translist) {
				List<FipTransVO> rslist = null;
				if(!isMerged){
					try{
						rslist = BOTranslateCenter.translate(transvo);
					} catch (Exception e) {
						FipTransVO rsvo = new FipTransVO();
						rsvo.setMessagevo(transvo.getMessagevo());
						String errCode = "";						
						if (e instanceof BusinessException) {
							errCode = ((BusinessException) e).getErrorCodeString();
						}
						if ("999".equals(errCode)) {
							errMSG = e.getMessage();
						} 
						rsvo.getMessagevo().setOpmessage(e.getMessage());
						rsvo.setDatavo(null);
						rsvo.setIsAutoConfirm(UFBoolean.FALSE);
						if (rslist == null) {
							rslist = new ArrayList<FipTransVO>();
						}
						rslist.add(rsvo);
						messageList.add(transvo.getMessagevo().getSrcRelation().getRelationID());
					}
					if(rslist == null || rslist.isEmpty()){
						messageList.add(transvo.getMessagevo().getSrcRelation().getRelationID());
					}
				} else {
					rslist = BOTranslateCenter.translate(transvo);
				}
				if (rslist == null || rslist.isEmpty()) {
					// ƾ֤ģΪʱɣɵʱ򣬲תĽ
					// ûƾ֤ƽ̨õǶʱɻɣᵼƾ֤
					OperatingLogVO vo = null;
					for (FipTransVO fipTransVO : effectlist) {
						vo = fipTransVO.getMessagevo().convertToOperatingLogVO();
						vo.setOpmessage("ƽ̨ûƾ֤");
						vo.setOperateflag(OperatingFlagEmu.FLAG_no_process);
						oplist.add(vo);
					}
					continue;
				}
				for (FipTransVO fipTransVO : rslist) {
					transrslist.add(fipTransVO);
				}
			}
			//ɾʼϢƾ֤תʧܣʱ
			if(!isMerged){
				if(messageList.size() > 0){
					deleteByRelationIds(messageList);
				}
			}
			for (FipTransVO rsvo : transrslist) {
				// תɹģϢΪ
				if (rsvo.getMessagevo().getOpmessage() == null) {
					if (rsvo.getIsEffect() != null && rsvo.getIsEffect().booleanValue()) {
						// Ӱҵ
						effectlist.add(rsvo);
					} else {
						uneffectlist.add(rsvo);
					}
				} else {
					errlist.add(rsvo);
				}
			}
		}


		List<FipRelationVO> relist = new ArrayList<FipRelationVO>();// ¼ʽ
		if(!isMerged){
			//Ӱ̻ǲӰ̣Ҫƽ̨Ϣ
			String gtxid = NCCSagas.getGtxid();//ȫid
			String ltxid = NCCSagas.getTxid(); //id
			if (!effectlist.isEmpty()) {
				try{
					new FipMessageImpl().saveDesBill_RequiresNew(effectlist,UFBoolean.valueOf(true),null);
				} catch (Exception e){
					String errMsg = "####" + nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0702") + "######" + e.getMessage() == null ? (e.getCause() == null ? "" : e.getCause().getMessage()) : e.getMessage();
					Logger.error(errMsg, e);
					OperatingLogVO vo = null;
					for (FipTransVO fipTransVO : effectlist) {
						vo = fipTransVO.getMessagevo().convertToOperatingLogVO();
						vo.setOpmessage(errMsg);
						vo.setOperateflag(OperatingFlagEmu.FLAG_no_process);
						vo.setSaga_gtxid(gtxid);
						vo.setSaga_btxid(ltxid);
						oplist.add(vo);
					}
				}
			}
			if (!errlist.isEmpty()) {
				// ת̳
				for (FipTransVO fipTransVO : errlist) {
					OperatingLogVO vo = fipTransVO.getMessagevo().convertToOperatingLogVO();
					vo.setOperateflag(OperatingFlagEmu.FLAG_no_process);
					vo.setSaga_gtxid(gtxid);
					vo.setSaga_btxid(ltxid);
					oplist.add(vo);
				}
			}
			if (!uneffectlist.isEmpty()) {
				try{
					new FipMessageImpl().saveDesBill_RequiresNew(uneffectlist,UFBoolean.valueOf(false),null);
				} catch (Exception e){
					String errMsg = "####" + nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0702") + "######" + e.getMessage() == null ? (e.getCause() == null ? "" : e.getCause().getMessage()) : e.getMessage();
					Logger.error(errMsg, e);
					OperatingLogVO vo = null;
					for (FipTransVO fipTransVO : uneffectlist) {
						vo = fipTransVO.getMessagevo().convertToOperatingLogVO();
						vo.setOpmessage(errMsg);
						vo.setOperateflag(OperatingFlagEmu.FLAG_no_process);
						vo.setSaga_gtxid(gtxid);
						vo.setSaga_btxid(ltxid);
						oplist.add(vo);
					}
				}
			}
		} else {
			if (!effectlist.isEmpty()) {
				// Ӱҵģֱӱ棬ʧ׳쳣
				List<OperatingLogVO> volist = new FipMessageImpl().saveDesBill_RequiresNew(effectlist);
				if (volist != null) {
					for (OperatingLogVO oplogvo : volist) {
						if (oplogvo.getOperateflag() != OperatingFlagEmu.FLAG_confirmed) {
							if (oplogvo.getDes_relationid() != null)
								oplist.add(oplogvo);
						} else {
							if (oplogvo.getDes_relationid() != null)
								relist.add(FipBasicRelationVO.convertFromOperatingVO(oplogvo).convertToRelationVO());
						}
					}
				}
			}
			if (!errlist.isEmpty()) {
				// ת̳
				for (FipTransVO fipTransVO : errlist) {
					OperatingLogVO vo = fipTransVO.getMessagevo().convertToOperatingLogVO();
					vo.setOperateflag(OperatingFlagEmu.FLAG_no_process);
					oplist.add(vo);
				}
			}
			if (!uneffectlist.isEmpty()) {
				// Ӱҵģÿһб棬ʧܵĻ¼Ϣ
				IFipMessage ip1 = NCLocator.getInstance().lookup(IFipMessage.class);
				for (FipTransVO fipTransVO : uneffectlist) {
					OperatingLogVO vo = null;
					try {
						List<FipTransVO> rslist = new ArrayList<FipTransVO>();
						rslist.add(fipTransVO);
						List<OperatingLogVO> volist = ip1.saveDesBill_RequiresNew(rslist);
						if (volist != null && !volist.isEmpty())
							vo = volist.get(0);
					} catch (BusinessException e) {
						Logger.error("", e);
						vo = fipTransVO.getMessagevo().convertToOperatingLogVO();
						vo.setOpmessage(e.getMessage());
						vo.setOperateflag(OperatingFlagEmu.FLAG_no_process);
					}
					if (vo == null)
						continue;
					if (vo.getOperateflag() != OperatingFlagEmu.FLAG_confirmed) {
						if (vo.getDes_relationid() != null)
							oplist.add(vo);
					} else {
						if (vo.getDes_relationid() != null)
							relist.add(FipBasicRelationVO.convertFromOperatingVO(vo).convertToRelationVO());
					}
				}
			}
		}
		if (!sumlist.isEmpty()) {
			FipSumRelationProxy ip = new FipSumRelationProxy();
			ip.insert(sumlist.toArray(new SumRelationVO[0]));
		}
		if (!oplist.isEmpty()) {
			FipOperatingLogProxy ip = new FipOperatingLogProxy();
			if(!isMerged){
				//sagasκ,쳣ͬʱ¼ƾ֤Ϣsagas_business_log
				String sagas_business_batch_no = SagasUtil.generateUID();
				for(OperatingLogVO logvo : oplist){
					if(logvo != null){
						logvo.setBatchno(sagas_business_batch_no);
					}
				}
				OperatingLogVO[] oplogs = ip.insert(oplist.toArray(new OperatingLogVO[0]));
				List<String> src_relationids = new ArrayList<String>();//Դrelationid
				for(OperatingLogVO oplog : oplogs){
					src_relationids.add(oplog.getSrc_relationid());
				}
				//ɾʼϢ
				this.deleteByRelationIds(src_relationids);
				//΢񳡾,Ҫתݱ浽,websocketϢǰ
				Map<String, Object> errMap = new HashMap<String, Object>();
				errMap.put("pks", src_relationids);
				errMap.put("scene", OperatinglogSceneEnum.GENERATE_FORWARD);
				if (errMSG != null && !"".equals(errMSG)) {
					errMap.put("errMsg", errMSG);
					errMap.put("msg", errMSG);
				} else {
					errMap.put("errMsg", nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10170410", "1101704100034"));
					errMap.put("msg", nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("10170410", "1101704100034"));
				}
				
				errMap.put("sagas_business_batch_no", sagas_business_batch_no);
				//ϢĲwebsocketϢ
				SagasUtil.saveAndPushErrorMsg(errMap);
			}else{
				ip.insert(oplist.toArray(new OperatingLogVO[0]));
			}
		}
		if (!relist.isEmpty()) {
			FipRelationProxy ip = new FipRelationProxy();
			ip.insert(relist.toArray(new FipRelationVO[0]));
		}
		return rs;
	}

	public void sumSrcBill(FipBasicRelationVO[] vos) throws BusinessException {
		if (vos == null || vos.length == 0)
			return;
		String pk_group = vos[0].getDesRelation().getPk_group();
		String src_billtype = vos[0].getSrcRelation().getPk_billtype();
		FipRelationInfoVO desinfo = vos[0].getDesRelation();
		String des_billtype = desinfo.getPk_billtype();
		String des_org = desinfo.getPk_org();
		ArrayList<FipRelationInfoVO> grouplist = new ArrayList<FipRelationInfoVO>();
		for (int i = 0; i < vos.length; i++) {
			grouplist.add(vos[i].getSrcRelation());
		}
		ArrayList<Collection<FipRelationInfoVO>> sumgroup = new ArrayList<Collection<FipRelationInfoVO>>();
		sumgroup.add(grouplist);
		FipQueryBO fipQueryBO = new FipQueryBO();
		String[] usingFields = fipQueryBO.queryUsingFields(src_billtype, des_billtype, pk_group, des_org);
		String[] factors = fipQueryBO.queryTemplateBusiTypes(src_billtype, des_billtype, pk_group, des_org);
		Collection<FipBillSumRSVO> sumBills = null;
		//УǷ΢,岿߼ֿ
		boolean isMerged = NCCEnv.isMerged();
		if(!isMerged){
			//ȡηӿ
			IFipInterfaceCenterService destService = SagasUtil.getFipInterfaceCenterService(src_billtype);
			Map<String,Serializable> params = new HashMap<String,Serializable>();
			params.put("pk_group", pk_group);
			params.put("billtype", src_billtype);
			try{
				sumBills = destService.querySumBill(params, sumgroup, usingFields, UFBoolean.valueOf(factors != null));
			} catch (BusinessException ex){
				throw ex;
			} catch (Exception ex1){//ʱֳܻʱ
				throw new BusinessException(ex1);
			}
		} else {
			IBillSumService ip = FipInterfaceCenter.getBillSumService(pk_group, src_billtype);
			if (ip == null)
				throw new BusinessException(FipInterfaceCenter.getNoInterfaceFoundMessage(src_billtype, "IBillSumService"));
			sumBills = ip.querySumBill(sumgroup, usingFields, UFBoolean.valueOf(factors != null));
		}
		Map<String,Object> params = null;		
		List<FipBillSumRSVO> sumBillsList = new ArrayList<FipBillSumRSVO>();
		if (sumBills != null && !sumBills.isEmpty()) {
			ArrayList<String> groupidlist = new ArrayList<String>();
			List<FipExtRelationVO> fipRelationlist = new ArrayList<FipExtRelationVO>();
			List<FipMessageVO> fipmessagelist = new ArrayList<FipMessageVO>();
			for (FipBillSumRSVO fipBillSumRSVO : sumBills) {
				FipExtRelationVO fipRelationVO = new FipExtRelationVO();
				FipMessageVO fipmessagevo = new FipMessageVO();
				fipRelationVO.setSrcRelation(fipBillSumRSVO.getMessageinfo());
				fipRelationVO.setDesRelation((FipRelationInfoVO) desinfo.clone());
				fipRelationVO.setIssum(UFBoolean.FALSE);
				fipmessagevo.setMessageinfo(fipBillSumRSVO.getMessageinfo());
				fipmessagevo.setBillVO(fipBillSumRSVO.getBillVO());
				fipmessagevo.setMessagetype(FipMessageVO.MESSAGETYPE_ADD);
				if(!isMerged){
					fipRelationlist.add(fipRelationVO);
					fipmessagelist.add(fipmessagevo);
					FipBillSumRSVO sumvo = new FipBillSumRSVO();
					sumvo.setBillVO(null);
					sumvo.setMessageinfo(fipBillSumRSVO.getMessageinfo());
					sumvo.setRelationvos(fipBillSumRSVO.getRelationvos());
					sumBillsList.add(sumvo);
				} else {
					addMessageAndSaveBill(fipRelationVO, fipmessagevo);
					// ·
					FipRelationInfoVO[] relationvos = fipBillSumRSVO.getRelationvos();
					if (relationvos != null) {
						String relationID = fipBillSumRSVO.getMessageinfo().getRelationID();
						groupidlist.add(relationID);
						updateSumRelation(relationID, relationvos, desinfo);
					}
				}
			}
			//΢񳡾Ҫݸη
			if(!isMerged){
				params = new HashMap<String,Object>();
				params.put("sumvos", sumBillsList.size() > 0 ? sumBillsList : null);//
				params.put("desinfo", desinfo);//ĿϢ
				addMessageAndSaveBillBatch(fipRelationlist,fipmessagelist,params);
			}
		}
	}

	public void updateSumRelation(String relationID, FipRelationInfoVO[] relationvos, FipRelationInfoVO desinfo) throws BusinessException {
		BaseDAO baseDAO = new BaseDAO();
		ArrayList<String> pklist = new ArrayList<String>();
		for (int i = 0; i < relationvos.length; i++) {
			FipRelationInfoVO fipRelationInfoVO = relationvos[i];
			if (fipRelationInfoVO == null || pklist.contains(fipRelationInfoVO.getRelationID()))
				continue;
			pklist.add(fipRelationInfoVO.getRelationID());
		}
		String wherepart = SqlTools.getInStr(SumRelationVO.SRC_RELATIONID, pklist, true) + " and " + SumRelationVO.DES_BILLTYPE + "='" + desinfo.getPk_billtype() + "' and " + SumRelationVO.DES_ORG + "='" + desinfo.getPk_org() + "'";
		String sql = "update " + SumRelationVO.getDefaultTableName() + " set " + SumRelationVO.GROUPID + " ='" + relationID + "' where " + wherepart;
		int upcount = baseDAO.executeUpdate(sql);
		if (upcount != pklist.size())
			throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("1017prv_0", "01017prv-0047")/* @res "Ѿ˸£ˢݡ" */);
		sql = "update " + OperatingLogVO.getDefaultTableName() + " set " + OperatingLogVO.SUMFLAG + " ='Y' where " + OperatingLogVO.SRC_RELATIONID + "='" + relationID + "' and " + OperatingLogVO.DES_BILLTYPE + "='" + desinfo.getPk_billtype() + "' and " + OperatingLogVO.DES_ORG + "='" + desinfo.getPk_org() + "' ";
		baseDAO.executeUpdate(sql);
		sql = "update " + FipRelationVO.getDefaultTableName() + " set " + FipRelationVO.SUMFLAG + " ='Y' where " + FipRelationVO.SRC_RELATIONID + "='" + relationID + "' and " + FipRelationVO.DES_BILLTYPE + "='" + desinfo.getPk_billtype() + "' and " + FipRelationVO.DES_ORG + "='" + desinfo.getPk_org() + "' ";
		baseDAO.executeUpdate(sql);
	}
	
	public void deleteByRelationIds(List<String> src_relationids) throws BusinessException{
		if(src_relationids == null || src_relationids.size() <= 0){
			return;
		}
		IOperatingLog op = NCLocator.getInstance().lookup(IOperatingLog.class);
		String wherepart_oplog = " " + SqlTools.getInStr(OperatingLogVO.SRC_RELATIONID, src_relationids, false) + " and operateflag = " + OperatingFlagEmu.FLAG_init_running;
		OperatingLogVO[] oplogs = op.queryByWhere(wherepart_oplog);
		if(oplogs != null){
			op.deleteOplog(oplogs);
		} 
	}
}
